package INV_SINERCOM.AccesoDatos;

import java.sql.*;
import java.util.*;

public class ADCliente {

    /// <summary>
    /// Aplicación: INV_SINERCOM (INVENTARIO SINERCOM)
    /// Módulo: CLIENTE
    /// Fecha:2014/09/30 
    /// Empresa:SINERCOM
    /// HISTORIA DE CAMBIOS
    /// ----------------------------------------------------------------------
    /// FECHA         USUARIO     DESCRIPCION
    /// 2014/09/30    DRPAREDA    Creacion de Clase para manejo de Clientes
    /// ----------------------------------------------------------------------
    /// </summary>
    private static ResultSet resultado = null;

    //Carga tipos de clientes de usuarios del sistema disponibles en a base de datos
    public static ArrayList CargaTiposClientes(int TipoCliente) {

        ArrayList valorRetorno = new ArrayList();
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_CONSULTA_CATALOGO_PARAMETRIZACION(?)}");
            proc.setInt(1, TipoCliente);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno.add(resultado.getString("nombre_detalle"));
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }

        return valorRetorno;
    }

    // Inserta nuevo cliente en base de datos
    public static int RegistraCliente(int tipoCliente, int tipoHospital, String nombreCliente, String rucCliente, String direccionCliente, String telefonoCliente) {
        int valorRetorno = 0;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_REGISTRA_CLIENTE(?,?,?,?,?,?)}");
            proc.setInt(1, tipoCliente);
            proc.setInt(2, tipoHospital);
            proc.setString(3, nombreCliente);
            proc.setString(4, rucCliente);
            proc.setString(5, direccionCliente);
            proc.setString(6, telefonoCliente);
            proc.execute();
            resultado = proc.getResultSet();
            if (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    //Busca cliente en especifico en la base de datos
    public static ArrayList BuscarUsuario(int operacion,int CodigoCliente,String rucCLiente) {
        ArrayList valorRetorno = new ArrayList();
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_BUSCAR_CLIENTE(?,?,?)}");
            proc.setInt(1, operacion);
            proc.setInt(2, CodigoCliente);
            proc.setString(3, rucCLiente);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno.add(resultado.getInt("CODIGO"));
                valorRetorno.add(resultado.getString("TIPO_CLIENTE"));
                valorRetorno.add(resultado.getString("TIPO_HOSPITAL"));
                valorRetorno.add(resultado.getString("NOMBRE_CLIENTE"));
                valorRetorno.add(resultado.getString("RUC_CLIENTE"));
                valorRetorno.add(resultado.getString("DIRECCION_CLIENTE"));
                valorRetorno.add(resultado.getString("TELEFONO_CLIENTE"));
            }
            if (valorRetorno.isEmpty()) {
                valorRetorno.add(0);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }

        return valorRetorno;
    }

    // Actualiza informacion de Cliente en base de datos
    public static int ActualizarUsuario(int codigoCliente, int tipoCliente, int tipoHospital,String nombreCliente,String RucCliente, String direccionCliente, String telefonoCliente) {
        int valorRetorno = 0;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_ACTUALIZAR_CLIENTE(?,?,?,?,?,?,?)}");
            proc.setInt(1, codigoCliente);
            proc.setInt(2, tipoCliente);
            proc.setInt(3, tipoHospital);
            proc.setString(4, nombreCliente);
            proc.setString(5, RucCliente);
            proc.setString(6, direccionCliente);
            proc.setString(7, telefonoCliente);
            proc.execute();
            resultado = proc.getResultSet();
            if (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    //Elimina informacion de clientes de la base de datos
    public static int EliminarCliente(int codigoCliente, int operacion) {
        int valorRetorno = 0;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_ELIMINAR_USUARIO(?,?)}");
            proc.setInt(1, codigoCliente);
            proc.setInt(2, operacion);
            proc.execute();
            resultado = proc.getResultSet();
            if (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }
        return valorRetorno;
    }
}
