package INV_SINERCOM.AccesoDatos;

import java.sql.*;
import javax.swing.*;
import java.util.*;

public class ADEmpleado {

    /// <summary>
    /// Aplicación: INV_SINERCOM (INVENTARIO SINERCOM)
    /// Módulo: USUARIOS
    /// Fecha:2014/09/30 
    /// Empresa:SINERCOM
    /// HISTORIA DE CAMBIOS
    /// ----------------------------------------------------------------------
    /// FECHA         USUARIO     DESCRIPCION
    /// 2014/10/28    DRPAREDA    Creacion de Clase para manejo de EMPLEADOS con base de datos
    /// ----------------------------------------------------------------------
    /// </summary> 
    private static ResultSet resultado = null;

    // Inserta nuevo empleado en base de datos
    public static int RegistraEmpleado(String nombreEmpleado, String apellidoEmpleado, String cedulaEmpleado, String direccionEmpleado, String telefonoEmpleado) {
        int valorRetorno = 0;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_REGISTRA_EMPLEADO(?,?,?,?,?)}");
            proc.setString(1, nombreEmpleado);
            proc.setString(2, apellidoEmpleado);
            proc.setString(3, cedulaEmpleado);
            proc.setString(4, direccionEmpleado);
            proc.setString(5, telefonoEmpleado);
            proc.execute();
            resultado = proc.getResultSet();
            if (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    // Buscar empleado en base de datos
    public static ArrayList BuscaEmpleado(int operacion,int codigoEmpleado, String cedulaEmpleado) {
        ArrayList valorRetorno = new ArrayList();
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_BUSCAR_EMPLEADO(?,?,?)}");
            proc.setInt(1, operacion);
            proc.setLong(2, codigoEmpleado);
            proc.setString(3, cedulaEmpleado);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno.add(resultado.getInt("CODIGO"));
                valorRetorno.add(resultado.getString("NOMBRE_EMPLEADO"));
                valorRetorno.add(resultado.getString("APELLIDO_EMPLEADO"));
                valorRetorno.add(resultado.getString("CEDULA_EMPLEADO"));
                valorRetorno.add(resultado.getString("DIRECCION_EMPLEADO"));
                valorRetorno.add(resultado.getString("TELEFONO_EMPLEADO"));
            }
            if (valorRetorno.isEmpty()) {
                valorRetorno.add(0);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }

        return valorRetorno;
    }

    // Actualiza informacion de Empleado en base de datos
    public static int ActualizarEmpleado(int codigoEmpleado, String nombreEmpleado, String apellidoEmpleado, String cedulaEmpleado, String direccionEmpleado, String telefonoEmpleado) {
        int valorRetorno = 0;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_ACTUALIZAR_EMPLEADO(?,?,?,?,?,?)}");
            proc.setInt(1, codigoEmpleado);
            proc.setString(2, nombreEmpleado);
            proc.setString(3, apellidoEmpleado);
            proc.setString(4, cedulaEmpleado);
            proc.setString(5, direccionEmpleado);
            proc.setString(6, telefonoEmpleado);
            proc.execute();
            resultado = proc.getResultSet();
            if (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

     //Elimina informacion de empleado de la base de datos
    public static int EliminarEmpleado(int codigoUsuario, int operacion) {
        int valorRetorno = 0;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_ELIMINAR_USUARIO(?,?)}");
            proc.setInt(1, codigoUsuario);
            proc.setInt(2, operacion);
            proc.execute();
            resultado = proc.getResultSet();
            if (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }
        return valorRetorno;
    }
}
