package INV_SINERCOM.AccesoDatos;


import java.io.IOException;
import java.sql.*;
import java.text.DateFormat;
//import java.text.SimpleDateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.Date;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.view.JasperViewer;


public class ADPedido {
    /// <summary>
    /// Aplicación: INV_SINERCOM (INVENTARIO SINERCOM)
    /// Módulo: PEDIDOS
    /// Fecha:2014/09/30 
    /// Empresa:SINERCOM
    /// HISTORIA DE CAMBIOS
    /// ----------------------------------------------------------------------
    /// FECHA         USUARIO     DESCRIPCION
    /// 2014/09/30    DRPAREDA    Creacion de Clase para manejo de Productos
    /// ----------------------------------------------------------------------
    /// </summary> 

    private static ResultSet resultado = null;

    //Carga tipos de filtros de Pedidos disponibles en a base de datos
    public static ArrayList CargaTipoFiltrosPedido(int CodigoCatalogo) {
        ArrayList valorRetorno = new ArrayList();
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_CONSULTA_CATALOGO_PARAMETRIZACION(?)}");
            proc.setInt(1, CodigoCatalogo);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno.add(resultado.getString("nombre_detalle"));
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }

        return valorRetorno;
    }

    //Carga lista de productos em base de datos base de datos
    public static ResultSet CargarListaProductos(int operacionProducto, int tipoProducto, String codigoProducto) throws SQLException {
        resultado = null;
        ResultSet valorRetorno = null;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_CONSULTA_PRODUCTOS(?,?,?)}");
            proc.setInt(1, operacionProducto);
            proc.setInt(2, tipoProducto);
            proc.setString(3, codigoProducto);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno = resultado;
                return valorRetorno;
            }
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    //Carga Lista de Clientes
    public static ArrayList CargaListaClientes(int operacion) {
        ArrayList valorRetorno = new ArrayList();
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_CONSULTA_CLIENTE(?)}");
            proc.setInt(1, operacion);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno.add(resultado.getString(1));
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }

        return valorRetorno;
    }

    //Registra Pedido
    public static int RegistraPedido(int flagActualizacion, int operacion, int Cliente, String Paciente, String Medico, int Paquete, int CodigoPedido, String CodigoProducto, int cantidad, int numeroItems, String usuarioRegistra) {
        int valorRetorno = 0;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_REGISTRA_PEDIDO(?,?,?,?,?,?,?,?,?,?,?)}");
            proc.setInt(1, flagActualizacion);
            proc.setInt(2, operacion);
            proc.setInt(3, Cliente);
            proc.setString(4, Paciente);
            proc.setString(5, Medico);
            proc.setInt(6, Paquete);
            proc.setInt(7, CodigoPedido);
            proc.setString(8, CodigoProducto);
            proc.setInt(9, cantidad);
            proc.setInt(10, numeroItems);
            proc.setString(11, usuarioRegistra);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }

        return valorRetorno;
    }

    //Genera reporte Pedido
    public static void GeneraReportePedido(int codigoPedido) throws JRException, IOException {

        try {
            Map parametros = new HashMap();
            parametros.clear();
            parametros.put("CodigoPedido", codigoPedido);
            String archivo = ADPedido.class.getResource("ADNotaEntrega.jrxml").getPath();
            JasperReport report = JasperCompileManager.compileReport(archivo);
            JasperPrint jpPedido = JasperFillManager.fillReport(report, parametros, ADConexionMySQL.ObtenerConexion());
            JasperExportManager.exportReportToPdfFile(jpPedido, "C:\\INV_SINERCOM\\NOTA_ENTREGA\\NotaEntrega_"+codigoPedido+".pdf");
            //JasperViewer.viewReport(jpPedido, false);
        } catch (JRException ex) {
        }
    }

    //Carga lista de productos em base de datos base de datos
    public static ResultSet CargarPaqueteProductos(int codigoPaquete) throws SQLException {
        resultado = null;
        ResultSet valorRetorno = null;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_CARGA_PAQUETE_PRODUCTOS(?)}");
            proc.setInt(1, codigoPaquete);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno = resultado;
                return valorRetorno;
            }
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    //Carga lista de productos em base de datos base de datos
    public static ResultSet BuscaPedidoRecepcion(int operacion, int codigoPedido, int codigoCliente, String fechaEmision) throws SQLException {
        resultado = null;
        ResultSet valorRetorno = null;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_CONSULTA_PEDIDOS(?,?,?,?)}");
            proc.setInt(1, operacion);
            proc.setInt(2, codigoPedido);
            proc.setInt(3, codigoCliente);
            proc.setString(4, fechaEmision);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno = resultado;
                return valorRetorno;
            }
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    public static int RegistraRecepcionPedido(int operacion, int codigoPedido, String codigoProducto, int cantidadRecepcion, float codigoPorcentaje) throws SQLException {
        resultado = null;
        int valorRetorno = 1;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_REGISTRA_RECEPCION_PEDIDO(?,?,?,?,?)}");
            proc.setInt(1, operacion);
            proc.setInt(2, codigoPedido);
            proc.setString(3, codigoProducto);
            proc.setInt(4, cantidadRecepcion);
            proc.setFloat(5, codigoPorcentaje);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno = resultado.getInt(1);
            }
            ADConexionMySQL.Desconectar();
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    //Carga lista de productos em base de datos base de datos
    public static ResultSet CargarReportePedidos(int operacion, int cliente, String fechaInicio, String fechaFin, String estadoPedido) throws SQLException {
        resultado = null;
        ResultSet valorRetorno = null;
        try {
            CallableStatement proc = ADConexionMySQL.ObtenerConexion().prepareCall("{call PRO_GENERA_REPORTES(?,?,?,?,?)}");
            proc.setInt(1, operacion);
            proc.setInt(2, cliente);
            proc.setString(3, fechaInicio);
            proc.setString(4, fechaFin);
            proc.setString(5, estadoPedido);
            proc.execute();
            resultado = proc.getResultSet();
            while (resultado.next()) {
                valorRetorno = resultado;
                return valorRetorno;
            }
        } catch (SQLException e) {
        }
        return valorRetorno;
    }

    //Genera reporte Pedido
    public static void GeneraReportesPedidos(int operacionE, int clienteE, String fechaInicioE, String fechaFinE, String estadoPedido) throws JRException, IOException {

        try {
            Map parametros = new HashMap();
            parametros.clear();
            parametros.put("operacion", operacionE);
            parametros.put("cliente", clienteE);
            parametros.put("fechaInicio", fechaInicioE);
            parametros.put("fechaFin", fechaFinE);
            parametros.put("estadoPedido", estadoPedido);
            String archivo = ADPedido.class.getResource("ADReportePedido.jrxml").getPath();
            JasperReport report = JasperCompileManager.compileReport(archivo);
            JasperPrint jpPedido = JasperFillManager.fillReport(report, parametros, ADConexionMySQL.ObtenerConexion());
            DateFormat dateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
            Date fechaActual=new java.util.Date();
            String fecha=dateFormat.format(fechaActual);
            JasperExportManager.exportReportToPdfFile(jpPedido, "C:\\INV_SINERCOM\\REPORTE_PEDIDOS\\ReportePedido_"+fecha+".pdf");
            //JasperViewer.viewReport(jpPedido, false);
            ADConexionMySQL.Desconectar();
        } catch (JRException ex) {
        }
    }
}
