package INV_SINERCOM.Negocio;

import INV_SINERCOM.AccesoDatos.ADCliente;
import INV_SINERCOM.Entidades.*;
import java.util.*;

public class NCliente {

    /// <summary>
    /// Aplicación: INV_SINERCOM (INVENTARIO SINERCOM)
    /// Módulo: CLIENTE
    /// Fecha:2014/09/30 
    /// Empresa:SINERCOM
    /// HISTORIA DE CAMBIOS
    /// ----------------------------------------------------------------------
    /// FECHA         USUARIO     DESCRIPCION
    /// 2014/09/30    DRPAREDA    Creacion de Clase para manejo de Clientes
    /// ----------------------------------------------------------------------
    /// </summary> 
    //Carga tipos de clientes de usuarios del sistema disponibles en a base de datos
    public static ArrayList CargaTiposClientes(int TipoCliente) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADCliente.CargaTiposClientes(TipoCliente);

        return valorRetorno;
    }

    // Inserta nuevo cliente en base de datos
    public static int RegistraCliente(ECliente entCliente, int tipoCliente, int tipoHospital, String direccionCliente, String telefonoCliente) {
        int valorRetorno = 0;
        valorRetorno = ADCliente.RegistraCliente(tipoCliente, tipoHospital, entCliente.getNombreCliente(),entCliente.getRucCLiente(),direccionCliente,telefonoCliente);
        return valorRetorno;
    }

    //Busca cliente en especifico en la base de datos
    public static ArrayList BuscarUsuario(int operacion,ECliente entCliente, int CodigoCliente) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADCliente.BuscarUsuario(operacion,CodigoCliente,entCliente.getRucCLiente());
        return valorRetorno;
    }

    // Actualiza informacion de Cliente en base de datos
    public static int ActualizarUsuario(ECliente entCliente,int codigoCliente, int tipoCliente, int tipoHospital,String direccionCliente,String telefonoCliente) {
        int valorRetorno = 0;
        valorRetorno = ADCliente.ActualizarUsuario(codigoCliente, tipoCliente, tipoHospital,entCliente.getNombreCliente(),entCliente.getRucCLiente(),direccionCliente,telefonoCliente);
        return valorRetorno;
    }

    //Elimina informacion de clientes de la base de datos
    public static int EliminarCliente(int codigoCliente) {
        int valorRetorno = 0;
        int operacion = 2;//tipo de operacion para eliminar un cliente y no un usuario
        valorRetorno = ADCliente.EliminarCliente(codigoCliente, operacion);
        return valorRetorno;
    }
}
