package INV_SINERCOM.Negocio;

import INV_SINERCOM.AccesoDatos.ADConexionMySQL;
import INV_SINERCOM.AccesoDatos.ADInventario;
import INV_SINERCOM.Entidades.*;
import com.mysql.jdbc.ResultSetMetaData;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.*;
import java.util.logging.*;
import javax.swing.text.html.HTML;
import net.sf.jasperreports.engine.JRException;

/// <summary>
/// Aplicación: INV_SINERCOM (INVENTARIO SINERCOM)
/// Módulo: PEDIDOS
/// Fecha:2014/09/30 
/// Empresa:SINERCOM
/// HISTORIA DE CAMBIOS
/// ----------------------------------------------------------------------
/// FECHA         USUARIO     DESCRIPCION
/// 2014/09/30    DRPAREDA    Creacion de Clase para manejo de Productos
/// ----------------------------------------------------------------------
/// </summary> 
public class NInventario {

    //CARGA TIPOS DE PRODUCTOS
    public static ArrayList CargaTipoProductos(int CodigoCatalogo) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADInventario.CargaTipoProductos(CodigoCatalogo);
        return valorRetorno;
    }
    //REGISTRA NUEVO INVENTARIO

    public static int RegistraNuevoInventario(int operacion, EInventario entInventario) {
        int valorRetorno = 1;
        valorRetorno = ADInventario.IngresaInventario(operacion, entInventario.getCodigoProducto(), entInventario.getDescripcionProducto(), entInventario.getMarcaProducto(), entInventario.getValorUnitario(), entInventario.getTipo(), entInventario.getCantidad());
        return valorRetorno;
    }

    //REGISTRA CANTIDAD DE INVENTARIO
    public static int RegistraInventario(int operacion, EInventario entInventario) {
        int valorRetorno = 1;
        valorRetorno = ADInventario.IngresaInventario(operacion, entInventario.getCodigoProducto(), entInventario.getDescripcionProducto(), entInventario.getMarcaProducto(), entInventario.getValorUnitario(), entInventario.getTipo(), entInventario.getCantidad());
        return valorRetorno;
    }

    public static String CargaTipoPaquetes(int codigoPaquete) throws SQLException, ClassNotFoundException {
        ResultSet rsResultado = ADInventario.CargaTipoPaquetes(codigoPaquete);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "0";
        } else {
            valorRetorno = ObtenerCargaPaquetes(rsResultado);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerCargaPaquetes(ResultSet rsResultado) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        String valorRetorno = "<table border='1' id='tPaquetess' style='width: 100%;'>";
        String codigoPedido = "";
        String idProducto = "";
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        String cadena = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoPedido = "";
                codigoPedido += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                idProducto = "N" + codigoPedido;
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2));
                valorRetorno += "<tr id='" + codigoPedido + "' value='" + cadena + "'>";
                valorRetorno += "<td id='td400' align='left'>";
                if (Integer.parseInt(codigoPedido) == 407) {
                    valorRetorno += "<input type='checkbox' name='checkPaquetes[]' id=" + idProducto + " value=" + codigoPedido + " onclick=ValidaCheckInventario('" + idProducto + "'); checked>" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2));
                } else {

                    valorRetorno += "<input type='checkbox' name='checkPaquetes[]' id=" + idProducto + " value=" + codigoPedido + " onclick=ValidaCheckInventario('" + idProducto + "');>" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2));

                }
                valorRetorno += "</td>";
                valorRetorno += "</tr>";

                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>";
        return valorRetorno;
    }

    public static int AsignaPaquetesInventario(EInventario entInventario, int PaqueteProducto) {
        int valorRetorno = 1;
        valorRetorno = ADInventario.AsignaPaquetesInventario(entInventario.getCodigoProducto(), PaqueteProducto);
        return valorRetorno;
    }

    //Carga lista de productos em base de datos
    public static String CargaInventarioIngreso(int operacion, int operacionPopUp, EInventario entInventario, String parametroBusqueda) throws SQLException {
        ResultSet rsResultado = ADInventario.CargaInventarioIngreso(operacion, entInventario.getTipo(), parametroBusqueda);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "No existe información para mostrar";
        } else {
            valorRetorno = ObtenerTablaInventario(rsResultado, operacionPopUp);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerTablaInventario(ResultSet rsResultado, int operacionPopUp) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "<table border='1' id='tProductos' style='width: 100%;'>";
        String codigoProducto = "";
        String cadena = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoProducto = "";
                codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2));
                valorRetorno += "<tr id='" + codigoProducto + "' value='" + cadena + "'>";
                for (int j = 1; j <= columnas; j++) {
                    //Ciclo para cada celda de la FILA 
                    if (j == 1) {
                        codigoProducto = "";
                        valorRetorno += "<td id='td75' align='center'>";
                        codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        if (operacionPopUp == 1) {
                            valorRetorno += "<a href=javascript:AtrapaInventario('" + codigoProducto + "');>" + codigoProducto + "</a>";
                        } else if (operacionPopUp == 2) {
                            valorRetorno += "<a href=javascript:AtrapaInventarioPopUp('" + codigoProducto + "');>" + codigoProducto + "</a>";
                        }
                        valorRetorno += "</td>";
                    } else if (j == 2) {
                        valorRetorno += "<td id='td150' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else {
                        valorRetorno += "<td id='td100' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    }

                }//fin bucle for columnas 
                valorRetorno += "</tr>";
                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>";
        return valorRetorno;
    }

    //Carga tipos de filtros de Pedidos disponibles en a base de datos
    public static ArrayList CargaTipoFiltrosInventario(int CodigoCatalogo) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADInventario.CargaTipoFiltrosInventario(CodigoCatalogo);
        return valorRetorno;
    }

    //Carga lista de productos em base de datos
    public static String CargaInventarioConsulta(int operacion, int operacionPopUp, EInventario entInventario, String parametroBusqueda) throws SQLException {
        ResultSet rsResultado = ADInventario.CargaInventarioConsulta(operacion, entInventario.getTipo(), parametroBusqueda);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "No existe información para mostrar";
        } else {
            valorRetorno = ObtenerTablaConsultaInventario(rsResultado, operacionPopUp);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerTablaConsultaInventario(ResultSet rsResultado, int operacionPopUp) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "<table border='1' id='tProductos' style='width: 100%;'>";
        String codigoProducto = "";
        String cadena = "";
        String valor = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoProducto = "";
                codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4))+ "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(5)).cast(rsResultado.getObject(5));
                valorRetorno += "<tr id='" + codigoProducto + "' value='" + cadena + "'>";
                for (int j = 0; j <= columnas; j++) {
                    //Ciclo para cada celda de la FILA 
                    if (j == 0) {
                        valorRetorno += "<td class='tdEdit' value='0' id='tdEdit_" + codigoProducto + "' align='center'>";
                        if (operacionPopUp == 1) {
                            valorRetorno += "<a href=javascript:EditaInventario('" + codigoProducto + "','" + operacionPopUp + "');>Editar</a>";
                        } else if (operacionPopUp == 2) {
                            valorRetorno += "<a href=javascript:EditaInventarioPopUp('" + codigoProducto + "','" + operacionPopUp + "');>Editar</a>";
                        }
                        valorRetorno += "</td>";
                    } else if (j == 1) {
                        valorRetorno += "<td value='" + codigoProducto + "' class='tdCodigoConsulta' id='td_" + codigoProducto + "' align='center'>";
                        valorRetorno += codigoProducto;
                        valorRetorno += "</td>";
                    } else if (j == 2) {
                        valorRetorno += "<td value='" + java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j)) + "' class='tdDet' id='tdDet_" + codigoProducto + "' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else if (j == 3) {
                        valor = "";
                        valor += java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3));
                        valor += "--";
                        valor += java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4));
                        valorRetorno += "<td value='" + valor + "' class='tdClase' id='tdClase_" + codigoProducto + "' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4));
                        valorRetorno += "</td>";
                    } else if (j == 4) {
                        valor = "";
                        valor += java.lang.Class.forName(metadataEntrada.getColumnClassName(5)).cast(rsResultado.getObject(5));
                        valor += "--";
                        valor += java.lang.Class.forName(metadataEntrada.getColumnClassName(6)).cast(rsResultado.getObject(6));
                        valorRetorno += "<td value='" + valor + "' class='tdTipo' id='tdTipo_" + codigoProducto + "' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(6)).cast(rsResultado.getObject(6));
                        valorRetorno += "</td>";
                    } else if (j == 5) {
                        valorRetorno += "<td value='" + java.lang.Class.forName(metadataEntrada.getColumnClassName(7)).cast(rsResultado.getObject(7)) + "' class='tdValorUnitario' id='tdValor_" + codigoProducto + "' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(7)).cast(rsResultado.getObject(7));
                        valorRetorno += "</td>";
                    }

                }//fin bucle for columnas 
                valorRetorno += "</tr>";
                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>";
        return valorRetorno;
    }

    public static int EditaInventario(EInventario entInventario, String codigoProductoN, int claseProducto) {
        int valorRetorno = 1;
        valorRetorno = ADInventario.EditaInventario(entInventario.getCodigoProducto(), codigoProductoN, entInventario.getDescripcionProducto(), claseProducto, entInventario.getTipo(),entInventario.getValorUnitario());
        return valorRetorno;
    }

    //Carga lista de productos em base de datos base de datos
    public static String CargarReporteInventario(int operacion, int estadoInventario, String fechaInicio, String fechaFin) throws SQLException {
        ResultSet rsResultado = ADInventario.CargarReporteInventario(operacion, estadoInventario, fechaInicio, fechaFin);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "No existe información sobre este Tipo de Pedido";
        } else {
            valorRetorno = ObtenerTablaGeneraReporteInventario(rsResultado);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerTablaGeneraReporteInventario(ResultSet rsResultado) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "<table border='1' id='tProductos' align='left' style='width: 100%;'>"
                + "<tr style='background-color:#1E4EC9; color: white; '>"
                + "<td id='Ctd75' align='center' style='font-size: medium'>Codigo</td>"
                + "<td id='Ctd75' align='center' style='font-size: medium'>Cantidad</td>"
                + "<td id='Ctd150' align='center'>Detalle</td>"
                + "<td id='Ctd150' align='center'>Fecha Ingreso</td>"
                + " </tr>";
        String codigoProducto = "";
        String cadena = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoProducto = "";
                codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4));
                valorRetorno += "<tr id='" + codigoProducto + "' value='" + cadena + "'>";
                for (int j = 1; j <= columnas; j++) {
                    //Ciclo para cada celda de la FILA 
                    if (j == 1 || j == 2) {
                        codigoProducto = "";
                        valorRetorno += "<td id='td75' align='center'>";
                        codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));

                        valorRetorno += codigoProducto;
                        valorRetorno += "</td>";
                    } else if (j == 3 || j == 4) {
                        valorRetorno += "<td id='td150' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    }

                }//fin bucle for columnas 
                valorRetorno += "</tr>";
                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>"
                + "</div>"
                + "</td>"
                + "</tr>"
                + "</table>";
        return valorRetorno;
    }

    //Carga lista de productos em base de datos base de datos
    public static String CargarReporteAuditoria(int operacion, String fechaInicio, String fechaFin) throws SQLException {
        ResultSet rsResultado = ADInventario.CargarReporteAuditoria(operacion, fechaInicio, fechaFin);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "No existe información sobre este Tipo de Pedido";
        } else {
            valorRetorno = ObtenerTablaGeneraReporteAuditoria(rsResultado);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerTablaGeneraReporteAuditoria(ResultSet rsResultado) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "<table border='1' id='tProductos' align='left' style='width: 100%;'>"
                + "<tr style='background-color:#1E4EC9; color: white; '>"
                + "<td id='Ctd100' align='center' style='font-size: medium'>Ip</td>"
                + "<td id='Ctd75' align='center' style='font-size: medium'>Usuario</td>"
                + "<td id='Ctd100' align='center'>Empleado</td>"
                + "<td id='Ctd150' align='center'>Transaccion</td>"
                + "<td id='Ctd150' align='center'>Fecha</td>"
                + " </tr>";
        String codigoProducto = "";
        String cadena = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoProducto = "";
                codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4));
                valorRetorno += "<tr id='" + codigoProducto + "' value='" + cadena + "'>";
                for (int j = 1; j <= columnas; j++) {
                    //Ciclo para cada celda de la FILA 
                    if (j == 1 || j == 3) {
                        codigoProducto = "";
                        valorRetorno += "<td id='td100' align='center'>";
                        codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));

                        valorRetorno += codigoProducto;
                        valorRetorno += "</td>";
                    } else if (j == 2) {
                        valorRetorno += "<td id='td75' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else if (j == 4 || j == 5) {
                        valorRetorno += "<td id='td150' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    }

                }//fin bucle for columnas 
                valorRetorno += "</tr>";
                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>"
                + "</div>"
                + "</td>"
                + "</tr>"
                + "</table>";
        return valorRetorno;
    }
    
    //Genera reporte inventario
    public static void GeneraReportesIventario(int operacionE, String fechaInicioE, String fechaFinE, int estadoInventario) throws  IOException, JRException  {

        ADInventario.GeneraReportesIventario(operacionE, fechaInicioE, fechaFinE, estadoInventario);
    }
           //Genera reporte auditoria
    public static void GeneraReportesAuditoria(int operacionE, String fechaInicioE, String fechaFinE) throws  IOException, JRException  {

         ADInventario.GeneraReportesAuditoria(operacionE, fechaInicioE, fechaFinE);
    }
}
