package INV_SINERCOM.Negocio;

import INV_SINERCOM.AccesoDatos.ADPedido;
import INV_SINERCOM.AccesoDatos.ADConexionMySQL;
import INV_SINERCOM.Entidades.*;
import com.mysql.jdbc.ResultSetMetaData;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.*;
import java.util.logging.*;
import javax.swing.text.html.HTML;
import net.sf.jasperreports.engine.JRException;

public class NPedido {
    /// <summary>
    /// Aplicación: INV_SINERCOM (INVENTARIO SINERCOM)
    /// Módulo: PEDIDOS
    /// Fecha:2014/09/30 
    /// Empresa:SINERCOM
    /// HISTORIA DE CAMBIOS
    /// ----------------------------------------------------------------------
    /// FECHA         USUARIO     DESCRIPCION
    /// 2014/09/30    DRPAREDA    Creacion de Clase para manejo de Productos
    /// ----------------------------------------------------------------------
    /// </summary> 
    //Carga tipos de filtros de Pedidos disponibles en a base de datos

    public static ArrayList CargaTipoFiltrosPedido(int CodigoCatalogo) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADPedido.CargaTipoFiltrosPedido(CodigoCatalogo);
        return valorRetorno;
    }

    //Carga lista de productos em base de datos base de datos
    public static String CargarListaProductos(int operacionProducto, int operacionPopUp, int tipoProducto, String codigoProducto) throws SQLException {
        ResultSet rsResultado = ADPedido.CargarListaProductos(operacionProducto, tipoProducto, codigoProducto);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "No existe información sobre este Tipo de Producto";
        } else {
            valorRetorno = ObtenerTablaProductos(rsResultado, operacionPopUp);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerTablaProductos(ResultSet rsResultado, int operacionPopUp) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "<table border='1' id='tProductos' style='width: 100%;'>";
        String codigoProducto = "";
        String cadena = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoProducto = "";
                codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4));
                valorRetorno += "<tr id='" + codigoProducto + "' value='" + cadena + "'>";
                for (int j = 1; j <= columnas; j++) {
                    //Ciclo para cada celda de la FILA 
                    if (j == 1) {
                        codigoProducto = "";
                        valorRetorno += "<td id='td75' align='center'>";
                        codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        if (operacionPopUp == 1) {
                            valorRetorno += "<a href=javascript:AtrapaPedido('" + codigoProducto + "');>" + codigoProducto + "</a>";
                        } else if (operacionPopUp == 2) {
                            valorRetorno += "<a href=javascript:AtrapaPedidoPopUp('" + codigoProducto + "');>" + codigoProducto + "</a>";
                        }
                        valorRetorno += "</td>";
                    } else if (j == 2) {
                        valorRetorno += "<td id='td150' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else if (j == 3) {
                        valorRetorno += "<td id='td200' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else if (j == 4) {
                        valorRetorno += "<td id='td75' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";

                    } else {
                        valorRetorno += "<td id='td100' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    }

                }//fin bucle for columnas 
                valorRetorno += "</tr>";
                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>";
        return valorRetorno;
    }

    //Carga Lista de Clientes
    public static ArrayList CargaListaClientes(int operacion) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADPedido.CargaListaClientes(operacion);
        return valorRetorno;
    }

    //Registra Pedido
    public static int RegistraPedido(int flagActualizacion, int Cliente, EPedido entPedido, int Paquete, int CodigoPedido, String CodigoProducto, int cantidad, int numeroItems, String usuarioRegistra) {
        int valorRetorno = 0;
        int operacion = 1;
        valorRetorno = ADPedido.RegistraPedido(flagActualizacion, operacion, Cliente, entPedido.getPacientePedido(), entPedido.getMedicoPedido(), Paquete, CodigoPedido, CodigoProducto, cantidad, numeroItems, usuarioRegistra);
        return valorRetorno;
    }
    //Registra DETALLES Pedido

    public static int RegistraDetallesPedido(int flagActualizacion, int Cliente, EPedido entPedido, int Paquete, int CodigoPedido, String CodigoProducto, int cantidad, int numeroItems, String usuarioRegistra) {
        int valorRetorno = 0;
        int operacion = 2;
        valorRetorno = ADPedido.RegistraPedido(flagActualizacion, operacion, Cliente, entPedido.getPacientePedido(), entPedido.getMedicoPedido(), Paquete, CodigoPedido, CodigoProducto, cantidad, numeroItems, usuarioRegistra);
        return valorRetorno;
    }

    //Genera reporte Pedido
    public static void GeneraReportePedido(int codigoPedido) throws JRException, IOException {

        ADPedido.GeneraReportePedido(codigoPedido);
        ADConexionMySQL.Desconectar();

    }

    //Carga lista de paquetes de base de datos
    public static String CargarPaqueteProductos(int codigoPaquete) throws SQLException, ClassNotFoundException {
        ResultSet rsResultado = ADPedido.CargarPaqueteProductos(codigoPaquete);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "0";
        } else {
            valorRetorno = ObtenerCargaPaquetes(rsResultado);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerCargaPaquetes(ResultSet rsResultado) throws SQLException, ClassNotFoundException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        //int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "";
        for (int i = 0; i < filas; i++) {//bucle por filas 
            valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4));
            if (i != (filas - 1)) {
                valorRetorno += "//";
            }
            rsResultado.next();
        }
        return valorRetorno;
    }

    public static String ObtenerTablaPedidos(ResultSet rsResultado) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "<table border='1' id='tProductos' style='width: 100%;'>";
        String codigoPedido = "";
        String cadena = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoPedido = "";
                codigoPedido += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(5)).cast(rsResultado.getObject(5));
                valorRetorno += "<tr id='" + codigoPedido + "' value='" + cadena + "'>";
                for (int j = 1; j <= columnas; j++) {
                    //Ciclo para cada celda de la FILA 
                    if (j == 1) {
                        codigoPedido = "";
                        valorRetorno += "<td id='td75' align='center'>";
                        codigoPedido += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "<a href=javascript:AtrapaPedidoRecepcion('" + codigoPedido + "');>" + codigoPedido + "</a>";

                        valorRetorno += "</td>";
                    } else if (j == 2) {
                        valorRetorno += "<td id='td150' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else if (j == 3) {
                        valorRetorno += "<td id='td200' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else if (j == 4) {
                        valorRetorno += "<td id='td200' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";

                    } else {
                        valorRetorno += "<td id='td200' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    }

                }//fin bucle for columnas 
                valorRetorno += "</tr>";
                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>";
        return valorRetorno;
    }

    public static String BuscaPedidoRecepcion(int operacion, int codigoPedido, int codigoCliente, String fechaEmision) throws SQLException, ClassNotFoundException {
        String valorRetorno = null;
        ResultSet rsResultado = ADPedido.BuscaPedidoRecepcion(operacion, codigoPedido, codigoCliente, fechaEmision);
        if (rsResultado == null) {
            valorRetorno = "No se encuentra informacion de Pedidos";
        } else {
            valorRetorno = ObtenerTablaPedidos(rsResultado);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    //Carga lista de paquetes de base de datos
    public static String CargarDetallesPedidoRecepcion(int operacion, int codigoPedido, int codigoCliente, String fechaEmision) throws SQLException, ClassNotFoundException {
        ResultSet rsResultado = ADPedido.BuscaPedidoRecepcion(operacion, codigoPedido, codigoCliente, fechaEmision);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "0";
        } else {
            valorRetorno = ObtenerDatosPedidoDetalle(rsResultado);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerDatosPedidoDetalle(ResultSet rsResultado) throws SQLException, ClassNotFoundException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        //int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "";
        for (int i = 0; i < filas; i++) {//bucle por filas 
            valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(5)).cast(rsResultado.getObject(5));
            if (i != (filas - 1)) {
                valorRetorno += "//";
            }
            rsResultado.next();
        }
        return valorRetorno;
    }

    public static int RegistraRecepcionPedido(int operacion, int codigoPedido, String codigoProducto, int cantidadRecepcion, float codigoPorcentaje) throws SQLException {

        int valorRetorno = 1;
        valorRetorno = ADPedido.RegistraRecepcionPedido(operacion, codigoPedido, codigoProducto, cantidadRecepcion, codigoPorcentaje);
        return valorRetorno;
    }

    //Carga lista de productos em base de datos base de datos
    public static String CargarReportePedidos(int operacion, int cliente, String fechaInicio, String fechaFin, String estadoPedido) throws SQLException {
        ResultSet rsResultado = ADPedido.CargarReportePedidos(operacion, cliente, fechaInicio, fechaFin, estadoPedido);
        String valorRetorno = null;
        if (rsResultado == null) {
            valorRetorno = "No existe información sobre este Tipo de Pedido";
        } else {
            valorRetorno = ObtenerTablaGeneraReportePedido(rsResultado);
        }
        ADConexionMySQL.Desconectar();
        return valorRetorno;
    }

    public static String ObtenerTablaGeneraReportePedido(ResultSet rsResultado) throws SQLException {
        rsResultado.last();
        int filas = rsResultado.getRow();
        rsResultado.first();
        ResultSetMetaData metadataEntrada = (ResultSetMetaData) rsResultado.getMetaData();
        int columnas = metadataEntrada.getColumnCount();
        String valorRetorno = "<table border='1' id='tProductos' align='left' style='width: 100%;'>"
                + "<tr style='background-color:#1E4EC9; color: white; '>"
                + "<td id='Ctd75' align='center' style='font-size: medium'>Pedido</td>"
                + "<td id='Ctd150' align='center'>Fecha Emision</td>"
                + "<td id='Ctd200' align='center'>Cliente</td>"
                + "<td id='Ctd200' align='center'>Paciente</td>"
                + "<td id='Ctd75' align='center'>Estado</td>"
                + "<td id='Ctd150' align='center'>Usuario</td>"
                + "<td id='Ctd75' align='center'>Total</td>"
                + " </tr>";
        String codigoProducto = "";
        String cadena = "";

        //retorno="Filas "+filas+" - Columnas"+columnas; 
        for (int i = 0; i < filas; i++) {//bucle por filas 
            try {
                cadena = "";
                codigoProducto = "";
                codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1));
                cadena += java.lang.Class.forName(metadataEntrada.getColumnClassName(1)).cast(rsResultado.getObject(1)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(2)).cast(rsResultado.getObject(2)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(3)).cast(rsResultado.getObject(3)) + "--" + java.lang.Class.forName(metadataEntrada.getColumnClassName(4)).cast(rsResultado.getObject(4));
                valorRetorno += "<tr id='" + codigoProducto + "' value='" + cadena + "'>";
                for (int j = 1; j <= columnas; j++) {
                    //Ciclo para cada celda de la FILA 
                    if (j == 1) {
                        codigoProducto = "";
                        valorRetorno += "<td id='td75' align='center'>";
                        codigoProducto += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        // valorRetorno += "<a href=javascript:AtrapaPedido('" + codigoProducto + "');>" + codigoProducto + "</a>";
                        valorRetorno += codigoProducto;
                        valorRetorno += "</td>";
                    } else if (j == 2 || j == 6) {
                        valorRetorno += "<td id='td150' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else if (j == 3 || j == 4) {
                        valorRetorno += "<td id='td200' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    } else {
                        valorRetorno += "<td id='td75' align='center'>";
                        valorRetorno += java.lang.Class.forName(metadataEntrada.getColumnClassName(j)).cast(rsResultado.getObject(j));
                        valorRetorno += "</td>";
                    }

                }//fin bucle for columnas 
                valorRetorno += "</tr>";
                rsResultado.next();
            } //fin bucle for columnas 
            catch (Exception ex) {
                Logger.getLogger(HTML.class.getName()).log(Level.SEVERE, null, ex);
            }
        }//fin bucle for filas 
        valorRetorno += "</table>"
                + "</div>"
                + "</td>"
                + "</tr>"
                + "</table>";
        return valorRetorno;
    }

    //Genera reporte Pedido
    public static void GeneraReportesPedidos(int operacionE, int clienteE, String fechaInicioE, String fechaFinE, String estadoPedido) throws  IOException, JRException  {

        //ADPedido.GeneraReportesPedidos2(operacionE, clienteE, fechaInicioE, fechaFinE,estadoPedido);
        ADPedido.GeneraReportesPedidos(operacionE, clienteE, fechaInicioE, fechaFinE, estadoPedido);
    }
    
}
