package INV_SINERCOM.Negocio;

import INV_SINERCOM.AccesoDatos.ADUsuarios;
import INV_SINERCOM.Entidades.*;
import java.util.*;

public class NUsuario {
    /// <summary>
    /// Aplicación: INV_SINERCOM (INVENTARIO SINERCOM)
    /// Módulo: USUARIOS
    /// Fecha:2014/09/30 
    /// Empresa:SINERCOM
    /// HISTORIA DE CAMBIOS
    /// ----------------------------------------------------------------------
    /// FECHA         USUARIO     DESCRIPCION
    /// 2014/09/30    DRPAREDA    Creacion de Clase para manejo de USUARIOS
    /// ----------------------------------------------------------------------
    /// </summary> 

    //Verifica datos del usuario a logearse
    public static ArrayList Login(EUsuario entUsuario) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADUsuarios.Login(entUsuario.getUsuario(), entUsuario.getContrasena());
        return valorRetorno;
    }

    //Obtiene perfil del usuario logeado
    public static String ObtienePerfilUsuario(EUsuario entUsuario) {
        String valorRetorno = "";
        valorRetorno = ADUsuarios.ObtienePerfilUsuario(entUsuario.getUsuario());
        return valorRetorno;
    }

    // Inserta nuevo usuario en base de datos
    public static int RegistraUsuario(EUsuario entusuario, int indexCombo, int indexEmpleado) {
        int valorRetorno = 0;
        valorRetorno = ADUsuarios.RegistraUsuario(entusuario.getUsuario(), entusuario.getContrasena(), indexCombo, indexEmpleado);
        return valorRetorno;
    }

    //Carga perfiles de usuarios del sistema disponibls en a base de datos
    public static ArrayList CargaPerfilUsuario() {

        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADUsuarios.CargaPerfilUsuario();
        return valorRetorno;
    }

    //Carga empleados de la empresa disponibls en a base de datos
    public static ArrayList CargaEmpleados(int operacion) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADUsuarios.CargaEmpleados(operacion);
        return valorRetorno;
    }

    //Busca usuario en especifico en la base de datos
    public static ArrayList BuscarUsuario(int operacion, EUsuario entUsuario, int CodigoUsuario) {
        ArrayList valorRetorno = new ArrayList();
        valorRetorno = ADUsuarios.BuscarUsuario(operacion, entUsuario.getUsuario(), CodigoUsuario);
        return valorRetorno;
    }

    // Actualiza informacion de Usuario en base de datos
    public static int ActualizarUsuario(int codigoUsuario, EUsuario entUsuario, int indexCombo, int indexEmpleado, String estadoUsuario) {
        int valorRetorno = 0;
        valorRetorno = ADUsuarios.ActualizarUsuario(codigoUsuario, entUsuario.getContrasena(), indexCombo, indexEmpleado, estadoUsuario);
        return valorRetorno;
    }

    //Elimina informacion de Usuario de la base de datos
    public static int EliminarUsuario(int codigoUsuario) {
        int valorRetorno = 0;
        int operacion = 1;
        valorRetorno = ADUsuarios.EliminarUsuario(codigoUsuario, operacion);
        return valorRetorno;
    }

    //Valida empleados si esta asociados ya a un usuario
    public static int ValidaEmpleadoUsuario(int operacion, int codigoEmpleado, int codigoUsuario) {
        int valorRetorno = 0;
        valorRetorno = ADUsuarios.ValidaEmpleadoUsuario(operacion, codigoEmpleado, codigoUsuario);
        return valorRetorno;
    }

    //Camba clave de usuario
    public static int CambiaClaveUsuario(int operacion, EUsuario entUsuario) {
        int valorRetorno = -1;
        valorRetorno = ADUsuarios.CambiaClaveUsuario(operacion, entUsuario.getUsuario(), entUsuario.getContrasena());
        return valorRetorno;
    }
}
