-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.5.8


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema sinercom
--

CREATE DATABASE IF NOT EXISTS sinercom;
USE sinercom;

--
-- Definition of table `inv_catalogo_detalle_paquete`
--

DROP TABLE IF EXISTS `inv_catalogo_detalle_paquete`;
CREATE TABLE `inv_catalogo_detalle_paquete` (
  `codigo` int(10) unsigned NOT NULL,
  `detalle` varchar(500) NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_catalogo_detalle_paquete`
--

/*!40000 ALTER TABLE `inv_catalogo_detalle_paquete` DISABLE KEYS */;
INSERT INTO `inv_catalogo_detalle_paquete` (`codigo`,`detalle`) VALUES 
 (2,'f'),
 (401,'Recibí de la Empresa SINERCOM CIA. LTDA., el instrumental e implantes (SISTEMA COMBO MANO), que se detalla a continuación, los mismos que me permitiré devolver en las mismas condiciones que me fueron entregados.'),
 (402,'Recibí de la Empresa SINERCOM CIA. LTDA., el instrumental e implantes (SISTEMA DE RECONSTRUCCION), que se detalla a continuación, los mismos que me permitiré devolver en las mismas condiciones que me fueron entregados.'),
 (403,'Recibí de la Empresa SINERCOM CIA. LTDA., el instrumental e implantes (SISTEMA ESTANDAR 2.0 MM), que se detalla a continuación, los mismos que me permitiré devolver en las mismas condiciones que me fueron entregados.'),
 (404,'Recibí de la Empresa SINERCOM CIA. LTDA., el instrumental e implantes (SISTEMA MINI 1.7 MM), que se detalla a continuación, los mismos que me permitiré devolver en las mismas condiciones que me fueron entregados.'),
 (405,'Recibí de la Empresa SINERCOM CIA. LTDA., el instrumental e implantes (SISTEMA COMBO MAXILOFACIAL), que se detalla a continuación, los mismos que me permitiré devolver en las mismas condiciones que me fueron entregados.'),
 (406,'Recibí de la Empresa SINERCOM CIA. LTDA., el instrumental e implantes (SISTEMA MALLA/TORNILLOS), que se detalla a continuación, los mismos que me permitiré devolver en las mismas condiciones que me fueron entregados.'),
 (407,'Recibí de la Empresa SINERCOM CIA. LTDA., el instrumental e implantes, que se detalla a continuación, los mismos que me permitiré devolver en las mismas condiciones que me fueron entregados.');
/*!40000 ALTER TABLE `inv_catalogo_detalle_paquete` ENABLE KEYS */;


--
-- Definition of table `inv_catalogo_paquetes`
--

DROP TABLE IF EXISTS `inv_catalogo_paquetes`;
CREATE TABLE `inv_catalogo_paquetes` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo_producto` varchar(50) NOT NULL,
  `codigo_paquete` int(10) unsigned NOT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_catalogo_paquetes_1` (`codigo_paquete`),
  CONSTRAINT `FK_inv_catalogo_paquetes_1` FOREIGN KEY (`codigo_paquete`) REFERENCES `inv_catalogo_detalle_paquete` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_catalogo_paquetes`
--

/*!40000 ALTER TABLE `inv_catalogo_paquetes` DISABLE KEYS */;
INSERT INTO `inv_catalogo_paquetes` (`codigo`,`codigo_producto`,`codigo_paquete`) VALUES 
 (1,'501004000',401),
 (2,'501004001',401),
 (8,'1234',407),
 (9,'1235',401),
 (10,'1235',403),
 (11,'1',407),
 (12,'0',401),
 (13,'0',402),
 (14,'0',404),
 (15,'prueba123',407);
/*!40000 ALTER TABLE `inv_catalogo_paquetes` ENABLE KEYS */;


--
-- Definition of table `inv_catalogo_parametrizacion`
--

DROP TABLE IF EXISTS `inv_catalogo_parametrizacion`;
CREATE TABLE `inv_catalogo_parametrizacion` (
  `codigo` int(10) unsigned NOT NULL,
  `nombre_catalogo` varchar(100) NOT NULL,
  `abreviatura` varchar(3) NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_catalogo_parametrizacion`
--

/*!40000 ALTER TABLE `inv_catalogo_parametrizacion` DISABLE KEYS */;
INSERT INTO `inv_catalogo_parametrizacion` (`codigo`,`nombre_catalogo`,`abreviatura`) VALUES 
 (10,'TIPO CLIENTE','TP'),
 (20,'TIPO HOSPITAL','TH'),
 (30,'TIPO PRODUCTO','TP'),
 (40,'TIPO PAQUETE','TPA'),
 (50,'TIPO ESTADO PRODUCTO','TE'),
 (60,'TIPO INVENTARIO','TSP'),
 (70,'TIPO PORCENTAJE CLIENTE','TPC');
/*!40000 ALTER TABLE `inv_catalogo_parametrizacion` ENABLE KEYS */;


--
-- Definition of table `inv_catalogo_producto`
--

DROP TABLE IF EXISTS `inv_catalogo_producto`;
CREATE TABLE `inv_catalogo_producto` (
  `codigo` varchar(50) NOT NULL DEFAULT '0',
  `tipo` int(10) unsigned NOT NULL,
  `descripcion` varchar(1000) NOT NULL,
  `valor_unitario` decimal(10,2) NOT NULL,
  `valor_con_iva` decimal(10,2) NOT NULL,
  `marca` varchar(100) NOT NULL,
  `v/util` decimal(10,2) NOT NULL,
  `tipo_inventario` int(10) unsigned NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_catalogo_producto`
--

/*!40000 ALTER TABLE `inv_catalogo_producto` DISABLE KEYS */;
INSERT INTO `inv_catalogo_producto` (`codigo`,`tipo`,`descripcion`,`valor_unitario`,`valor_con_iva`,`marca`,`v/util`,`tipo_inventario`) VALUES 
 ('100000000',307,'Con tope','71.10','79.63','N/A','0.00',601),
 ('100000001',317,'40x30 mm. p/1.7 mm.','448.10','501.87','N/A','0.00',601),
 ('100000002',317,'200x200 p/1.7 mm.','3691.80','4134.82','N/A','0.00',601),
 ('100000003',317,'200x100 p/1.7 mm.','1845.90','2067.41','N/A','0.00',601),
 ('108056',320,'CAMISA SUJETADOR TORNILL','300.36','336.40','BIOASEP','10.00',602),
 ('108057',320,'CAMISA SUJETADOR TORNILL','680.00','761.60','BIOASEP','10.00',602),
 ('108059',320,'PROTECTOR DE CAMISA 2.0','182.32','204.20','BIOASEP','10.00',602),
 ('1201101',316,'Placa 2 orif. c/pte.','35.53','39.80','N/A','0.00',601),
 ('1201102',316,'Torn.2.0x4 en cruz','16.99','19.03','N/A','0.00',601),
 ('2273026',318,'Alambre (metros)','4.44','4.97','N/A','0.00',601),
 ('2273028',318,'Alambre (rollo 50 m.)','58.78','65.83','N/A','0.00',601),
 ('2274100',318,'Arco de Erich','64.52','72.27','N/A','0.00',601),
 ('2296003511',320,'MICRO SIERRA OSCILA 2.5','60.00','67.20','BIOASEP','10.00',602),
 ('2296003525',320,'MICRO SIERRA OSCILA SAGI','100.00','112.00','BIOASEP','10.00',602),
 ('260901739',320,'CONTRA CLEAN + ACOPLE','60.00','67.20','BIOASEP','10.00',602),
 ('501004000',301,'4 orif. c/pte. peq.','59.92','67.11','N/A','0.00',601),
 ('501004001',301,'4 orificios regular','59.92','67.11','N/A','0.00',601),
 ('501004002',301,'4 orif, con puente','59.92','67.11','N/A','0.00',601),
 ('501004003',301,'L derecha, regular','93.36','104.56','N/A','0.00',601),
 ('501004004',301,'L izquierda, regular','93.36','104.56','N/A','0.00',601),
 ('501004007',301,'L derecha, c/pte.','97.49','109.19','N/A','0.00',601),
 ('501004008',301,'L izquierda, c/pte.','97.49','109.19','N/A','0.00',601),
 ('501004009',302,'4 orificios regular','71.48','80.06','N/A','0.00',601),
 ('501004010',302,'4 orificios c/puente','71.48','80.06','N/A','0.00',601),
 ('501004011',302,'4 orificios c/pte.larg','71.48','80.06','N/A','0.00',601),
 ('501004017',302,'L der., c/pte 8mm ','105.18','117.80','N/A','0.00',601),
 ('501004018',302,'L izq., c/pte 8mm ','105.18','117.80','N/A','0.00',601),
 ('501004035',303,'4 orificios regular','67.54','75.64','N/A','0.00',601),
 ('501004039',314,'4 orif. Regular','181.10','202.84','N/A','0.00',601),
 ('501004041',314,'4 orif. c/pte. Med.','202.88','227.23','N/A','0.00',601),
 ('501004042',314,'4 orif. c/pte. Largo','227.43','254.72','N/A','0.00',601),
 ('501004054',313,'Izq. ,4+11 orif.','336.49','376.87','N/A','0.00',601),
 ('501004055',313,'Der. , 4+11 orif.','336.49','376.87','N/A','0.00',601),
 ('501004056',313,'Izq. ,4+14 orif','351.99','394.23','N/A','0.00',601),
 ('501004057',313,'Compl.4+17+4','494.13','553.43','N/A','0.00',601),
 ('501005002',301,'Placa Y, regular','105.53','118.19','N/A','0.00',601),
 ('501005003',301,'Placa Y, c/puente','105.53','118.19','N/A','0.00',601),
 ('501005006',302,'Placa T c/puente','126.89','142.12','N/A','0.00',601),
 ('501005007',302,'Placa Y regular','126.89','142.12','N/A','0.00',601),
 ('501005008',302,'Placa Y c/puente','126.89','142.12','N/A','0.00',601),
 ('501005019',303,'Placa T, regular','113.78','127.43','N/A','0.00',601),
 ('501005050',314,'5 orif. Regular','226.39','253.56','N/A','0.00',601),
 ('501006000',301,'6 orificios regular','63.07','70.64','N/A','0.00',601),
 ('501006001',301,'6 orif, con puente','63.07','70.64','N/A','0.00',601),
 ('501006002',301,'Placa T, regular','105.53','118.19','N/A','0.00',601),
 ('501006003',301,'Placa T, c/puente','105.53','118.19','N/A','0.00',601),
 ('501006005',301,'Doble Y, regular','134.72','150.88','N/A','0.00',601),
 ('501006006',301,'Doble Y, c/pte.','134.72','150.88','N/A','0.00',601),
 ('501006007',302,'6 orificios regular','75.22','84.25','N/A','0.00',601),
 ('501006009',302,'Placa T regular','126.89','142.12','N/A','0.00',601),
 ('501006010',302,'Doble T, regular','130.12','145.73','N/A','0.00',601),
 ('501006011',302,'Doble Y, regular','134.43','150.56','N/A','0.00',601),
 ('501006012',302,'Doble Y, c/puente','139.79','156.56','N/A','0.00',601),
 ('501006023',303,'6 orificios regular','73.34','82.14','N/A','0.00',601),
 ('501006024',303,'Placa en Y regular','126.45','141.63','N/A','0.00',601),
 ('501006025',303,'Doble Y regular','148.19','165.97','N/A','0.00',601),
 ('501006029',314,'6 orif. Regular','283.91','317.98','N/A','0.00',601),
 ('501006030',314,'6 orif. Angulada','283.91','317.98','N/A','0.00',601),
 ('501007001',302,'Doble Y, reg.7 orif.','149.68','167.64','N/A','0.00',601),
 ('501007005',303,'Placa doble Y,7 orif','155.26','173.90','N/A','0.00',601),
 ('501007022',301,'Z izquierda regular','67.67','75.79','N/A','0.00',601),
 ('501007023',301,'Z derecha regular','67.67','75.79','N/A','0.00',601),
 ('501008000',301,'8 orificios regular','89.27','99.98','N/A','0.00',601),
 ('501008001',302,'8 orificios regular','96.88','108.51','N/A','0.00',601),
 ('501008002',319,'8 orif. Curva','126.95','142.18','N/A','0.00',601),
 ('501008009',303,'8 orificios regular','79.38','88.91','N/A','0.00',601),
 ('501008018',314,'8 orif. con puente','301.64','337.84','N/A','0.00',601),
 ('501008019',313,'Recta 8 orificios','226.00','253.12','N/A','0.00',601),
 ('501008028',314,'8 orif. Regular','296.39','331.96','N/A','0.00',601),
 ('501009001',303,'Doble T, 9 orif.','157.23','176.09','N/A','0.00',601),
 ('501010000',319,'10 orif. Curva','156.84','175.66','N/A','0.00',601),
 ('501011000',313,'Recta 11 orificios','247.05','276.70','N/A','0.00',601),
 ('501012001',303,'12 orificios regular','126.45','141.63','N/A','0.00',601),
 ('501014000',314,'Recta 14 orif.','339.59','380.34','N/A','0.00',601),
 ('501014001',313,'Recta 14 orificios','268.07','300.23','N/A','0.00',601),
 ('501016000',301,'16 orificios regular','110.88','124.19','N/A','0.00',601),
 ('501016001',302,'16 orificios regular','144.51','161.85','N/A','0.00',601),
 ('501016003',303,'16 orificios regular','155.26','173.90','N/A','0.00',601),
 ('501017000',313,'Recta 17 orificios','289.09','323.78','N/A','0.00',601),
 ('501122000',309,'2x2 orif.cuadrado','114.41','128.14','N/A','0.00',601),
 ('501122001',309,'2x2 orif.rectangular','114.41','128.14','N/A','0.00',601),
 ('501122006',304,'2x2 orif.cuadrado','114.41','128.14','N/A','0.00',601),
 ('501122008',306,'2x2 orif.cuadrado','120.42','134.87','N/A','0.00',601),
 ('501122009',306,'2x2 orif.rectangular','120.42','134.87','N/A','0.00',601),
 ('501132000',309,'3x2 orif.cuadrado','167.30','187.37','N/A','0.00',601),
 ('501132001',309,'3x2 orif.rectangular','167.30','187.37','N/A','0.00',601),
 ('501132006',304,'3x2 orif.cuadrado','167.30','187.37','N/A','0.00',601),
 ('501132008',306,'3x2 orif.cuadrado','176.14','197.28','N/A','0.00',601),
 ('501142009',306,'4x2 orif.cuadrado','171.10','191.63','N/A','0.00',601),
 ('501148002',313,'Der. , 4+14 orif.','351.99','394.23','N/A','0.00',601),
 ('502015101',307,'Corta, 1.5 x 7 mm.','71.10','79.63','N/A','0.00',601),
 ('502015102',307,'Mediana,1.5x20 mm.','71.10','79.63','N/A','0.00',601),
 ('502015104',307,'Larga, 1.5 x 20 mm.','98.92','110.79','N/A','0.00',601),
 ('502015113',312,'1.0 x 50 mm.','82.59','92.50','N/A','0.00',601),
 ('502015121',310,'Con tope,1.4x5 mm. ','82.59','92.50','N/A','0.00',601),
 ('502015123',310,'Diam. 1.3 x 8 mm ','82.59','92.50','N/A','0.00',601),
 ('503001759',317,'40x25 mm. p/1.7 mm.','341.16','382.09','N/A','0.00',601),
 ('503004105',320,'MANGO DESTORNILLADOR TUF','300.96','337.08','NORMED','10.00',602),
 ('503004107',320,'HOJA INTERCAMBIABLE PARA','53.12','59.49','NORMED','10.00',602),
 ('503004110',320,'ADERER DOBLADOR DE PLACA','151.04','169.16','NORMED','10.00',602),
 ('503004115',320,'MEDIDOR DE PROFUNDIDAD V','0.00','0.00','NORMED','10.00',602),
 ('503004122',317,'Malla reconstrucc.','761.48','852.86','N/A','0.00',601),
 ('503004124',320,'PINZA DOBLAR PLACAS,BROC','101.91','114.14','NORMED','10.00',602),
 ('503004136',317,'40x40 mm. p/1.7 mm.','497.23','556.89','N/A','0.00',601),
 ('503004195',320,'ADERER DOBLADOR DEPLACAS','110.57','123.84','NORMED','10.00',602),
 ('503004196',320,'PINZA ADERER DOBLADORA D','146.97','164.61','NORMED','10.00',602),
 ('503004197',320,'PINZA DE TITANIIO P/PLAC','74.46','83.40','NORMED','10.00',602),
 ('503004247',320,'CORTAFRIO TC P/PLACAS 18','568.59','636.82','NORMED','10.00',602),
 ('503004412',320,'HOJA INTERCAMBIABLE CROS','53.12','59.49','NORMED','10.00',602),
 ('503004417',320,'HOJA INTERCAMBIABLE CROS','53.12','59.49','NORMED','10.00',602),
 ('503004605',320,'MANGO DESTORNILLADOR MET','72.11','80.76','NORMED','10.00',602),
 ('503004610',320,'MANGO DESTORNILLADOR MET','216.33','242.29','NORMED','10.00',602),
 ('503004912',320,'DISPOSITIVO DE AGARRE EA','67.27','75.34','NORMED','10.00',602),
 ('503004917',320,'DISPOSITIVO DE AGARRE EA','67.27','75.34','NORMED','10.00',602),
 ('503004920',320,'DISPOSITIVO DE AGARRE EA','67.27','75.34','NORMED','10.00',602),
 ('509002100',320,'CONTENEDOR ALUMINIO 300X','474.65','531.61','NORMED','10.00',602),
 ('509002128',320,'SOPORTE COMBO,ALUMINIO,M','540.62','605.49','NORMED','10.00',602),
 ('509002129',320,'SOPORTE COMBO ALUMINIO 1','540.62','605.49','NORMED','10.00',602),
 ('509002130',320,'SOPORTE COMBO ALUMINIO 2','540.62','605.49','NORMED','10.00',602),
 ('509002131',320,'BANDEJA COMBO P/INSTRUME','406.03','454.75','NORMED','10.00',602),
 ('5100004000',320,'CABLE PARA MICROMOTOR TP','662.40','741.89','CROSSWEL INTERNACIOL','10.00',602),
 ('5100008000',320,'PEDAL TPS (5) PEDAL CORE','1323.60','1482.43','CROSSWEL INTERNACIOL','10.00',602),
 ('5100009000',320,'INTERRUPTOR DE MANO UNIV','360.00','403.20','CROSSWEL INTERNACIOL','10.00',602),
 ('5100015000',320,'MICRO DRILL TPS','1400.00','1568.00','CROSSWEL INTERNACIOL','10.00',602),
 ('5100015043',320,'DRILL MEDIANO','840.80','941.70','CROSSWEL INTERNACIOL','10.00',602),
 ('5100015250',320,'DRILL MEDIANO TPS','420.40','470.85','CROSSWEL INTERNACIOL','10.00',602),
 ('5100031000',320,'SIERRA OSCILANTE TPS','1800.00','2016.00','CROSSWEL INTERNACIOL','10.00',602),
 ('5100050000',320,'CONSOLA INTEGRAL CON IRR','5670.00','6350.40','CROSSWEL INTERNACIOL','10.00',602),
 ('5100137133',320,'SIERRA RECIPROCANTE DE P','360.00','403.20','BIOASEP','10.00',602),
 ('5100137134',320,'SIERRA RECIPROCANTE DE P','180.00','201.60','BIOASEP','10.00',602),
 ('5100276000',320,'CAJA TPS SMALL','921.60','1032.19','CROSSWEL INTERNACIOL','10.00',602),
 ('512003001',311,'1.2 x 3 mm.','38.58','43.21','N/A','0.00',601),
 ('512004001',311,'1.2 x 4 mm.','38.58','43.21','N/A','0.00',601),
 ('512005001',311,'1.2 x 5 mm.','38.58','43.21','N/A','0.00',601),
 ('512006001',311,'1.2 x 6 mm.','38.58','43.21','N/A','0.00',601),
 ('512007001',311,'1.2 x 7 mm.','40.99','45.91','N/A','0.00',601),
 ('512008001',311,'1.2 x 8 mm.','40.99','45.91','N/A','0.00',601),
 ('514005001',311,'1.4 x 5  mm.','38.58','43.21','N/A','0.00',601),
 ('514007001',311,'1.4 x 7  mm.','38.58','43.21','N/A','0.00',601),
 ('517003001',308,'1.7 x 3 mm.','21.60','24.19','N/A','0.00',601),
 ('517004001',308,'1.7 x 4 mm.','21.60','24.19','N/A','0.00',601),
 ('517005001',308,'1.7 x 5 mm.','22.60','25.31','N/A','0.00',601),
 ('517006001',308,'1.7 x 6 mm.','22.60','25.31','N/A','0.00',601),
 ('517007001',308,'1.7 x 7 mm.','24.60','27.55','N/A','0.00',601),
 ('517008001',308,'1.7 x 8 mm.','24.60','27.55','N/A','0.00',601),
 ('519005001',308,'1.9 x 5 mm.','22.60','25.31','N/A','0.00',601),
 ('520004009',305,'2.0 x 4 mm.','18.76','21.02','N/A','0.00',601),
 ('520005009',305,'2.0 x 5 mm.','18.76','21.02','N/A','0.00',601),
 ('520007009',305,'2.0 x 7 mm.','18.76','21.02','N/A','0.00',601),
 ('520008080',305,'IMF 2.0 x 8 mm.','22.56','25.27','N/A','0.00',601),
 ('520009009',305,'2.0 x 9 mm.','18.76','21.02','N/A','0.00',601),
 ('520011009',305,'2.0 x 11 mm.','18.76','21.02','N/A','0.00',601),
 ('520013009',305,'2.0 x 13 mm.','18.76','21.02','N/A','0.00',601),
 ('520014080',305,'IMF 2.0 x 14 mm.','22.56','25.27','N/A','0.00',601),
 ('520015009',305,'2.0 x 15 mm.','21.21','23.76','N/A','0.00',601),
 ('523007009',305,'2.3 x  7 mm.','18.76','21.01','N/A','0.00',601),
 ('523008001',315,'2.3 X 8 mm.','25.65','28.73','N/A','0.00',601),
 ('523010001',315,'2.3 x 10 mm.','25.65','28.73','N/A','0.00',601),
 ('523012001',315,'2.3 x 12 mm.','25.65','28.73','N/A','0.00',601),
 ('523014001',315,'2.3 x 14 mm.','25.65','28.73','N/A','0.00',601),
 ('523016001',315,'2.3 x 16 mm.','26.81','30.02','N/A','0.00',601),
 ('527008001',316,'2. 7 x 8 mm.','36.11','40.44','N/A','0.00',601),
 ('527010001',316,'2. 7 x 10 mm.','37.85','42.39','N/A','0.00',601),
 ('527012001',316,'2. 7 x 12 mm.','41.54','46.52','N/A','0.00',601),
 ('527014001',316,'2. 7 x 14 mm.','41.54','46.52','N/A','0.00',601),
 ('527016001',316,'2. 7 x 16 mm.','42.30','47.38','N/A','0.00',601),
 ('527018001',316,'2. 7 x 18 mm.','44.03','49.31','N/A','0.00',601),
 ('530010001',316,'3.0 x 10 mm.','59.56','66.70','N/A','0.00',601),
 ('5400015000',320,'MICRO DRILL CORE','2800.00','3136.00','CROSSWEL INTERNACIOL','10.00',602),
 ('5400031000',320,'SIERRA OSCILANTE CORE','3600.00','4032.00','CROSSWEL INTERNACIOL','10.00',602),
 ('5400037000',320,'SIERRA RESCIPROCANTE','1800.00','2016.00','CROSSWEL INTERNACIOL','10.00',602),
 ('5408508',319,'standhouser 20 orif.','166.32','186.28','N/A','0.00',601),
 ('6010404',312,'Con tope,1.0x46 mm. ','82.59','92.50','N/A','0.00',601),
 ('6212175',320,'DOBLAD-CORTADO DEREC PLA','611.52','684.90','CROSSWEL INTERNACIOL','10.00',602),
 ('6212175A',320,'DOBLAD-CORTAD DEREC PLAC','196.85','220.47','CROSSWEL INTERNACIOL','10.00',602),
 ('6212176',320,'DOBLADOR DE PLACAS CARA','427.84','479.18','CROSSWEL INTERNACIOL','10.00',602),
 ('6212176A',320,'DOBLADOR DE PLACAS CARA','196.85','220.47','CROSSWEL INTERNACIOL','10.00',602),
 ('6227136',320,'PALA DESTORNILLADOR HEX-','400.00','448.00','CROSSWEL INTERNACIOL','10.00',602),
 ('6400242',320,'DOBLADOR IZQUIERDO SISTE','197.35','221.03','CROSSWEL INTERNACIOL','10.00',602),
 ('6400243',320,'COBLADOR Y CORTADOR DERE','197.35','221.03','CROSSWEL INTERNACIOL','10.00',602),
 ('JEIL112MD302',320,'BROCA LARGA 14 MM.','22.02','24.66','JEIL','10.00',602),
 ('JEIL112MX301',320,'BROCA SISTEMA MAXI 2.4 M','44.78','50.15','JEIL','10.00',602),
 ('LEI0108050',320,'DESTORN. SUJETA TORN. 2.','236.98','265.42','LEI','10.00',602),
 ('LEI0108070',320,'ALICATE ADERER 2.0 MM.','125.14','140.16','LEI','10.00',602),
 ('LEI0108071',320,'ALICATE ADERER 1.7 MM.','30.17','33.79','LEI','10.00',602),
 ('LEI0108110',320,'PINZA SUJETADORA DE PLAC','48.04','53.80','LEI','10.00',602),
 ('LEI0108502',320,'CANULA PARA MANGO WURZBU','29.69','33.25','LEI','10.00',602),
 ('LEI0108504',320,'RETRACTOR DE MEJILLA WUR','24.52','27.46','LEI.','10.00',602),
 ('LEI0108506',320,'TROCAR WURZBURG 01-08500','5.81','6.51','LEI','10.00',602),
 ('LEI0108508',320,'DRILL GUIA WURZBURG','7.23','8.10','LEI','10.00',602),
 ('LEI0108512',320,'MANGO WURZBURG CON TUBO','162.64','182.16','LEI','10.00',602),
 ('LEI0108514',320,'SEPARADOR DE MEJILLA WUR','134.34','150.46','LEI','10.00',602),
 ('LEI0108514A',320,'SEPARADOR DE MEJILLA WUR','67.17','75.23','LEI','10.00',602),
 ('LEI0108516',320,'TROCAR WURZBURG','31.82','35.64','LEI','10.00',602),
 ('LEI0108518',320,'GUIA WURZBURG PARA PERFO','31.82','35.64','LEI','10.00',602),
 ('LEI0108725',320,'MEDIDOR DE PROFUNDIDAD 2','126.19','141.33','LEI','10.00',602),
 ('LEI2912151',320,'CONTENEDOR DE IMPLANTES','461.55','516.94','LEI','10.00',602),
 ('LEI2912156',320,'BANDEJA PORTA INSTRUMENT','300.52','336.58','LEI','10.00',602),
 ('LEI2913103',320,'CONTENEDOR DE IMPLANTES','211.88','237.31','LEI','10.00',602),
 ('LEI2920500',320,'CAJA ESTERILIZADORA 30X3','492.40','551.49','LEI','10.00',602),
 ('LEI3600726',320,'ALICATE DOBLADOR DE PLAC','69.78','78.15','LEI','10.00',602),
 ('LEI3600726A',320,'ALICATE DOBLADOR DE PLAC','69.78','78.15','LEI','10.00',602),
 ('LEI3605310',320,'PINZA MICHEL PARA APLICA','17.36','19.44','LEI','10.00',602),
 ('LEI5405172',320,'ROSETA PARA CRANEOTOMIA','63.82','71.48','LEI','10.00',602),
 ('LEI6015138',320,'BROCA TIPO STRYKER DIAM.','9.00','10.08','LEI','10.00',602),
 ('LEI6020155',320,'BROCA TIPO STRYKER DIAM.','7.34','8.22','LEI','10.00',602),
 ('LEI6020384',320,'BROCA AO 2.0 X 125 MM.','7.34','8.22','LEI','10.00',602),
 ('LEI6025326',320,'BROCA AO 2.5 X 87 MM.','7.34','8.22','LEI','10.00',602),
 ('LEI6088123',320,'BROCA LARGA PARA TORNILL','34.07','38.16','LEI','10.00',602),
 ('LEI6200500',320,'DESTORNILLAODR SISTEMA S','339.40','380.13','LEI','10.00',602),
 ('LEI6200501',320,'MANGO PARA 62-00500 (1.2','131.80','147.62','LEI','10.00',602),
 ('LEI6200520',320,'DESTORNILLADOR FIJO 1.7','231.84','259.66','LEI','10.00',602),
 ('LEI6200530',320,'DESTORNILLADOR SISTEMA S','231.28','259.03','LEI','10.00',602),
 ('LEI6210100',320,'MEDIDOR DE PROFUNDIDAD 1','154.63','173.19','LEI','10.00',602),
 ('LEI6217401',320,'HOJA DESTORNILLADOR 1.7','41.23','46.18','LEI','10.00',602),
 ('LEI6217500',320,'DESTORNILLADOR SISTEMA S','297.40','333.09','LEI','10.00',602),
 ('LEI6217500A',320,'DESTORNILLADOR SISTEMA S','297.40','333.09','LEI','10.00',602),
 ('LEI6223500',320,'DESTORNILLADOR SIST. SUJ','297.40','333.09','LEI','10.00',602),
 ('LEI6400105',320,'PINZA ADERER 1.2 MM.','62.60','70.11','LEI','10.00',602),
 ('LEI6420120',320,'CIZALLA PARA CORTAR PLAC','115.30','129.14','LEI','10.00',602),
 ('NOR501015121',320,'BROCA 1.3 X 47 MM.','31.50','35.28','NORMED','10.00',602),
 ('NOR502015101',320,'BROCA CORTA 6MM DIAM. 1.','108.43','121.44','NORMED','10.00',602),
 ('NOR502015102',320,'BROCA MEDIANA 20 MM','262.40','293.89','NORMED','10.00',602),
 ('NOR502015104',320,'BROCA LARGA 20 MM. 1.5 X','192.15','215.21','NORMED','10.00',602),
 ('NOR502015106',320,'BROCA TIPO STRYKER 2.0 X','188.47','211.09','NORMED','10.00',602),
 ('NOR502015123',320,'BROCA PARA TORNILLOS 1.7','60.32','67.56','NORMED','10.00',602),
 ('NOR503004104',320,'ATRORNILLADOR DISPOSITIV','460.28','515.51','NORMED','10.00',602),
 ('NOR50304124',320,'PINZA ADERER PARA 1.7 MM','40.98','45.90','NORMED','10.00',602),
 ('NOR8010600',320,'CAJA PLASTICA ESTERILIZA','127.60','142.91','NORMED','10.00',602),
 ('prueba123',301,'aa','100.00','112.00','na','0.00',601),
 ('prueba6666',301,'dfsdg','0.00','0.00','prueba','0.00',601),
 ('pruebq6666',304,'rgwergwer','10.50','11.76','hqsfas','0.00',601),
 ('SOUS83102',320,'HOJA SIERRA SAGITAL','23.11','25.88','SOU','10.00',602),
 ('TAVM01005',320,'MUESTRARIO FRESAS Y SIER','469.14','525.44','TAV','10.00',602);
/*!40000 ALTER TABLE `inv_catalogo_producto` ENABLE KEYS */;


--
-- Definition of table `inv_cliente`
--

DROP TABLE IF EXISTS `inv_cliente`;
CREATE TABLE `inv_cliente` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `tipo_cliente` int(10) unsigned NOT NULL,
  `tipo_hospital` int(10) unsigned NOT NULL,
  `nombre_cliente` varchar(200) NOT NULL,
  `fecha_alta` datetime NOT NULL,
  `fecha_modificacion` datetime DEFAULT NULL,
  `direccion_cliente` varchar(300) NOT NULL,
  `telefono_cliente` varchar(20) NOT NULL,
  `ruc_cliente` varchar(30) NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_cliente`
--

/*!40000 ALTER TABLE `inv_cliente` DISABLE KEYS */;
INSERT INTO `inv_cliente` (`codigo`,`tipo_cliente`,`tipo_hospital`,`nombre_cliente`,`fecha_alta`,`fecha_modificacion`,`direccion_cliente`,`telefono_cliente`,`ruc_cliente`) VALUES 
 (2,101,202,'HOSPITAL FAEE','2014-11-04 22:24:54','2015-01-10 16:39:28','11111','11111','1234501190'),
 (3,102,203,'sdgasdf','2014-11-04 22:26:55','2015-02-02 22:15:06','rr44','222','333');
/*!40000 ALTER TABLE `inv_cliente` ENABLE KEYS */;


--
-- Definition of table `inv_detalle_catalogo_parametrizacion`
--

DROP TABLE IF EXISTS `inv_detalle_catalogo_parametrizacion`;
CREATE TABLE `inv_detalle_catalogo_parametrizacion` (
  `codigo` int(10) unsigned NOT NULL,
  `nombre_detalle` varchar(100) NOT NULL,
  `codigo_catalogo` int(10) unsigned NOT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_detalle_catalogo_parametrizacion` (`codigo_catalogo`),
  CONSTRAINT `FK_inv_detalle_catalogo_parametrizacion` FOREIGN KEY (`codigo_catalogo`) REFERENCES `inv_catalogo_parametrizacion` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_detalle_catalogo_parametrizacion`
--

/*!40000 ALTER TABLE `inv_detalle_catalogo_parametrizacion` DISABLE KEYS */;
INSERT INTO `inv_detalle_catalogo_parametrizacion` (`codigo`,`nombre_detalle`,`codigo_catalogo`) VALUES 
 (101,'HOSPITAL',10),
 (102,'P.NATURAL',10),
 (201,'PRIVADO',20),
 (202,'PUBLICO',20),
 (203,'N/A',20),
 (301,'PLACAS ESTANDAR(2.0)',30),
 (302,'MINI PLACAS(1.7)',30),
 (303,'MICRO PLACAS(1.2)',30),
 (304,'MICROSEGMENTOS',30),
 (305,'TORNILLOS(2.0 MM)',30),
 (306,'SEGMENTOS TRIDIMENSIONALES',30),
 (307,'BROCAS PARA(2.0)',30),
 (308,'TORNILLOS(1.7 MM)',30),
 (309,'MINISEGMENTOS 3-D(1.7)',30),
 (310,'BROCAS PARA(1.7 m)',30),
 (311,'MICRO TORNILLOS(1.2 MM)',30),
 (312,'BROCAS PARA(1.2 MM)',30),
 (313,'PLACAS RECONSTRUCCION MANDIBULAR(2.7)',30),
 (314,'PLACAS P/FRACTURA MANDIBULAR(2.4)',30),
 (315,'TORNILLOS DE TITANIO(2.3 MM)',30),
 (316,'TORNILLOS RECONST. MANDIB',30),
 (317,'MALLAS',30),
 (318,'VARIOS',30),
 (319,'PLACAS ORBITARIAS',30),
 (320,'INSTRUMENTAL',30),
 (401,'SISTEMA COMBO MANO',40),
 (402,'SISTEMA DE RECONSTRUCCION',40),
 (403,'SISTEMA ESTANDAR 2.0 MM',40),
 (404,'SISTEMA MINI 1.7 mm',40),
 (405,'SISTEMA COMBO MAXILOFACIAL',40),
 (406,'MALLA/TORNILLOS',40),
 (407,'N/A',40),
 (501,'DISPONIBLE',50),
 (502,'NO DISPONIBLE',50),
 (503,'EN PROCESO',50),
 (601,'IMPLANTES',60),
 (602,'INSTRUMENTAL',60),
 (701,'CLIENTES A 12%',70),
 (702,'CLIENTES B 12%',70),
 (703,'CLIENTES C 12%',70),
 (704,'CLIENTES D 12%',70);
/*!40000 ALTER TABLE `inv_detalle_catalogo_parametrizacion` ENABLE KEYS */;


--
-- Definition of table `inv_detalle_pedido`
--

DROP TABLE IF EXISTS `inv_detalle_pedido`;
CREATE TABLE `inv_detalle_pedido` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo_pedido` int(10) unsigned NOT NULL,
  `codigo_tipo_producto` int(10) unsigned NOT NULL,
  `codigo_producto` varchar(50) NOT NULL,
  `codigo_paquete` int(10) unsigned NOT NULL,
  `cantidad` int(10) unsigned NOT NULL,
  `tipo_inventario` int(10) unsigned NOT NULL,
  `valor_grupal` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_detalle_pedido` (`codigo_pedido`),
  CONSTRAINT `FK_inv_detalle_pedido` FOREIGN KEY (`codigo_pedido`) REFERENCES `inv_pedido` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=64 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_detalle_pedido`
--

/*!40000 ALTER TABLE `inv_detalle_pedido` DISABLE KEYS */;
INSERT INTO `inv_detalle_pedido` (`codigo`,`codigo_pedido`,`codigo_tipo_producto`,`codigo_producto`,`codigo_paquete`,`cantidad`,`tipo_inventario`,`valor_grupal`) VALUES 
 (1,1,301,'501004002',407,2,601,'179.76'),
 (2,2,320,'108056',407,2,602,'901.08'),
 (3,3,301,'501004002',407,1,601,NULL),
 (4,3,301,'501004000',407,1,601,NULL),
 (5,3,320,'108056',407,1,602,NULL),
 (6,4,301,'501004000',407,1,601,NULL),
 (7,5,301,'501004000',407,1,601,'83.89'),
 (8,6,301,'501004000',407,1,601,NULL),
 (9,7,301,'501004000',407,1,601,NULL),
 (10,8,301,'501004002',407,2,601,NULL),
 (11,8,301,'501016000',407,3,601,NULL),
 (12,9,301,'501004002',407,2,601,NULL),
 (13,9,301,'501016000',407,2,601,NULL),
 (14,10,301,'501016000',407,1,601,NULL),
 (15,11,301,'501004000',407,1,601,NULL),
 (16,12,301,'501004000',407,1,601,NULL),
 (17,13,301,'501004000',407,1,601,NULL),
 (18,14,301,'501004000',407,1,601,NULL),
 (19,15,301,'501004000',407,1,601,NULL),
 (20,16,301,'501004000',407,1,601,NULL),
 (21,17,301,'501004001',401,1,601,'0.00'),
 (22,17,301,'501004004',407,1,601,'0.00'),
 (23,18,301,'501004000',407,1,601,NULL),
 (27,20,301,'501004001',401,1,601,NULL),
 (28,20,301,'501004000',401,1,601,NULL),
 (29,21,301,'501004000',407,2,601,NULL),
 (30,22,301,'501004000',407,3,601,NULL),
 (31,23,301,'501004000',407,2,601,NULL),
 (32,24,301,'501004001',407,1,601,NULL),
 (33,24,301,'501004000',407,1,601,NULL),
 (34,25,301,'501004000',407,1,601,NULL),
 (35,26,301,'501004000',407,1,601,NULL),
 (36,27,301,'501004000',407,1,601,NULL),
 (37,28,301,'501004000',407,1,601,NULL),
 (38,29,301,'501004000',407,1,601,NULL),
 (39,30,301,'501006005',407,1,601,NULL),
 (40,30,301,'501006002',407,1,601,NULL),
 (41,30,301,'501007022',407,1,601,NULL),
 (42,30,301,'501006006',407,1,601,NULL),
 (43,30,301,'501006003',407,1,601,NULL),
 (44,30,301,'501006001',407,1,601,NULL),
 (45,30,301,'501005003',407,1,601,NULL),
 (46,30,301,'501004008',407,1,601,NULL),
 (47,30,301,'501004004',407,1,601,NULL),
 (48,30,301,'501005002',407,1,601,NULL),
 (49,30,301,'501004007',407,1,601,NULL),
 (50,30,301,'501004003',407,1,601,NULL),
 (51,30,301,'501004002',407,1,601,NULL),
 (52,30,301,'501004000',407,1,601,NULL),
 (53,30,301,'501016000',407,1,601,NULL),
 (54,30,301,'501004001',407,1,601,NULL),
 (55,31,301,'501004000',407,1,601,NULL),
 (56,31,301,'501004001',407,2,601,NULL),
 (57,32,301,'501004000',407,1,601,NULL),
 (58,33,301,'501004000',407,1,601,NULL),
 (59,34,301,'501004000',407,1,601,NULL),
 (60,35,301,'501004000',407,1,601,NULL),
 (61,35,301,'501004001',407,1,601,NULL),
 (62,36,301,'501004000',407,1,601,NULL),
 (63,36,301,'501004001',407,1,601,NULL);
/*!40000 ALTER TABLE `inv_detalle_pedido` ENABLE KEYS */;


--
-- Definition of table `inv_empleado`
--

DROP TABLE IF EXISTS `inv_empleado`;
CREATE TABLE `inv_empleado` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nombre_empleado` varchar(100) NOT NULL,
  `apellido_empleado` varchar(100) NOT NULL,
  `cedula_empleado` varchar(10) NOT NULL,
  `direccion_empleado` varchar(600) NOT NULL,
  `telefono_empleado` varchar(20) NOT NULL,
  `fecha_registro` datetime NOT NULL,
  `fecha_modificacion` datetime DEFAULT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_empleado`
--

/*!40000 ALTER TABLE `inv_empleado` DISABLE KEYS */;
INSERT INTO `inv_empleado` (`codigo`,`nombre_empleado`,`apellido_empleado`,`cedula_empleado`,`direccion_empleado`,`telefono_empleado`,`fecha_registro`,`fecha_modificacion`) VALUES 
 (1,'Daniel','Paredes','1715580237','inaquito y joaquin auz','2922397','2014-10-28 15:34:25','2015-02-02 20:36:48'),
 (2,'christian','calderon','1234567891','dadas','1341346436','2014-10-28 17:01:51',NULL),
 (26,'sadfasdf','asfasdf','2512351','asdfasd','4444','2015-02-02 23:47:13',NULL);
/*!40000 ALTER TABLE `inv_empleado` ENABLE KEYS */;


--
-- Definition of table `inv_inventario_proceso`
--

DROP TABLE IF EXISTS `inv_inventario_proceso`;
CREATE TABLE `inv_inventario_proceso` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo_pedido` int(10) unsigned NOT NULL,
  `codigo_producto` varchar(50) NOT NULL,
  `cantidad` int(10) unsigned NOT NULL,
  `estado` int(10) unsigned NOT NULL,
  `fecha_emision` datetime NOT NULL,
  `tipo_inventario` int(10) unsigned NOT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_inventario_proceso_1` (`codigo_pedido`),
  KEY `FK_inv_inventario_proceso_2` (`codigo_producto`),
  CONSTRAINT `FK_inv_inventario_proceso_2` FOREIGN KEY (`codigo_producto`) REFERENCES `inv_catalogo_producto` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `FK_inv_inventario_proceso_1` FOREIGN KEY (`codigo_pedido`) REFERENCES `inv_pedido` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=63 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_inventario_proceso`
--

/*!40000 ALTER TABLE `inv_inventario_proceso` DISABLE KEYS */;
INSERT INTO `inv_inventario_proceso` (`codigo`,`codigo_pedido`,`codigo_producto`,`cantidad`,`estado`,`fecha_emision`,`tipo_inventario`) VALUES 
 (3,3,'501004002',1,503,'2015-01-11 22:17:48',601),
 (4,3,'501004000',1,503,'2015-01-11 22:17:48',601),
 (5,3,'108056',1,503,'2015-01-11 22:17:49',602),
 (6,4,'501004000',1,503,'2015-01-11 22:24:14',601),
 (7,6,'501004000',1,503,'2015-01-12 19:51:29',601),
 (8,7,'501004000',1,503,'2015-01-12 19:59:08',601),
 (9,8,'501004002',2,503,'2015-01-12 19:59:49',601),
 (10,8,'501016000',3,503,'2015-01-12 19:59:49',601),
 (11,9,'501004002',2,503,'2015-01-12 21:53:57',601),
 (12,9,'501016000',2,503,'2015-01-12 21:53:58',601),
 (13,10,'501016000',1,503,'2015-01-12 22:01:43',601),
 (14,11,'501004000',1,503,'2015-01-12 22:12:49',601),
 (15,12,'501004000',1,503,'2015-01-12 22:15:40',601),
 (16,13,'501004000',1,503,'2015-01-12 22:17:07',601),
 (17,14,'501004000',1,503,'2015-01-12 22:23:02',601),
 (19,16,'501004000',1,503,'2015-01-12 23:03:42',601),
 (22,18,'501004000',1,503,'2015-01-13 22:56:53',601),
 (23,19,'501004001',1,503,'2015-01-13 23:01:47',601),
 (24,19,'501016000',1,503,'2015-01-13 23:01:47',601),
 (25,19,'501004000',1,503,'2015-01-13 23:01:47',601),
 (26,20,'501004001',1,503,'2015-02-02 23:52:54',601),
 (27,20,'501004000',1,503,'2015-02-02 23:52:54',601),
 (28,21,'501004000',2,503,'2015-02-05 21:13:17',601),
 (29,22,'501004000',3,503,'2015-02-05 21:31:28',601),
 (30,23,'501004000',2,503,'2015-02-05 21:34:19',601),
 (31,24,'501004001',1,503,'2015-02-05 21:40:15',601),
 (32,24,'501004000',1,503,'2015-02-05 21:40:15',601),
 (33,25,'501004000',1,503,'2015-02-05 21:43:16',601),
 (34,26,'501004000',1,503,'2015-02-05 21:47:34',601),
 (35,27,'501004000',1,503,'2015-02-05 21:54:52',601),
 (36,28,'501004000',1,503,'2015-02-05 21:57:35',601),
 (37,29,'501004000',1,503,'2015-02-05 22:04:15',601),
 (38,30,'501006005',1,503,'2015-02-05 22:05:58',601),
 (39,30,'501006002',1,503,'2015-02-05 22:05:58',601),
 (40,30,'501006006',1,503,'2015-02-05 22:05:58',601),
 (41,30,'501007022',1,503,'2015-02-05 22:05:58',601),
 (42,30,'501006003',1,503,'2015-02-05 22:05:58',601),
 (43,30,'501006001',1,503,'2015-02-05 22:05:58',601),
 (44,30,'501005003',1,503,'2015-02-05 22:05:59',601),
 (45,30,'501004004',1,503,'2015-02-05 22:05:59',601),
 (46,30,'501004008',1,503,'2015-02-05 22:05:59',601),
 (47,30,'501004007',1,503,'2015-02-05 22:05:59',601),
 (48,30,'501005002',1,503,'2015-02-05 22:05:59',601),
 (49,30,'501004003',1,503,'2015-02-05 22:05:59',601),
 (50,30,'501004002',1,503,'2015-02-05 22:05:59',601),
 (51,30,'501004000',1,503,'2015-02-05 22:05:59',601),
 (52,30,'501016000',1,503,'2015-02-05 22:05:59',601),
 (53,30,'501004001',1,503,'2015-02-05 22:05:59',601),
 (54,31,'501004000',1,503,'2015-02-05 22:09:00',601),
 (55,31,'501004001',2,503,'2015-02-05 22:09:00',601),
 (56,32,'501004000',1,503,'2015-02-05 22:10:51',601),
 (57,33,'501004000',1,503,'2015-02-05 22:12:17',601),
 (58,34,'501004000',1,503,'2015-02-05 23:15:04',601),
 (59,35,'501004000',1,503,'2015-02-10 19:55:27',601),
 (60,35,'501004001',1,503,'2015-02-10 19:55:27',601),
 (61,36,'501004000',1,503,'2015-02-10 20:05:32',601),
 (62,36,'501004001',1,503,'2015-02-10 20:05:32',601);
/*!40000 ALTER TABLE `inv_inventario_proceso` ENABLE KEYS */;


--
-- Definition of table `inv_inventario_producto`
--

DROP TABLE IF EXISTS `inv_inventario_producto`;
CREATE TABLE `inv_inventario_producto` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo_producto` varchar(50) NOT NULL,
  `cantidad` int(10) unsigned NOT NULL,
  `estado` int(10) unsigned NOT NULL,
  `fecha_ultimo_ingreso` datetime NOT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_inventario_producto` (`codigo_producto`),
  CONSTRAINT `FK_inv_inventario_producto` FOREIGN KEY (`codigo_producto`) REFERENCES `inv_catalogo_producto` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_inventario_producto`
--

/*!40000 ALTER TABLE `inv_inventario_producto` DISABLE KEYS */;
INSERT INTO `inv_inventario_producto` (`codigo`,`codigo_producto`,`cantidad`,`estado`,`fecha_ultimo_ingreso`) VALUES 
 (1,'501004000',141,501,'2014-09-25 17:32:14'),
 (2,'501004001',134,501,'2014-09-30 15:05:13'),
 (3,'501016000',56,501,'2014-10-02 14:30:31'),
 (4,'501004002',148,501,'2014-11-20 22:00:22'),
 (5,'501004003',87,501,'2014-11-20 22:11:11'),
 (6,'501004004',73,501,'2014-11-20 22:11:17'),
 (7,'501004007',97,501,'2014-11-20 22:11:26'),
 (8,'501004008',98,501,'2014-11-20 22:11:31'),
 (9,'501005002',93,501,'2014-11-20 22:12:24'),
 (10,'501005003',91,501,'2014-11-20 22:12:24'),
 (11,'501006000',96,501,'2014-11-20 22:13:49'),
 (12,'501006001',94,501,'2014-11-20 22:13:49'),
 (13,'501006002',94,501,'2014-11-20 22:14:49'),
 (14,'501006003',92,501,'2014-11-20 22:14:49'),
 (15,'501006005',98,501,'2014-11-20 22:14:49'),
 (16,'501006006',98,501,'2014-11-20 22:14:49'),
 (17,'501007022',98,501,'2014-11-20 22:18:25'),
 (18,'501007023',99,501,'2014-11-20 22:18:25'),
 (19,'501008000',97,501,'2014-11-20 22:18:25'),
 (20,'108056',91,501,'2014-11-25 22:51:19'),
 (21,'2296003525',4,501,'2015-01-13 09:51:54'),
 (22,'108059',4,501,'2015-01-13 09:51:54');
/*!40000 ALTER TABLE `inv_inventario_producto` ENABLE KEYS */;


--
-- Definition of table `inv_log_errores`
--

DROP TABLE IF EXISTS `inv_log_errores`;
CREATE TABLE `inv_log_errores` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ip` varchar(50) NOT NULL,
  `usuario` varchar(50) NOT NULL,
  `error` varchar(1000) NOT NULL,
  `fecha` datetime NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB AUTO_INCREMENT=133 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_log_errores`
--

/*!40000 ALTER TABLE `inv_log_errores` DISABLE KEYS */;
INSERT INTO `inv_log_errores` (`codigo`,`ip`,`usuario`,`error`,`fecha`) VALUES 
 (1,'10.19.8.141','drpareda','Pedido - For input string: \"idTipoProducto\"','2014-10-06 13:16:59'),
 (2,'10.19.8.141','drpareda','Pedido - For input string: \"idTipoProducto\"','2014-10-06 13:18:38'),
 (3,'10.19.8.141','drpareda','Pedido - Dangling meta character \'*\' near index 0\r\n*\r\n^','2014-10-08 11:44:04'),
 (4,'10.19.8.141','drpareda','Pedido - Dangling meta character \'*\' near index 0\r\n*\r\n^','2014-10-08 11:46:03'),
 (5,'10.19.8.141','drpareda','Pedido - Dangling meta character \'*\' near index 0\r\n*\r\n^','2014-10-08 11:48:31'),
 (6,'10.19.8.141','drpareda','Pedido - Dangling meta character \'*\' near index 0\r\n*\r\n^','2014-10-08 11:49:51'),
 (7,'10.19.8.141','drpareda','Pedido - Index: 0, Size: 0','2014-10-15 09:57:23'),
 (8,'10.19.8.141','drpareda','Pedido - Index: 0, Size: 0','2014-10-15 09:59:28'),
 (9,'10.19.8.141','drpareda','Pedido - java.io.FileNotFoundException: C:\\Users\\Irene\\Desktop\\Dropbox\\SISTEMA\\SINERCOM\\SISTEMA\\OCTUBRE\\15-10-2014\\INV_SINERCOM\\src\\java\\INV_SINERCOM\\AccesoDatos\\NotaEntrega.jasper','2014-10-27 10:54:21'),
 (10,'10.19.8.141','drpareda','Pedido - java.io.FileNotFoundException: C:\\Users\\Irene\\Desktop\\Dropbox\\SISTEMA\\SINERCOM\\SISTEMA\\OCTUBRE\\15-10-2014\\INV_SINERCOM\\src\\java\\INV_SINERCOM\\AccesoDatos\\NotaEntrega.jasper','2014-10-27 10:56:14'),
 (11,'192.168.1.124','drpareda','Cliente - For input string: \"undefined\"','2014-11-03 22:44:19'),
 (12,'192.168.1.124','drpareda','Cliente - For input string: \"undefined\"','2014-11-03 22:49:51'),
 (13,'192.168.1.124','drpareda','Cliente - For input string: \"undefined\"','2014-11-03 22:55:20'),
 (14,'192.168.1.124','drpareda','Usuario - Index: 0, Size: 0','2014-11-03 23:45:39'),
 (15,'192.168.1.124','drpareda','Usuario - Index: 0, Size: 0','2014-11-03 23:50:45'),
 (16,'192.168.1.124','drpareda','Usuario - Index: 0, Size: 0','2014-11-03 23:51:20'),
 (17,'192.168.1.124','drpareda','Usuario - Index: 0, Size: 0','2014-11-03 23:54:20'),
 (18,'192.168.1.124','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-11-09 11:25:22'),
 (19,'192.168.1.124','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-11-09 13:40:06'),
 (20,'192.168.1.124','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-11-16 21:08:31'),
 (21,'192.168.1.124','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-11-16 21:12:06'),
 (22,'192.168.1.124','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-11-16 21:12:52'),
 (23,'192.168.1.124','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-11-16 23:39:07'),
 (24,'192.168.1.124','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-11-20 22:48:58'),
 (25,'192.168.1.124','drpareda','Pedido - For input string: \"null\"','2014-11-27 23:19:42'),
 (26,'192.168.1.124','drpareda','Pedido - For input string: \"null\"','2014-11-27 23:27:19'),
 (27,'192.168.1.124','drpareda','Pedido - For input string: \"null\"','2014-11-27 23:32:58'),
 (28,'192.168.1.124','drpareda','Pedido - For input string: \"\"','2014-11-27 23:38:48'),
 (29,'192.168.1.124','drpareda','Pedido - For input string: \"null\"','2014-11-27 23:40:06'),
 (30,'192.168.1.124','drpareda','Pedido - Resource not found at : C:\\Users\\Irene\\Desktop\\Dropbox\\SISTEMA\\SINERCOM\\SISTEMA\\OCTUBRE\\15-10-2014\\INV_SINERCOM\\src\\java\\INV_SINERCOM\\AccesoDatos\\ADDetallePedido.jasper','2014-11-30 23:04:15'),
 (31,'192.168.1.124','drpareda','Pedido - For input string: \"\"','2014-12-02 21:18:12'),
 (32,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-11 23:49:12'),
 (33,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-11 23:52:17'),
 (34,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-11 23:52:37'),
 (35,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-11 23:53:59'),
 (36,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:05:45'),
 (37,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:05:45'),
 (38,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:05:45'),
 (39,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:05:45'),
 (40,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:08:39'),
 (41,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:08:39'),
 (42,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:08:39'),
 (43,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:08:39'),
 (44,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:11:23'),
 (45,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:11:23'),
 (46,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:11:23'),
 (47,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:11:23'),
 (48,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:13:23'),
 (49,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:13:23'),
 (50,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:13:23'),
 (51,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:13:23'),
 (52,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:15:08'),
 (53,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:15:08'),
 (54,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:15:08'),
 (55,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:15:08'),
 (56,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:16:57'),
 (57,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:16:57'),
 (58,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:16:57'),
 (59,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:16:57'),
 (60,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:19:45'),
 (61,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:19:45'),
 (62,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:19:45'),
 (63,'192.168.1.127','drpareda','Pedido - For input string: \"\"','2014-12-15 00:19:45'),
 (64,'192.168.1.127','drpareda','Pedido - 4','2014-12-15 23:08:27'),
 (65,'192.168.1.127','drpareda','Pedido - 3','2014-12-15 23:18:38'),
 (66,'192.168.1.127','drpareda','Pedido - 4','2014-12-15 23:23:31'),
 (67,'10.19.8.141','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-12-22 13:56:12'),
 (68,'192.168.1.127','drpareda','Inventario - For input string: \"1operacionP=1\"','2014-12-22 23:41:01'),
 (69,'192.168.1.127','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-12-22 23:43:34'),
 (70,'192.168.1.127','drpareda','Pedido - For input string: \"1operacionP=1\"','2014-12-22 23:43:43'),
 (71,'192.168.1.127','drpareda','Pedido - java.io.FileNotFoundException: NotaEntrega.jasper','2015-01-05 21:34:27'),
 (72,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556364\"','2015-01-06 09:59:27'),
 (73,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556372\"','2015-01-06 09:59:33'),
 (74,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556372\"','2015-01-06 10:00:43'),
 (75,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556451\"','2015-01-06 10:00:54'),
 (76,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556372\"','2015-01-06 10:04:56'),
 (77,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556451\"','2015-01-06 10:04:59'),
 (78,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556709\"','2015-01-06 10:05:10'),
 (79,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556712\"','2015-01-06 10:05:12'),
 (80,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556714\"','2015-01-06 10:05:14'),
 (81,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556716\"','2015-01-06 10:05:16'),
 (82,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556718\"','2015-01-06 10:05:18'),
 (83,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556723\"','2015-01-06 10:05:23'),
 (84,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556725\"','2015-01-06 10:05:25'),
 (85,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556727\"','2015-01-06 10:05:27'),
 (86,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556729\"','2015-01-06 10:05:29'),
 (87,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556732\"','2015-01-06 10:05:32'),
 (88,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556734\"','2015-01-06 10:05:34'),
 (89,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556736\"','2015-01-06 10:05:37'),
 (90,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556451\"','2015-01-06 10:06:29'),
 (91,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556372\"','2015-01-06 10:06:29'),
 (92,'10.19.8.141','drpareda','Pedido - For input string: \"0?t=1420556803\"','2015-01-06 10:06:43'),
 (93,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 14:50:27'),
 (94,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 14:52:14'),
 (95,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 15:58:38'),
 (96,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 16:05:04'),
 (97,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 16:05:56'),
 (98,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 16:08:45'),
 (99,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 16:10:04'),
 (100,'192.168.1.127','drpareda','Cliente - For input string: \"5d\"','2015-01-10 16:11:24'),
 (101,'192.168.1.127','drpareda','Usuario - For input string: \"4573212111\"','2015-01-10 16:41:45'),
 (102,'192.168.1.127','drpareda','Cliente - For input string: \"12341325135\"','2015-01-10 18:36:17'),
 (103,'192.168.1.127','drpareda','Cliente - For input string: \"132412351325132513\"','2015-01-10 18:36:41'),
 (104,'192.168.1.127','drpareda','Usuario - For input string: \"233151351354\"','2015-01-10 18:39:05'),
 (105,'192.168.1.127','drpareda','Empleado - For input string: \"235123513513535325331\"','2015-01-10 18:39:17'),
 (106,'192.168.1.127','drpareda','Empleado - For input string: \"12353154351351545545\"','2015-01-10 18:42:57'),
 (107,'192.168.1.127','drpareda','Empleado - For input string: \"123423151351325135\"','2015-01-10 18:46:16'),
 (108,'192.168.1.127','drpareda','Empleado - For input string: \"1351351435135132532113\"','2015-01-10 19:01:25'),
 (109,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-01-10 19:09:46'),
 (110,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-01-10 19:09:55'),
 (111,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-01-10 19:17:06'),
 (112,'192.168.1.127','drpareda','Pedido - java.io.FileNotFoundException: ReportePedidos.jasper','2015-01-12 00:36:32'),
 (113,'192.168.1.127','drpareda','Pedido - java.io.FileNotFoundException: ReportePedidos.jasper','2015-01-12 00:40:03'),
 (114,'192.168.1.127','drpareda','Pedido - Byte data not found at : cherry.jpg','2015-01-12 22:27:22'),
 (115,'192.168.1.127','drpareda','Pedido - Byte data not found at : cherry.jpg','2015-01-12 22:28:31'),
 (116,'192.168.1.127','drpareda','Pedido - Byte data not found at : cherry.jpg','2015-01-12 22:28:44'),
 (117,'192.168.1.127','drpareda','Pedido - Byte data not found at : cherry.jpg','2015-01-12 22:28:44'),
 (118,'192.168.1.127','drpareda','Pedido - Byte data not found at : cherry.jpg','2015-01-12 22:28:44'),
 (119,'10.19.8.141','drpareda','Reportes - For input string: \"TRAN\"','2015-01-27 15:52:04'),
 (120,'10.19.8.141','drpareda','Reportes - For input string: \"TRAN\"','2015-01-27 15:56:29'),
 (121,'10.19.8.141','drpareda','Reportes - For input string: \"TRAN\"','2015-01-27 15:56:29'),
 (122,'10.19.8.141','drpareda','Reportes - For input string: \"TRA\"','2015-01-27 16:04:03'),
 (123,'10.19.8.141','drpareda','Reportes - For input string: \"TRA\"','2015-01-27 16:08:33'),
 (124,'10.19.8.141','drpareda','Reportes - For input string: \"TRA\"','2015-01-27 16:08:45'),
 (125,'10.19.8.141','drpareda','Reportes - For input string: \"TRA\"','2015-01-27 16:11:21'),
 (126,'192.168.1.127','pruebaa','Login usuario - Index: 1, Size: 1','2015-01-28 23:58:40'),
 (127,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-02-02 20:15:31'),
 (128,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-02-02 20:17:28'),
 (129,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-02-02 20:25:37'),
 (130,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-02-02 20:32:06'),
 (131,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-02-02 20:32:35'),
 (132,'192.168.1.127','drpareda','Empleado - radix 500 greater than Character.MAX_RADIX','2015-02-02 20:33:11');
/*!40000 ALTER TABLE `inv_log_errores` ENABLE KEYS */;


--
-- Definition of table `inv_log_transacciones`
--

DROP TABLE IF EXISTS `inv_log_transacciones`;
CREATE TABLE `inv_log_transacciones` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ip` varchar(50) NOT NULL,
  `usuario` varchar(50) DEFAULT NULL,
  `accion` varchar(500) NOT NULL,
  `fecha` datetime NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB AUTO_INCREMENT=2869 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_log_transacciones`
--

/*!40000 ALTER TABLE `inv_log_transacciones` DISABLE KEYS */;
INSERT INTO `inv_log_transacciones` (`codigo`,`ip`,`usuario`,`accion`,`fecha`) VALUES 
 (1,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:28:08'),
 (2,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:30:04'),
 (3,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:32:35'),
 (4,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:33:55'),
 (5,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:34:37'),
 (6,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:36:09'),
 (7,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:36:33'),
 (8,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:38:00'),
 (9,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:41:08'),
 (10,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:41:57'),
 (11,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:45:04'),
 (12,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:46:38'),
 (13,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:47:57'),
 (14,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:51:12'),
 (15,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:53:56'),
 (16,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:56:11'),
 (17,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 10:56:52'),
 (18,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:04:54'),
 (19,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:05:55'),
 (20,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:10:59'),
 (21,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:11:49'),
 (22,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:12:28'),
 (23,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:13:27'),
 (24,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:54:24'),
 (25,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 11:56:27'),
 (26,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:16:46'),
 (27,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:17:52'),
 (28,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:20:24'),
 (29,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:21:21'),
 (30,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:25:00'),
 (31,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:26:06'),
 (32,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:27:58'),
 (33,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:29:24'),
 (34,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:30:20'),
 (35,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:32:21'),
 (36,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:34:52'),
 (37,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:37:47'),
 (38,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:38:48'),
 (39,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:39:25'),
 (40,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:40:54'),
 (41,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:41:34'),
 (42,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:47:19'),
 (43,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:48:30'),
 (44,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:50:06'),
 (45,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:51:44'),
 (46,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 13:53:25'),
 (47,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:05:17'),
 (48,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:06:32'),
 (49,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:19:48'),
 (50,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:20:43'),
 (51,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:23:04'),
 (52,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:26:22'),
 (53,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:28:50'),
 (54,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:29:28'),
 (55,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:33:14'),
 (56,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:34:48'),
 (57,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:36:38'),
 (58,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 14:56:25'),
 (59,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:02:58'),
 (60,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:05:15'),
 (61,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:09:13'),
 (62,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:11:08'),
 (63,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:12:06'),
 (64,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:13:41'),
 (65,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:26:30'),
 (66,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 15:36:27'),
 (67,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 17:55:42'),
 (68,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 17:56:11'),
 (69,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-06 17:57:14'),
 (70,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:24:03'),
 (71,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:24:42'),
 (72,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:29:07'),
 (73,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:32:40'),
 (74,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:34:21'),
 (75,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:36:00'),
 (76,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:38:21'),
 (77,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:41:44'),
 (78,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 16:59:02'),
 (79,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:00:30'),
 (80,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:04:56'),
 (81,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:06:08'),
 (82,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:07:01'),
 (83,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:08:27'),
 (84,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:11:22'),
 (85,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:12:02'),
 (86,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:13:14'),
 (87,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:22:32'),
 (88,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:22:58'),
 (89,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:25:30'),
 (90,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:30:45'),
 (91,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:31:27'),
 (92,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:33:39'),
 (93,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:37:36'),
 (94,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:38:18'),
 (95,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:43:39'),
 (96,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:45:07'),
 (97,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:49:09'),
 (98,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:51:35'),
 (99,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:52:46'),
 (100,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-07 17:53:36'),
 (101,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 09:43:07'),
 (102,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 09:51:37'),
 (103,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 09:53:59'),
 (104,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:02:39'),
 (105,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:04:36'),
 (106,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:06:18'),
 (107,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:06:43'),
 (108,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:07:26'),
 (109,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:18:34'),
 (110,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:27:44'),
 (111,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:28:23'),
 (112,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:29:04'),
 (113,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:29:35'),
 (114,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:33:34'),
 (115,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:36:32'),
 (116,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:37:37'),
 (117,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:38:11'),
 (118,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:40:45'),
 (119,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:41:31'),
 (120,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:44:45'),
 (121,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:46:22'),
 (122,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:46:52'),
 (123,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:53:29'),
 (124,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:54:37'),
 (125,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:55:03'),
 (126,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:55:24'),
 (127,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 10:56:15'),
 (128,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:01:44'),
 (129,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:03:39'),
 (130,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:04:54'),
 (131,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:08:35'),
 (132,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:16:00'),
 (133,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:20:54'),
 (134,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:22:14'),
 (135,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:23:08'),
 (136,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:24:10'),
 (137,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:25:45'),
 (138,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:31:05'),
 (139,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:43:58'),
 (140,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:45:44'),
 (141,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:48:20'),
 (142,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:49:26'),
 (143,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:50:51'),
 (144,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:51:40'),
 (145,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 11:52:30'),
 (146,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:34:02'),
 (147,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:37:27'),
 (148,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:40:57'),
 (149,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:44:09'),
 (150,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:44:39'),
 (151,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:45:53'),
 (152,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:46:31'),
 (153,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:48:48'),
 (154,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:49:57'),
 (155,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:51:24'),
 (156,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:52:56'),
 (157,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:53:47'),
 (158,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:55:27'),
 (159,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:57:10'),
 (160,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 13:57:48'),
 (161,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:03:03'),
 (162,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:03:48'),
 (163,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:04:40'),
 (164,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:05:51'),
 (165,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:06:43'),
 (166,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:08:09'),
 (167,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:11:09'),
 (168,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:12:22'),
 (169,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:13:18'),
 (170,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:13:47'),
 (171,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:15:42'),
 (172,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:16:45'),
 (173,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:18:22'),
 (174,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:19:43'),
 (175,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:25:36'),
 (176,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:26:30'),
 (177,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:32:36'),
 (178,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:33:40'),
 (179,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:34:39'),
 (180,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:35:19'),
 (181,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:40:45'),
 (182,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:42:08'),
 (183,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:43:10'),
 (184,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:43:53'),
 (185,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:49:05'),
 (186,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:50:43'),
 (187,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 14:52:52'),
 (188,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:06:36'),
 (189,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:07:45'),
 (190,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:08:08'),
 (191,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:08:47'),
 (192,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:21:49'),
 (193,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:22:52'),
 (194,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:23:48'),
 (195,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:28:52'),
 (196,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:29:55'),
 (197,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:44:15'),
 (198,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:45:04'),
 (199,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:46:01'),
 (200,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:50:54'),
 (201,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:51:20'),
 (202,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:52:50'),
 (203,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:53:51'),
 (204,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:55:43'),
 (205,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:57:18'),
 (206,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:58:11'),
 (207,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 15:59:00'),
 (208,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:00:46'),
 (209,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:02:23'),
 (210,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:04:03'),
 (211,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:04:59'),
 (212,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:06:21'),
 (213,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:07:34'),
 (214,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:10:36'),
 (215,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:15:32'),
 (216,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:16:15'),
 (217,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:17:06'),
 (218,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:18:13'),
 (219,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:18:51'),
 (220,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:19:20'),
 (221,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:20:03'),
 (222,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:21:05'),
 (223,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:23:21'),
 (224,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:23:56'),
 (225,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:24:39'),
 (226,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:25:25'),
 (227,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:26:40'),
 (228,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:32:10'),
 (229,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:34:57'),
 (230,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:37:19'),
 (231,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:38:21'),
 (232,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:40:18'),
 (233,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:42:19'),
 (234,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:44:10'),
 (235,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:46:24'),
 (236,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 16:53:02'),
 (237,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:10:02'),
 (238,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:27:22'),
 (239,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:31:03'),
 (240,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:32:07'),
 (241,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:33:59'),
 (242,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:37:16'),
 (243,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:37:49'),
 (244,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:41:10'),
 (245,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:44:56'),
 (246,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:45:49'),
 (247,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:46:22'),
 (248,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:48:37'),
 (249,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:50:07'),
 (250,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:50:54'),
 (251,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:51:50'),
 (252,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:55:15'),
 (253,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:56:12'),
 (254,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:57:15'),
 (255,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:58:39'),
 (256,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-08 17:59:13'),
 (257,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 11:13:30'),
 (258,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 11:22:24'),
 (259,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 11:24:01'),
 (260,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:06:02'),
 (261,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:07:18'),
 (262,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:10:23'),
 (263,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:11:24'),
 (264,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:13:34'),
 (265,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:14:20'),
 (266,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:20:37'),
 (267,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:23:59'),
 (268,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:28:14'),
 (269,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:30:34'),
 (270,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:30:34'),
 (271,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:31:28'),
 (272,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:33:17'),
 (273,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:37:21'),
 (274,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:37:47'),
 (275,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:39:08'),
 (276,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:45:40'),
 (277,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:46:39'),
 (278,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:48:12'),
 (279,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-09 17:50:32'),
 (280,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 11:45:20'),
 (281,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:17:50'),
 (282,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:19:52'),
 (283,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:20:45'),
 (284,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:21:32'),
 (285,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:31:49'),
 (286,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:32:48'),
 (287,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:35:58'),
 (288,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:46:42'),
 (289,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:47:50'),
 (290,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:48:43'),
 (291,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:50:01'),
 (292,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:53:21'),
 (293,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:54:15'),
 (294,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 13:54:49'),
 (295,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:03:32'),
 (296,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:04:14'),
 (297,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:05:31'),
 (298,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:06:12'),
 (299,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:06:47'),
 (300,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:07:57'),
 (301,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:10:26'),
 (302,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:15:18'),
 (303,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:15:56'),
 (304,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:18:33'),
 (305,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:20:09'),
 (306,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:20:46'),
 (307,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:27:00'),
 (308,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:29:51'),
 (309,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:31:08'),
 (310,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:31:38'),
 (311,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:34:12'),
 (312,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:36:11'),
 (313,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-13 14:38:20'),
 (314,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:23:22'),
 (315,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:27:53'),
 (316,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:29:25'),
 (317,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:35:23'),
 (318,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:36:32'),
 (319,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:37:19'),
 (320,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:39:08'),
 (321,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:40:09'),
 (322,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:41:47'),
 (323,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:42:56'),
 (324,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:43:24'),
 (325,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:45:10'),
 (326,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:46:14'),
 (327,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:49:07'),
 (328,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:50:20'),
 (329,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 10:56:27'),
 (330,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:02:45'),
 (331,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:03:57'),
 (332,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:04:33'),
 (333,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:06:18'),
 (334,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:08:31'),
 (335,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:09:16'),
 (336,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:09:48'),
 (337,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:10:31'),
 (338,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:12:18'),
 (339,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:17:49'),
 (340,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:18:20'),
 (341,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:25:33'),
 (342,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:32:07'),
 (343,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:36:10'),
 (344,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:49:50'),
 (345,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:52:57'),
 (346,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 11:55:38'),
 (347,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 13:49:22'),
 (348,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 13:51:34'),
 (349,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 13:53:23'),
 (350,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 13:54:03'),
 (351,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 13:55:35'),
 (352,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 13:58:59'),
 (353,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 13:59:51'),
 (354,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 14:00:51'),
 (355,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 14:01:30'),
 (356,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 14:02:40'),
 (357,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 14:03:19'),
 (358,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 14:06:28'),
 (359,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 14:07:15'),
 (360,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:07:35'),
 (361,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:08:33'),
 (362,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:12:47'),
 (363,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:20:11'),
 (364,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:31:13'),
 (365,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:32:51'),
 (366,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:54:36'),
 (367,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:56:50'),
 (368,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:57:42'),
 (369,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:59:09'),
 (370,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 15:59:40'),
 (371,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:00:21'),
 (372,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:01:33'),
 (373,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:03:03'),
 (374,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:05:52'),
 (375,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:16:50'),
 (376,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:17:21'),
 (377,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:18:19'),
 (378,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:20:43'),
 (379,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:21:29'),
 (380,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:21:47'),
 (381,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:22:08'),
 (382,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:25:17'),
 (383,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:25:53'),
 (384,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 16:58:39'),
 (385,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:13:44'),
 (386,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:15:57'),
 (387,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:17:09'),
 (388,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:23:26'),
 (389,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:23:53'),
 (390,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:24:39'),
 (391,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:25:08'),
 (392,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:25:59'),
 (393,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:26:58'),
 (394,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:27:34'),
 (395,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-14 17:30:00'),
 (396,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 09:51:51'),
 (397,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 09:52:55'),
 (398,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 09:53:28'),
 (399,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 09:54:31'),
 (400,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 09:55:13'),
 (401,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 09:56:50'),
 (402,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 09:59:03'),
 (403,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 10:00:07'),
 (404,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 10:00:41'),
 (405,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 10:03:21'),
 (406,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 10:03:50'),
 (407,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 10:04:50'),
 (408,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 10:05:20'),
 (409,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 10:12:06'),
 (410,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:16:58'),
 (411,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:19:42'),
 (412,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:20:47'),
 (413,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:23:15'),
 (414,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:24:20'),
 (415,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:25:26'),
 (416,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:26:13'),
 (417,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:27:27'),
 (418,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:28:05'),
 (419,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:28:59'),
 (420,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:29:48'),
 (421,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:34:20'),
 (422,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:37:46'),
 (423,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:42:37'),
 (424,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 11:43:01'),
 (425,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 13:35:45'),
 (426,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 13:38:20'),
 (427,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 13:39:28'),
 (428,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 13:46:27'),
 (429,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 13:48:08'),
 (430,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 13:53:06'),
 (431,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 13:55:42'),
 (432,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 14:01:10'),
 (433,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 14:04:12'),
 (434,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 14:05:31'),
 (435,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 14:08:42'),
 (436,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 14:13:43'),
 (437,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 14:16:09'),
 (438,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-15 14:16:47'),
 (439,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 10:54:08'),
 (440,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 10:56:08'),
 (441,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 10:58:17'),
 (442,'10.19.8.141','drpareda','Registro Usuario','2014-10-27 11:00:56'),
 (443,'10.19.8.141','drpareda','Actualizacion Usuario','2014-10-27 11:01:34'),
 (444,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 11:14:43'),
 (445,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 11:16:34'),
 (446,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 11:17:59'),
 (447,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 11:26:50'),
 (448,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 15:15:07'),
 (449,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 15:55:06'),
 (450,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 15:57:49'),
 (451,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 16:03:43'),
 (452,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 16:31:45'),
 (453,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-27 16:57:48'),
 (454,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 11:45:11'),
 (455,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 11:48:09'),
 (456,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 11:50:51'),
 (457,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 12:01:01'),
 (458,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:20:34'),
 (459,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:23:21'),
 (460,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:24:08'),
 (461,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:26:00'),
 (462,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:27:50'),
 (463,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:30:07'),
 (464,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:30:57'),
 (465,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:31:38'),
 (466,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 13:31:59'),
 (467,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 14:43:00'),
 (468,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 14:43:48'),
 (469,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 14:49:00'),
 (470,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 14:51:44'),
 (471,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 14:54:51'),
 (472,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 14:56:21'),
 (473,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 16:04:11'),
 (474,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 16:10:16'),
 (475,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 16:32:40'),
 (476,'10.19.8.141','drpareda','Registro Usuario','2014-10-28 16:32:58'),
 (477,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 17:00:09'),
 (478,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 17:01:31'),
 (479,'10.19.8.141','drpareda','Registro Usuario','2014-10-28 17:01:51'),
 (480,'10.19.8.141','drpareda','Acceso al Sistema','2014-10-28 17:08:32'),
 (481,'10.19.8.141','drpareda','Registro Usuario','2014-10-28 17:09:33'),
 (482,'192.168.1.124','drpareda','Acceso al Sistema','2014-10-30 19:46:41'),
 (483,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 19:55:15'),
 (484,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 19:56:28'),
 (485,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 19:57:52'),
 (486,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 20:28:51'),
 (487,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 20:37:59'),
 (488,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 20:40:44'),
 (489,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 20:41:25'),
 (490,'192.168.1.124','drpareda','Actualizacion Empleado','2014-11-03 20:41:34'),
 (491,'192.168.1.124','drpareda','Actualizacion Empleado','2014-11-03 20:44:26'),
 (492,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 20:45:15'),
 (493,'192.168.1.124','drpareda','Actualizacion Empleado','2014-11-03 20:45:27'),
 (494,'192.168.1.124','drpareda','Actualizacion Usuario','2014-11-03 20:46:34'),
 (495,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 21:29:48'),
 (496,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 21:30:40'),
 (497,'192.168.1.124','drpareda','Eliminacion Empleado','2014-11-03 21:30:50'),
 (498,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 21:32:24'),
 (499,'192.168.1.124','drpareda','Eliminacion Empleado','2014-11-03 21:32:57'),
 (500,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 21:34:17'),
 (501,'192.168.1.124','drpareda','Eliminacion Empleado','2014-11-03 21:34:43'),
 (502,'192.168.1.124','drpareda','Eliminacion Usuario','2014-11-03 21:35:48'),
 (503,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 21:52:58'),
 (504,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 21:55:55'),
 (505,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 21:56:50'),
 (506,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:04:39'),
 (507,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:05:45'),
 (508,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:09:25'),
 (509,'192.168.1.124','drpareda','Actualizacion Usuario','2014-11-03 22:09:34'),
 (510,'192.168.1.124','drpareda','Eliminacion Usuario','2014-11-03 22:13:19'),
 (511,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:17:56'),
 (512,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:18:26'),
 (513,'192.168.1.124','drpareda','Actualizacion Usuario','2014-11-03 22:19:01'),
 (514,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:19:07'),
 (515,'192.168.1.124','ccalderg','Acceso al Sistema','2014-11-03 22:20:39'),
 (516,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:20:51'),
 (517,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:30:58'),
 (518,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:33:09'),
 (519,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:34:30'),
 (520,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:36:58'),
 (521,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:43:02'),
 (522,'192.168.1.124','drpareda','Registro Cliente','2014-11-03 22:43:15'),
 (523,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:44:08'),
 (524,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:49:44'),
 (525,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:54:57'),
 (526,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 22:59:02'),
 (527,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:00:51'),
 (528,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:02:07'),
 (529,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:05:21'),
 (530,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:10:48'),
 (531,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:39:23'),
 (532,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:45:33'),
 (533,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:50:04'),
 (534,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:51:15'),
 (535,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:53:39'),
 (536,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-03 23:54:49'),
 (537,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:02:49'),
 (538,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:03:20'),
 (539,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:41:02'),
 (540,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:42:33'),
 (541,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:43:16'),
 (542,'192.168.1.124','drpareda','Registro Usuario','2014-11-04 00:43:45'),
 (543,'192.168.1.124','DRPAREDA','Acceso al Sistema','2014-11-04 00:48:09'),
 (544,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:49:20'),
 (545,'192.168.1.124','drpareda','Registro Usuario','2014-11-04 00:49:34'),
 (546,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:52:10'),
 (547,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:53:54'),
 (548,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:55:41'),
 (549,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 00:57:16'),
 (550,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 10:55:54'),
 (551,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 11:14:17'),
 (552,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 11:16:29'),
 (553,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 11:23:43'),
 (554,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 13:54:36'),
 (555,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 14:09:24'),
 (556,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 14:14:39'),
 (557,'10.19.8.141','drpareda','Actualizacion Usuario','2014-11-04 14:15:22'),
 (558,'10.19.8.141','drpareda','Actualizacion Usuario','2014-11-04 14:15:49'),
 (559,'10.19.8.141','drpareda','Actualizacion Usuario','2014-11-04 14:15:56'),
 (560,'10.19.8.141','drpareda','Actualizacion Usuario','2014-11-04 14:17:45'),
 (561,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 14:57:53'),
 (562,'10.19.8.141','drpareda','Actualizacion Usuario','2014-11-04 14:59:11'),
 (563,'10.19.8.141','drpareda','Actualizacion Usuario','2014-11-04 15:00:05'),
 (564,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 15:01:58'),
 (565,'10.19.8.141','drpareda','Acceso al Sistema','2014-11-04 15:07:59'),
 (566,'10.19.8.141','drpareda','Actualizacion Usuario','2014-11-04 15:11:46'),
 (567,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 19:50:58'),
 (568,'192.168.1.124','drpareda','Actualizacion Usuario','2014-11-04 19:51:19'),
 (569,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 19:59:51'),
 (570,'192.168.1.124','drpareda','Actualizacion Usuario','2014-11-04 20:00:26'),
 (571,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:05:58'),
 (572,'192.168.1.124','drpareda','Actualizacion Usuario','2014-11-04 20:06:07'),
 (573,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:17:13'),
 (574,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:18:26'),
 (575,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:21:09'),
 (576,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:23:19'),
 (577,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:32:08'),
 (578,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:40:11'),
 (579,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:44:04'),
 (580,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:51:04'),
 (581,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:52:07'),
 (582,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:53:11'),
 (583,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:53:51'),
 (584,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:56:37'),
 (585,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:57:59'),
 (586,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 20:58:54'),
 (587,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:00:30'),
 (588,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:02:18'),
 (589,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:09:19'),
 (590,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:10:58'),
 (591,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:11:40'),
 (592,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:12:52'),
 (593,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:15:05'),
 (594,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:17:40'),
 (595,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:18:43'),
 (596,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:19:59'),
 (597,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:20:43'),
 (598,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:22:35'),
 (599,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:23:06'),
 (600,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:31:53'),
 (601,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:34:36'),
 (602,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:36:08'),
 (603,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:37:22'),
 (604,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 21:38:52'),
 (605,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:00:36'),
 (606,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:05:38'),
 (607,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:06:43'),
 (608,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:08:35'),
 (609,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:09:11'),
 (610,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:10:51'),
 (611,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:12:26'),
 (612,'192.168.1.124','drpareda','Registro Cliente','2014-11-04 22:12:38'),
 (613,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:22:46'),
 (614,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:24:28'),
 (615,'192.168.1.124','drpareda','Registro Cliente','2014-11-04 22:24:55'),
 (616,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:26:41'),
 (617,'192.168.1.124','drpareda','Registro Cliente','2014-11-04 22:26:55'),
 (618,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:27:33'),
 (619,'192.168.1.124','drpareda','Registro Cliente','2014-11-04 22:28:04'),
 (620,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:30:01'),
 (621,'192.168.1.124','drpareda','Registro Cliente','2014-11-04 22:30:16'),
 (622,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:37:43'),
 (623,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:47:32'),
 (624,'192.168.1.124','drpareda','Actualizacion Cliente','2014-11-04 22:47:42'),
 (625,'192.168.1.124','drpareda','Actualizacion Cliente','2014-11-04 22:48:02'),
 (626,'192.168.1.124','drpareda','Eliminacion Cliente','2014-11-04 22:48:35'),
 (627,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:51:37'),
 (628,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 22:53:09'),
 (629,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 23:01:04'),
 (630,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-04 23:03:40'),
 (631,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:05:32'),
 (632,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:08:34'),
 (633,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:09:20'),
 (634,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:10:12'),
 (635,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:13:27'),
 (636,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:16:56'),
 (637,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:19:44'),
 (638,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:21:11'),
 (639,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:22:27'),
 (640,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:25:06'),
 (641,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:26:58'),
 (642,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:28:37'),
 (643,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:29:11'),
 (644,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:29:40'),
 (645,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:31:29'),
 (646,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:32:57'),
 (647,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:35:17'),
 (648,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:37:57'),
 (649,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:39:37'),
 (650,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:41:57'),
 (651,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:43:28'),
 (652,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:44:55'),
 (653,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:47:29'),
 (654,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:48:30'),
 (655,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:49:16'),
 (656,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:50:57'),
 (657,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:51:51'),
 (658,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:52:30'),
 (659,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 11:55:46'),
 (660,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:01:27'),
 (661,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:03:36'),
 (662,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:04:34'),
 (663,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:07:19'),
 (664,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:18:11'),
 (665,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:19:54'),
 (666,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:20:58'),
 (667,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:22:25'),
 (668,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:23:07'),
 (669,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:23:48'),
 (670,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:24:17'),
 (671,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:27:43'),
 (672,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:29:02'),
 (673,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:43:09'),
 (674,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:44:19'),
 (675,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:46:12'),
 (676,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:47:04'),
 (677,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:47:40'),
 (678,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:48:38'),
 (679,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:49:12'),
 (680,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:49:46'),
 (681,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:52:28'),
 (682,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:54:37'),
 (683,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:55:49'),
 (684,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:57:17'),
 (685,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 12:59:52'),
 (686,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:01:01'),
 (687,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:01:41'),
 (688,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:03:14'),
 (689,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:04:18'),
 (690,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:05:56'),
 (691,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:08:02'),
 (692,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:08:49'),
 (693,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:09:23'),
 (694,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:09:50'),
 (695,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:13:15'),
 (696,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:13:52'),
 (697,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:19:56'),
 (698,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:41:05'),
 (699,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:42:05'),
 (700,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:42:40'),
 (701,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:54:17'),
 (702,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:55:16'),
 (703,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 13:59:43'),
 (704,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:08:48'),
 (705,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:10:45'),
 (706,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:11:28'),
 (707,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:12:02'),
 (708,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:13:02'),
 (709,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:14:07'),
 (710,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:15:43'),
 (711,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:17:19'),
 (712,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:18:43'),
 (713,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:25:26'),
 (714,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:35:24'),
 (715,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:42:59'),
 (716,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:43:52'),
 (717,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:46:00'),
 (718,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:46:35'),
 (719,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:48:29'),
 (720,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:55:02'),
 (721,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:56:36'),
 (722,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 14:59:16'),
 (723,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 15:09:27'),
 (724,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 15:12:46'),
 (725,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 15:13:39'),
 (726,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 15:14:54'),
 (727,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 15:15:31'),
 (728,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 15:16:52'),
 (729,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 19:46:56'),
 (730,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 19:47:38'),
 (731,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 19:48:20'),
 (732,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 19:49:59'),
 (733,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 19:50:33'),
 (734,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 19:59:42'),
 (735,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:00:46'),
 (736,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:06:26'),
 (737,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:11:09'),
 (738,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:13:48'),
 (739,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:17:24'),
 (740,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:18:11'),
 (741,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:19:15'),
 (742,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:20:55'),
 (743,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:23:42'),
 (744,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:27:13'),
 (745,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:28:25'),
 (746,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:31:39'),
 (747,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:43:47'),
 (748,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:45:26'),
 (749,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:47:53'),
 (750,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:49:30'),
 (751,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:52:18'),
 (752,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:53:17'),
 (753,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:54:41'),
 (754,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 20:59:08'),
 (755,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:01:46'),
 (756,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:03:06'),
 (757,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:11:37'),
 (758,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:16:35'),
 (759,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:28:38'),
 (760,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:38:57'),
 (761,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:41:07'),
 (762,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:49:00'),
 (763,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:50:55'),
 (764,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:53:37'),
 (765,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:57:18'),
 (766,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:58:56'),
 (767,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 21:59:32'),
 (768,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:01:25'),
 (769,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:03:00'),
 (770,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:04:59'),
 (771,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:11:08'),
 (772,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:13:00'),
 (773,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:15:30'),
 (774,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:16:32'),
 (775,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:20:49'),
 (776,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:22:28'),
 (777,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:37:28'),
 (778,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:43:56'),
 (779,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:47:23'),
 (780,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:48:11'),
 (781,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:49:30'),
 (782,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:50:16'),
 (783,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:51:45'),
 (784,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:52:32'),
 (785,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:55:03'),
 (786,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:56:41'),
 (787,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:57:30'),
 (788,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:58:47'),
 (789,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 22:59:41'),
 (790,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:01:10'),
 (791,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:03:08'),
 (792,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:05:13'),
 (793,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:06:31'),
 (794,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:08:06'),
 (795,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:09:31'),
 (796,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:12:44'),
 (797,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:13:37'),
 (798,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:17:48'),
 (799,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:19:40'),
 (800,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:22:14'),
 (801,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:23:07'),
 (802,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:24:54'),
 (803,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-09 23:25:31'),
 (804,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:29:59'),
 (805,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:31:35'),
 (806,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:32:46'),
 (807,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:34:03'),
 (808,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:34:51'),
 (809,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:35:49'),
 (810,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:38:43'),
 (811,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:39:58'),
 (812,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:40:32'),
 (813,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:41:34'),
 (814,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:42:16'),
 (815,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:44:37'),
 (816,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:45:56'),
 (817,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:46:52'),
 (818,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:48:09'),
 (819,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:49:12'),
 (820,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:50:20'),
 (821,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:54:10'),
 (822,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:55:47'),
 (823,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 20:57:05'),
 (824,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:02:30'),
 (825,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:03:16'),
 (826,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:03:52'),
 (827,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:04:18'),
 (828,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:04:41'),
 (829,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:05:45'),
 (830,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:06:11'),
 (831,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:06:38'),
 (832,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:07:05'),
 (833,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:07:31'),
 (834,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:07:54'),
 (835,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:10:57'),
 (836,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:11:56'),
 (837,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:13:08'),
 (838,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:13:39'),
 (839,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:15:04'),
 (840,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:16:17'),
 (841,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:17:18'),
 (842,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:19:16'),
 (843,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:20:26'),
 (844,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:21:22'),
 (845,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:26:31');
INSERT INTO `inv_log_transacciones` (`codigo`,`ip`,`usuario`,`accion`,`fecha`) VALUES 
 (846,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:27:26'),
 (847,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:28:47'),
 (848,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:32:00'),
 (849,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:33:34'),
 (850,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:34:54'),
 (851,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:41:20'),
 (852,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 21:46:47'),
 (853,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 22:43:33'),
 (854,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 22:52:42'),
 (855,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 22:53:57'),
 (856,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 22:54:58'),
 (857,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 22:58:11'),
 (858,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:00:53'),
 (859,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:03:07'),
 (860,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:03:56'),
 (861,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:07:31'),
 (862,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:09:09'),
 (863,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:12:28'),
 (864,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:19:13'),
 (865,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:20:26'),
 (866,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:22:24'),
 (867,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:24:32'),
 (868,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-11 23:25:08'),
 (869,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 22:20:27'),
 (870,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 22:22:06'),
 (871,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 22:34:02'),
 (872,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 22:47:32'),
 (873,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 22:54:41'),
 (874,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 22:56:50'),
 (875,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:10:15'),
 (876,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:11:44'),
 (877,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:13:24'),
 (878,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:22:17'),
 (879,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:28:26'),
 (880,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:29:27'),
 (881,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:32:38'),
 (882,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-13 23:34:50'),
 (883,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 16:15:30'),
 (884,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 16:20:54'),
 (885,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 16:24:16'),
 (886,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 16:36:29'),
 (887,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 16:38:26'),
 (888,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 16:57:13'),
 (889,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:05:02'),
 (890,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:05:35'),
 (891,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:08:48'),
 (892,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:17:18'),
 (893,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:22:26'),
 (894,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:36:31'),
 (895,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:51:54'),
 (896,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:56:31'),
 (897,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 17:58:30'),
 (898,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:02:41'),
 (899,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:05:46'),
 (900,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:07:07'),
 (901,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:12:51'),
 (902,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:15:39'),
 (903,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:33:22'),
 (904,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:35:44'),
 (905,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:46:04'),
 (906,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:53:09'),
 (907,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:54:07'),
 (908,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:55:00'),
 (909,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:55:54'),
 (910,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 18:58:35'),
 (911,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:04:05'),
 (912,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:05:18'),
 (913,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:12:01'),
 (914,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:13:33'),
 (915,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:14:13'),
 (916,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:15:05'),
 (917,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:25:45'),
 (918,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:26:58'),
 (919,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:27:35'),
 (920,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:29:03'),
 (921,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:31:11'),
 (922,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:31:38'),
 (923,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:32:12'),
 (924,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 19:56:22'),
 (925,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:00:58'),
 (926,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:02:01'),
 (927,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:02:50'),
 (928,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:06:59'),
 (929,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:09:46'),
 (930,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:15:37'),
 (931,'192.168.1.124','DRPAREDA','Acceso al Sistema','2014-11-16 20:32:06'),
 (932,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:36:25'),
 (933,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:38:40'),
 (934,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:43:48'),
 (935,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:45:38'),
 (936,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:46:36'),
 (937,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:49:57'),
 (938,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 20:58:36'),
 (939,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:00:08'),
 (940,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:02:41'),
 (941,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:04:40'),
 (942,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:06:07'),
 (943,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:06:43'),
 (944,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:07:21'),
 (945,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:08:25'),
 (946,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:12:02'),
 (947,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:12:46'),
 (948,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:13:26'),
 (949,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:14:30'),
 (950,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:19:19'),
 (951,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:20:49'),
 (952,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:23:12'),
 (953,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:24:32'),
 (954,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:25:07'),
 (955,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:26:23'),
 (956,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:27:58'),
 (957,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:29:45'),
 (958,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 21:32:17'),
 (959,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:03:44'),
 (960,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:04:52'),
 (961,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:06:24'),
 (962,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:09:02'),
 (963,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:11:25'),
 (964,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:13:30'),
 (965,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:14:53'),
 (966,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:15:47'),
 (967,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:19:06'),
 (968,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:21:11'),
 (969,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:22:46'),
 (970,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:23:26'),
 (971,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:39:49'),
 (972,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:40:24'),
 (973,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:42:49'),
 (974,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:44:08'),
 (975,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:49:50'),
 (976,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:50:28'),
 (977,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:51:52'),
 (978,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:52:48'),
 (979,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:54:14'),
 (980,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:55:19'),
 (981,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:56:37'),
 (982,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:58:39'),
 (983,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 22:59:42'),
 (984,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:04:53'),
 (985,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:16:37'),
 (986,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:17:24'),
 (987,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:18:33'),
 (988,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:19:08'),
 (989,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:22:34'),
 (990,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:26:14'),
 (991,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:28:52'),
 (992,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:30:25'),
 (993,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:31:25'),
 (994,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:32:00'),
 (995,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:35:29'),
 (996,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:38:01'),
 (997,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:41:40'),
 (998,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:42:56'),
 (999,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:48:30'),
 (1000,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:50:31'),
 (1001,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:54:55'),
 (1002,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-16 23:58:32'),
 (1003,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-17 00:01:53'),
 (1004,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-17 00:02:24'),
 (1005,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-17 00:05:24'),
 (1006,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-17 00:07:07'),
 (1007,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-17 00:07:48'),
 (1008,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-17 00:08:39'),
 (1009,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:18:16'),
 (1010,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:24:40'),
 (1011,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:27:41'),
 (1012,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:33:13'),
 (1013,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:39:57'),
 (1014,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:43:18'),
 (1015,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:46:19'),
 (1016,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:48:26'),
 (1017,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:49:46'),
 (1018,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 19:54:10'),
 (1019,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 20:12:04'),
 (1020,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 20:16:39'),
 (1021,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 20:19:38'),
 (1022,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 20:40:04'),
 (1023,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 20:42:11'),
 (1024,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 20:45:44'),
 (1025,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 21:00:50'),
 (1026,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 21:14:32'),
 (1027,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 21:18:20'),
 (1028,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 21:21:49'),
 (1029,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 22:24:37'),
 (1030,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 22:41:08'),
 (1031,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-18 23:11:50'),
 (1032,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:02:16'),
 (1033,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:07:53'),
 (1034,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:15:17'),
 (1035,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:18:48'),
 (1036,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:22:07'),
 (1037,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:26:26'),
 (1038,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:31:36'),
 (1039,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:33:57'),
 (1040,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:34:39'),
 (1041,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:35:44'),
 (1042,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:36:52'),
 (1043,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:37:34'),
 (1044,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:38:33'),
 (1045,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:44:23'),
 (1046,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:45:07'),
 (1047,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:47:21'),
 (1048,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:48:53'),
 (1049,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:50:31'),
 (1050,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:51:28'),
 (1051,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:52:52'),
 (1052,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:56:57'),
 (1053,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 22:58:37'),
 (1054,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:00:11'),
 (1055,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:00:52'),
 (1056,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:01:50'),
 (1057,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:02:33'),
 (1058,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:04:09'),
 (1059,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:04:55'),
 (1060,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:06:30'),
 (1061,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:07:41'),
 (1062,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:09:54'),
 (1063,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:11:32'),
 (1064,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:13:32'),
 (1065,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:14:20'),
 (1066,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:15:29'),
 (1067,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:17:09'),
 (1068,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-20 23:18:27'),
 (1069,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 19:34:31'),
 (1070,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 19:37:48'),
 (1071,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 20:45:19'),
 (1072,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 20:47:14'),
 (1073,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 20:49:50'),
 (1074,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 20:51:43'),
 (1075,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 20:53:01'),
 (1076,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 20:55:37'),
 (1077,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 20:58:35'),
 (1078,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:00:28'),
 (1079,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:02:54'),
 (1080,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:04:01'),
 (1081,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:06:06'),
 (1082,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:07:32'),
 (1083,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:09:14'),
 (1084,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:12:46'),
 (1085,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:14:21'),
 (1086,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:16:01'),
 (1087,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:19:05'),
 (1088,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:22:37'),
 (1089,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:23:39'),
 (1090,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:24:47'),
 (1091,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:27:20'),
 (1092,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:29:20'),
 (1093,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:31:07'),
 (1094,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:33:58'),
 (1095,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:36:08'),
 (1096,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:37:32'),
 (1097,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:38:17'),
 (1098,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:38:59'),
 (1099,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:40:04'),
 (1100,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-21 21:41:06'),
 (1101,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 20:51:30'),
 (1102,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 20:56:25'),
 (1103,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:01:29'),
 (1104,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:06:32'),
 (1105,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:08:03'),
 (1106,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:11:43'),
 (1107,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:13:58'),
 (1108,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:16:21'),
 (1109,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:19:22'),
 (1110,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:24:21'),
 (1111,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:26:12'),
 (1112,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:28:24'),
 (1113,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:30:29'),
 (1114,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:31:35'),
 (1115,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:34:40'),
 (1116,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:36:53'),
 (1117,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:37:40'),
 (1118,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:39:57'),
 (1119,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:41:21'),
 (1120,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:43:28'),
 (1121,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:44:17'),
 (1122,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:46:33'),
 (1123,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:47:57'),
 (1124,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:48:46'),
 (1125,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:49:43'),
 (1126,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:50:38'),
 (1127,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:51:36'),
 (1128,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:54:13'),
 (1129,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:54:56'),
 (1130,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:55:49'),
 (1131,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:56:28'),
 (1132,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 21:58:12'),
 (1133,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:02:01'),
 (1134,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:03:40'),
 (1135,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:06:17'),
 (1136,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:07:11'),
 (1137,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:07:51'),
 (1138,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:08:27'),
 (1139,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:09:07'),
 (1140,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:11:00'),
 (1141,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:13:21'),
 (1142,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:15:20'),
 (1143,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:19:14'),
 (1144,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 22:51:50'),
 (1145,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 23:08:27'),
 (1146,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-25 23:13:10'),
 (1147,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 21:18:11'),
 (1148,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 21:23:34'),
 (1149,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 21:25:46'),
 (1150,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 21:28:29'),
 (1151,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 21:32:43'),
 (1152,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 21:36:58'),
 (1153,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 22:13:56'),
 (1154,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 22:16:44'),
 (1155,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:05:20'),
 (1156,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:08:15'),
 (1157,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:09:16'),
 (1158,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:14:19'),
 (1159,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:14:40'),
 (1160,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:15:28'),
 (1161,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:19:08'),
 (1162,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:19:38'),
 (1163,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:26:44'),
 (1164,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:27:05'),
 (1165,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:31:20'),
 (1166,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:32:39'),
 (1167,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:38:17'),
 (1168,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:38:37'),
 (1169,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:39:40'),
 (1170,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:39:59'),
 (1171,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:43:42'),
 (1172,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:44:05'),
 (1173,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-27 23:46:30'),
 (1174,'192.168.1.124','drpareda','Registro Pedido','2014-11-27 23:46:47'),
 (1175,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 22:30:24'),
 (1176,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 22:32:50'),
 (1177,'192.168.1.124','drpareda','Registro Pedido','2014-11-30 22:34:14'),
 (1178,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 22:38:22'),
 (1179,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 22:45:06'),
 (1180,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 22:54:14'),
 (1181,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 22:56:34'),
 (1182,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 23:04:08'),
 (1183,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 23:09:19'),
 (1184,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 23:11:42'),
 (1185,'192.168.1.124','drpareda','Registro Pedido','2014-11-30 23:12:27'),
 (1186,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 23:14:21'),
 (1187,'192.168.1.124','drpareda','Registro Pedido','2014-11-30 23:14:46'),
 (1188,'192.168.1.124','drpareda','Acceso al Sistema','2014-11-30 23:25:19'),
 (1189,'192.168.1.124','drpareda','Registro Pedido','2014-11-30 23:26:58'),
 (1190,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 20:39:36'),
 (1191,'192.168.1.124','drpareda','Registro Pedido','2014-12-02 20:40:15'),
 (1192,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 20:43:38'),
 (1193,'192.168.1.124','drpareda','Registro Pedido','2014-12-02 20:44:19'),
 (1194,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 20:46:35'),
 (1195,'192.168.1.124','drpareda','Registro Pedido','2014-12-02 20:47:10'),
 (1196,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 20:48:12'),
 (1197,'192.168.1.124','drpareda','Registro Pedido','2014-12-02 20:48:48'),
 (1198,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 20:50:01'),
 (1199,'192.168.1.124','drpareda','Registro Pedido','2014-12-02 20:50:41'),
 (1200,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 20:57:44'),
 (1201,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 21:02:20'),
 (1202,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 21:16:07'),
 (1203,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 21:18:00'),
 (1204,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 21:20:53'),
 (1205,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-02 21:22:01'),
 (1206,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-03 00:30:11'),
 (1207,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 19:58:03'),
 (1208,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 20:02:39'),
 (1209,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 20:03:07'),
 (1210,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 20:03:34'),
 (1211,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 20:04:23'),
 (1212,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 20:04:55'),
 (1213,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 20:31:33'),
 (1214,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 20:48:32'),
 (1215,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 21:14:20'),
 (1216,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 21:31:43'),
 (1217,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 21:33:17'),
 (1218,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 21:34:27'),
 (1219,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 21:36:34'),
 (1220,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 21:37:21'),
 (1221,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 21:44:34'),
 (1222,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:01:56'),
 (1223,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:16:14'),
 (1224,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:18:11'),
 (1225,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:21:18'),
 (1226,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:52:48'),
 (1227,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:54:18'),
 (1228,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:54:44'),
 (1229,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 22:56:31'),
 (1230,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:06:58'),
 (1231,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:09:13'),
 (1232,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:10:19'),
 (1233,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:11:17'),
 (1234,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:15:17'),
 (1235,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:18:32'),
 (1236,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:21:48'),
 (1237,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:23:01'),
 (1238,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:27:14'),
 (1239,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:28:18'),
 (1240,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:37:59'),
 (1241,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:38:53'),
 (1242,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:43:14'),
 (1243,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:44:00'),
 (1244,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:44:32'),
 (1245,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:46:09'),
 (1246,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:55:52'),
 (1247,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:56:33'),
 (1248,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-08 23:57:30'),
 (1249,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:00:10'),
 (1250,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:02:53'),
 (1251,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:04:19'),
 (1252,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:07:25'),
 (1253,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:08:50'),
 (1254,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:12:25'),
 (1255,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:14:01'),
 (1256,'192.168.1.124','drpareda','Acceso al Sistema','2014-12-09 00:14:42'),
 (1257,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 21:34:07'),
 (1258,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 21:40:17'),
 (1259,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 22:50:35'),
 (1260,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 22:51:49'),
 (1261,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 22:56:39'),
 (1262,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 22:57:31'),
 (1263,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:02:12'),
 (1264,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:03:10'),
 (1265,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:08:41'),
 (1266,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:11:39'),
 (1267,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:12:46'),
 (1268,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:13:31'),
 (1269,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:19:10'),
 (1270,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:31:15'),
 (1271,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:48:52'),
 (1272,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:50:08'),
 (1273,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:52:04'),
 (1274,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:53:03'),
 (1275,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:54:51'),
 (1276,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-11 23:58:22'),
 (1277,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 00:01:16'),
 (1278,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 00:03:01'),
 (1279,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 00:08:25'),
 (1280,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 00:09:18'),
 (1281,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 00:11:04'),
 (1282,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 00:13:22'),
 (1283,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 00:15:03'),
 (1284,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:06:46'),
 (1285,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:08:36'),
 (1286,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:11:39'),
 (1287,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:16:35'),
 (1288,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:18:00'),
 (1289,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:18:51'),
 (1290,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:19:29'),
 (1291,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 22:22:48'),
 (1292,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:13:14'),
 (1293,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:16:22'),
 (1294,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:17:02'),
 (1295,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:32:42'),
 (1296,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:33:41'),
 (1297,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:36:17'),
 (1298,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:36:58'),
 (1299,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:38:47'),
 (1300,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:40:07'),
 (1301,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:41:43'),
 (1302,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:42:38'),
 (1303,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:44:17'),
 (1304,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-12 23:52:25'),
 (1305,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 00:56:17'),
 (1306,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 00:57:23'),
 (1307,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 00:59:14'),
 (1308,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:00:18'),
 (1309,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:02:16'),
 (1310,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:03:24'),
 (1311,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:04:40'),
 (1312,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:08:15'),
 (1313,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:09:06'),
 (1314,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:09:48'),
 (1315,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:10:34'),
 (1316,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:12:40'),
 (1317,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:14:58'),
 (1318,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:15:51'),
 (1319,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:16:54'),
 (1320,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:18:25'),
 (1321,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:19:51'),
 (1322,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:22:08'),
 (1323,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:23:39'),
 (1324,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 01:24:17'),
 (1325,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:25:28'),
 (1326,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:28:06'),
 (1327,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:30:47'),
 (1328,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:35:57'),
 (1329,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:39:08'),
 (1330,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:42:18'),
 (1331,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:44:47'),
 (1332,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:46:48'),
 (1333,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:49:54'),
 (1334,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:51:04'),
 (1335,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 13:59:40'),
 (1336,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:06:45'),
 (1337,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:09:07'),
 (1338,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:10:02'),
 (1339,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:13:15'),
 (1340,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:16:13'),
 (1341,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:17:25'),
 (1342,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:20:27'),
 (1343,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:21:34'),
 (1344,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:23:29'),
 (1345,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:25:14'),
 (1346,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:26:18'),
 (1347,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:28:12'),
 (1348,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:30:08'),
 (1349,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:30:51'),
 (1350,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:31:44'),
 (1351,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:33:09'),
 (1352,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:34:52'),
 (1353,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:35:41'),
 (1354,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:37:10'),
 (1355,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:38:33'),
 (1356,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:41:30'),
 (1357,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:42:26'),
 (1358,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:44:39'),
 (1359,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:46:48'),
 (1360,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:49:23'),
 (1361,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:51:13'),
 (1362,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:53:06'),
 (1363,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:55:07'),
 (1364,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:56:01'),
 (1365,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:57:16'),
 (1366,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 14:58:32'),
 (1367,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:00:25'),
 (1368,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:00:59'),
 (1369,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:02:59'),
 (1370,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:07:25'),
 (1371,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:08:47'),
 (1372,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:13:45'),
 (1373,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:14:54'),
 (1374,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:16:57'),
 (1375,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:25:39'),
 (1376,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:27:19'),
 (1377,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:29:40'),
 (1378,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:34:52'),
 (1379,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 15:59:51'),
 (1380,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:06:32'),
 (1381,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:10:11'),
 (1382,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:14:09'),
 (1383,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:16:48'),
 (1384,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:28:50'),
 (1385,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:30:38'),
 (1386,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:31:42'),
 (1387,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:47:49'),
 (1388,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:49:07'),
 (1389,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 16:50:44'),
 (1390,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:01:26'),
 (1391,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:06:32'),
 (1392,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:12:35'),
 (1393,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:14:26'),
 (1394,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:15:56'),
 (1395,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:21:06'),
 (1396,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:22:07'),
 (1397,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:22:53'),
 (1398,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:23:38'),
 (1399,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:24:22'),
 (1400,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:26:51'),
 (1401,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:27:35'),
 (1402,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:28:06'),
 (1403,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:33:58'),
 (1404,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:40:05'),
 (1405,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:42:19'),
 (1406,'192.168.1.127','drpareda','Registro Pedido','2014-12-13 17:42:55'),
 (1407,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-13 17:44:19'),
 (1408,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 17:29:18'),
 (1409,'192.168.1.127','DRPAREDA','Acceso al Sistema','2014-12-14 17:52:37'),
 (1410,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:13:32'),
 (1411,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:21:27'),
 (1412,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:22:11'),
 (1413,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:23:38'),
 (1414,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:24:32'),
 (1415,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:25:02'),
 (1416,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:27:32'),
 (1417,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:31:08'),
 (1418,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:32:10'),
 (1419,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 18:33:12'),
 (1420,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:38:27'),
 (1421,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:40:02'),
 (1422,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:41:37'),
 (1423,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:44:11'),
 (1424,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:48:46'),
 (1425,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:51:07'),
 (1426,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:56:52'),
 (1427,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-14 21:58:31'),
 (1428,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:00:07'),
 (1429,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 00:00:47'),
 (1430,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:05:09'),
 (1431,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:08:20'),
 (1432,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:11:05'),
 (1433,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:12:13'),
 (1434,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:14:52'),
 (1435,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:16:14'),
 (1436,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:19:25'),
 (1437,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:21:42'),
 (1438,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:22:32'),
 (1439,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:25:23'),
 (1440,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:27:06'),
 (1441,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:30:01'),
 (1442,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 00:34:08'),
 (1443,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 00:34:33'),
 (1444,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 20:51:27'),
 (1445,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 20:51:56'),
 (1446,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 20:54:01'),
 (1447,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 20:54:37'),
 (1448,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 21:04:03'),
 (1449,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 21:04:27'),
 (1450,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 21:06:43'),
 (1451,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 21:07:20'),
 (1452,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 21:21:33'),
 (1453,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 21:22:14'),
 (1454,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 21:28:04'),
 (1455,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 21:28:24'),
 (1456,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 21:36:16'),
 (1457,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 21:36:48'),
 (1458,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 21:45:14'),
 (1459,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 22:49:38'),
 (1460,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 22:50:03'),
 (1461,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 22:59:15'),
 (1462,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 22:59:45'),
 (1463,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:03:22'),
 (1464,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:05:56'),
 (1465,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:07:10'),
 (1466,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:17:06'),
 (1467,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:17:32'),
 (1468,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:19:07'),
 (1469,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:19:37'),
 (1470,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:27:17'),
 (1471,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:27:39'),
 (1472,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:30:11'),
 (1473,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:30:42'),
 (1474,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:42:05'),
 (1475,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:42:24'),
 (1476,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:42:52'),
 (1477,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:51:07'),
 (1478,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:51:37'),
 (1479,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:52:35'),
 (1480,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:53:14'),
 (1481,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:53:58'),
 (1482,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:54:58'),
 (1483,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-15 23:55:30'),
 (1484,'192.168.1.127','drpareda','Registro Pedido','2014-12-15 23:55:51'),
 (1485,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-16 00:03:31'),
 (1486,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-16 00:05:03'),
 (1487,'192.168.1.127','drpareda','Registro Pedido','2014-12-16 00:05:22'),
 (1488,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-16 22:02:23'),
 (1489,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-16 22:06:25'),
 (1490,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-16 22:15:13'),
 (1491,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-16 23:21:20'),
 (1492,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 13:27:33'),
 (1493,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 14:24:20'),
 (1494,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 14:35:49'),
 (1495,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 14:46:03'),
 (1496,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 14:46:04'),
 (1497,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 14:46:07'),
 (1498,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 14:54:00'),
 (1499,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 16:29:03'),
 (1500,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 16:30:10'),
 (1501,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 16:33:24'),
 (1502,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 16:38:31'),
 (1503,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 16:44:36'),
 (1504,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 16:47:52'),
 (1505,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:07:25'),
 (1506,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:18:49'),
 (1507,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:27:15'),
 (1508,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:28:33'),
 (1509,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:31:14'),
 (1510,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:37:54'),
 (1511,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:44:03'),
 (1512,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-18 17:46:39'),
 (1513,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-19 10:05:55'),
 (1514,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 18:58:41'),
 (1515,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:06:30'),
 (1516,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:10:49'),
 (1517,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:13:27'),
 (1518,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:14:19'),
 (1519,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:16:45'),
 (1520,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:22:31'),
 (1521,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:24:29'),
 (1522,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:25:45'),
 (1523,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:28:06'),
 (1524,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:30:16'),
 (1525,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:31:39'),
 (1526,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:34:13'),
 (1527,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:37:17'),
 (1528,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:38:33'),
 (1529,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:42:29'),
 (1530,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:46:11'),
 (1531,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:54:46'),
 (1532,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 19:59:28'),
 (1533,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 20:03:38'),
 (1534,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 20:05:08'),
 (1535,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 20:07:06'),
 (1536,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 20:08:33'),
 (1537,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 23:03:51'),
 (1538,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 23:15:27'),
 (1539,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 23:17:03'),
 (1540,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 23:18:29'),
 (1541,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 23:22:09'),
 (1542,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-20 23:36:32'),
 (1543,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:18:18'),
 (1544,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:19:58'),
 (1545,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:21:16'),
 (1546,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:22:32'),
 (1547,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:23:37'),
 (1548,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:24:52'),
 (1549,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:26:28'),
 (1550,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:28:16'),
 (1551,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:39:20'),
 (1552,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:44:16'),
 (1553,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 00:54:19'),
 (1554,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 01:01:14'),
 (1555,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 18:45:04'),
 (1556,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 18:51:17'),
 (1557,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 19:12:39'),
 (1558,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 19:24:35'),
 (1559,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 19:25:45'),
 (1560,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 19:27:26'),
 (1561,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 19:28:36'),
 (1562,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 19:51:33'),
 (1563,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 21:10:47'),
 (1564,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 21:20:50'),
 (1565,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 21:52:25'),
 (1566,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 21:54:38'),
 (1567,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 21:58:01'),
 (1568,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:12:37'),
 (1569,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:14:03'),
 (1570,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:15:09'),
 (1571,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:16:03'),
 (1572,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:17:31'),
 (1573,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:31:57'),
 (1574,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:33:58'),
 (1575,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:37:40'),
 (1576,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-21 22:39:21'),
 (1577,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:32:54'),
 (1578,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:35:46'),
 (1579,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:40:22'),
 (1580,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:41:21'),
 (1581,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:43:20'),
 (1582,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:45:55'),
 (1583,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:54:44'),
 (1584,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 10:59:52'),
 (1585,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 11:02:32'),
 (1586,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 11:04:21'),
 (1587,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 11:09:43'),
 (1588,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 11:13:48'),
 (1589,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 11:22:59'),
 (1590,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 13:47:28'),
 (1591,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 13:49:42'),
 (1592,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 13:55:13'),
 (1593,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:00:38'),
 (1594,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:01:22'),
 (1595,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:03:51'),
 (1596,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:04:46'),
 (1597,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:06:53'),
 (1598,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:29:27'),
 (1599,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:30:20'),
 (1600,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:31:22'),
 (1601,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:32:24'),
 (1602,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:33:21'),
 (1603,'10.19.8.141','drpareda','Acceso al Sistema','2014-12-22 14:36:49'),
 (1604,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 19:58:28'),
 (1605,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:03:36'),
 (1606,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:03:53'),
 (1607,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:09:15'),
 (1608,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:12:16'),
 (1609,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:13:39'),
 (1610,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:15:05'),
 (1611,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:16:27'),
 (1612,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:17:51'),
 (1613,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:19:22'),
 (1614,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:20:15'),
 (1615,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:23:01'),
 (1616,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:23:47'),
 (1617,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:27:05'),
 (1618,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:29:27'),
 (1619,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:30:10'),
 (1620,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:33:52'),
 (1621,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:37:24'),
 (1622,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:38:47'),
 (1623,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:39:15'),
 (1624,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:42:42'),
 (1625,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:49:34'),
 (1626,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:51:22'),
 (1627,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:52:54'),
 (1628,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 20:58:17'),
 (1629,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:01:56'),
 (1630,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:05:14'),
 (1631,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:05:54'),
 (1632,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:07:02'),
 (1633,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:08:12'),
 (1634,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:09:02'),
 (1635,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:09:54'),
 (1636,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:13:49'),
 (1637,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:16:23'),
 (1638,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:17:56'),
 (1639,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:18:36'),
 (1640,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:25:56'),
 (1641,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:27:57'),
 (1642,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:35:10'),
 (1643,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:35:54'),
 (1644,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:36:48'),
 (1645,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:38:07'),
 (1646,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:40:52'),
 (1647,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:42:17'),
 (1648,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:48:57'),
 (1649,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:51:47'),
 (1650,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:53:10'),
 (1651,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:55:40'),
 (1652,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:57:59'),
 (1653,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 21:59:16'),
 (1654,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:00:30'),
 (1655,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:01:49'),
 (1656,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:03:02'),
 (1657,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:04:05'),
 (1658,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:05:25'),
 (1659,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:08:22'),
 (1660,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:09:07'),
 (1661,'192.168.1.127','drpareda','Registro Pedido','2014-12-22 22:09:28'),
 (1662,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 22:14:17'),
 (1663,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:05:13'),
 (1664,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:06:22'),
 (1665,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:09:13'),
 (1666,'192.168.1.127','DRPAREDA','Acceso al Sistema','2014-12-22 23:11:12'),
 (1667,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:12:02'),
 (1668,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:17:18'),
 (1669,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:18:43'),
 (1670,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:22:43');
INSERT INTO `inv_log_transacciones` (`codigo`,`ip`,`usuario`,`accion`,`fecha`) VALUES 
 (1671,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:37:04'),
 (1672,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:40:56'),
 (1673,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:43:28'),
 (1674,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:49:16'),
 (1675,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:51:25'),
 (1676,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:53:48'),
 (1677,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:55:21'),
 (1678,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:56:07'),
 (1679,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:57:08'),
 (1680,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-22 23:57:51'),
 (1681,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-23 00:06:33'),
 (1682,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 19:46:46'),
 (1683,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 19:49:09'),
 (1684,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 19:49:46'),
 (1685,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 19:50:23'),
 (1686,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 19:51:02'),
 (1687,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 20:24:10'),
 (1688,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 20:26:51'),
 (1689,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 20:40:13'),
 (1690,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 20:48:46'),
 (1691,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 20:51:34'),
 (1692,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 21:08:22'),
 (1693,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 21:12:58'),
 (1694,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 21:26:41'),
 (1695,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 21:29:08'),
 (1696,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 21:41:24'),
 (1697,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 21:42:39'),
 (1698,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 21:50:38'),
 (1699,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:04:24'),
 (1700,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:05:18'),
 (1701,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:11:08'),
 (1702,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:29:54'),
 (1703,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:31:31'),
 (1704,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:32:23'),
 (1705,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:42:59'),
 (1706,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:44:22'),
 (1707,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-25 22:45:04'),
 (1708,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-26 12:21:09'),
 (1709,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-26 15:54:59'),
 (1710,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-26 15:57:21'),
 (1711,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-26 15:58:15'),
 (1712,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-26 16:00:07'),
 (1713,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 12:20:44'),
 (1714,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 12:32:01'),
 (1715,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 12:32:56'),
 (1716,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 13:00:11'),
 (1717,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 13:15:16'),
 (1718,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 13:17:46'),
 (1719,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 13:22:12'),
 (1720,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 13:23:14'),
 (1721,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 13:24:09'),
 (1722,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 17:11:14'),
 (1723,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 17:12:43'),
 (1724,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 17:17:55'),
 (1725,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 17:21:50'),
 (1726,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 17:26:01'),
 (1727,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 17:30:26'),
 (1728,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 17:31:22'),
 (1729,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:32:28'),
 (1730,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:33:42'),
 (1731,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:34:24'),
 (1732,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:35:12'),
 (1733,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:36:14'),
 (1734,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:44:39'),
 (1735,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:47:39'),
 (1736,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:50:11'),
 (1737,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 18:52:28'),
 (1738,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:03:33'),
 (1739,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:04:19'),
 (1740,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:06:17'),
 (1741,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:08:26'),
 (1742,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:17:14'),
 (1743,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:19:48'),
 (1744,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:20:23'),
 (1745,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:21:47'),
 (1746,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:35:41'),
 (1747,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:37:08'),
 (1748,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:38:03'),
 (1749,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:39:40'),
 (1750,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:41:19'),
 (1751,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:42:35'),
 (1752,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:55:29'),
 (1753,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:57:47'),
 (1754,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 19:59:24'),
 (1755,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 20:02:19'),
 (1756,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 20:12:36'),
 (1757,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 20:15:29'),
 (1758,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 20:17:27'),
 (1759,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 21:01:27'),
 (1760,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 21:55:28'),
 (1761,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:01:10'),
 (1762,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:02:03'),
 (1763,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:03:02'),
 (1764,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:03:32'),
 (1765,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:04:25'),
 (1766,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:08:30'),
 (1767,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:11:13'),
 (1768,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:12:02'),
 (1769,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:12:52'),
 (1770,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:13:30'),
 (1771,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:14:30'),
 (1772,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:15:48'),
 (1773,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:16:30'),
 (1774,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:17:44'),
 (1775,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:18:54'),
 (1776,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:20:20'),
 (1777,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:21:07'),
 (1778,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:22:24'),
 (1779,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:23:42'),
 (1780,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:25:15'),
 (1781,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:26:14'),
 (1782,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:27:09'),
 (1783,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:28:14'),
 (1784,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:28:57'),
 (1785,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:34:21'),
 (1786,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:35:54'),
 (1787,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:39:56'),
 (1788,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:42:03'),
 (1789,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:45:11'),
 (1790,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:53:52'),
 (1791,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:55:24'),
 (1792,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:57:03'),
 (1793,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:57:44'),
 (1794,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 22:59:31'),
 (1795,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:11:17'),
 (1796,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:17:36'),
 (1797,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:19:24'),
 (1798,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:20:43'),
 (1799,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:27:11'),
 (1800,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:27:49'),
 (1801,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:28:55'),
 (1802,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:29:39'),
 (1803,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:32:06'),
 (1804,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:40:46'),
 (1805,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:42:20'),
 (1806,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:43:04'),
 (1807,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:45:35'),
 (1808,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:47:25'),
 (1809,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:52:10'),
 (1810,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:53:26'),
 (1811,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-28 23:55:43'),
 (1812,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 00:01:44'),
 (1813,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 00:02:23'),
 (1814,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 22:57:01'),
 (1815,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:12:48'),
 (1816,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:15:16'),
 (1817,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:16:03'),
 (1818,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:17:02'),
 (1819,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:22:29'),
 (1820,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:24:05'),
 (1821,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:28:04'),
 (1822,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:28:45'),
 (1823,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:30:38'),
 (1824,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:33:57'),
 (1825,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:53:16'),
 (1826,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:55:12'),
 (1827,'192.168.1.127','drpareda','Acceso al Sistema','2014-12-29 23:56:16'),
 (1828,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 20:37:00'),
 (1829,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 20:46:11'),
 (1830,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 20:46:59'),
 (1831,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:09:22'),
 (1832,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:13:41'),
 (1833,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:19:33'),
 (1834,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:44:46'),
 (1835,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:49:44'),
 (1836,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:51:10'),
 (1837,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:53:08'),
 (1838,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:54:32'),
 (1839,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 21:56:36'),
 (1840,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 23:32:30'),
 (1841,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 23:33:53'),
 (1842,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 23:47:49'),
 (1843,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 23:51:09'),
 (1844,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 23:55:44'),
 (1845,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-02 23:57:48'),
 (1846,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 00:06:30'),
 (1847,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 12:51:24'),
 (1848,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 12:58:55'),
 (1849,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 12:59:42'),
 (1850,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 13:01:11'),
 (1851,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 13:03:08'),
 (1852,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 13:04:30'),
 (1853,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 13:06:41'),
 (1854,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 16:11:36'),
 (1855,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 16:31:54'),
 (1856,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 16:32:57'),
 (1857,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 16:34:36'),
 (1858,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 16:36:34'),
 (1859,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 16:37:43'),
 (1860,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:01:30'),
 (1861,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:20:16'),
 (1862,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:23:36'),
 (1863,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:27:54'),
 (1864,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:29:01'),
 (1865,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:31:24'),
 (1866,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:37:03'),
 (1867,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:40:00'),
 (1868,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:41:41'),
 (1869,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-03 17:44:48'),
 (1870,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 14:02:48'),
 (1871,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 15:22:46'),
 (1872,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 15:24:59'),
 (1873,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 15:26:04'),
 (1874,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 15:27:01'),
 (1875,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 15:28:45'),
 (1876,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 15:51:27'),
 (1877,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 16:55:35'),
 (1878,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 18:57:13'),
 (1879,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:00:51'),
 (1880,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:05:10'),
 (1881,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:07:29'),
 (1882,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:08:43'),
 (1883,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:09:46'),
 (1884,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:21:59'),
 (1885,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:30:33'),
 (1886,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:34:00'),
 (1887,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:35:03'),
 (1888,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 19:44:13'),
 (1889,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:07:24'),
 (1890,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:08:17'),
 (1891,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:28:44'),
 (1892,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:29:54'),
 (1893,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:30:47'),
 (1894,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:31:16'),
 (1895,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:35:29'),
 (1896,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:43:46'),
 (1897,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:47:20'),
 (1898,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:52:42'),
 (1899,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:57:07'),
 (1900,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 20:59:51'),
 (1901,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 21:02:38'),
 (1902,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 21:29:19'),
 (1903,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 21:32:25'),
 (1904,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 21:37:45'),
 (1905,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 22:16:47'),
 (1906,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 22:24:32'),
 (1907,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 22:43:38'),
 (1908,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 22:47:30'),
 (1909,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 22:51:12'),
 (1910,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 22:55:01'),
 (1911,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 22:56:36'),
 (1912,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 23:07:26'),
 (1913,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 23:09:23'),
 (1914,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-04 23:12:09'),
 (1915,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 00:03:23'),
 (1916,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 00:05:21'),
 (1917,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 00:06:17'),
 (1918,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 00:14:40'),
 (1919,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 20:22:23'),
 (1920,'192.168.1.127','drpareda','Registro Pedido','2015-01-05 20:23:59'),
 (1921,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 20:28:49'),
 (1922,'192.168.1.127','drpareda','Registro Pedido','2015-01-05 20:29:13'),
 (1923,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 21:30:38'),
 (1924,'192.168.1.127','drpareda','Registro Pedido','2015-01-05 21:34:24'),
 (1925,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 21:50:15'),
 (1926,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 21:59:27'),
 (1927,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 22:02:49'),
 (1928,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 22:06:26'),
 (1929,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 22:50:14'),
 (1930,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 22:53:59'),
 (1931,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 22:55:36'),
 (1932,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 22:57:00'),
 (1933,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 23:08:23'),
 (1934,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 23:09:16'),
 (1935,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 23:10:05'),
 (1936,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 23:12:47'),
 (1937,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-05 23:25:51'),
 (1938,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 09:58:25'),
 (1939,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 10:00:43'),
 (1940,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 10:02:27'),
 (1941,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 10:04:59'),
 (1942,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 10:06:29'),
 (1943,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 12:52:55'),
 (1944,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 12:54:20'),
 (1945,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 13:52:21'),
 (1946,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 13:56:05'),
 (1947,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 13:56:26'),
 (1948,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 14:01:42'),
 (1949,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 14:05:14'),
 (1950,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 14:05:29'),
 (1951,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 14:05:30'),
 (1952,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 14:05:30'),
 (1953,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 14:05:30'),
 (1954,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 14:09:58'),
 (1955,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:00:52'),
 (1956,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:11:44'),
 (1957,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:20:22'),
 (1958,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:24:25'),
 (1959,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:27:40'),
 (1960,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:27:50'),
 (1961,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:33:35'),
 (1962,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:34:10'),
 (1963,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:37:23'),
 (1964,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:38:10'),
 (1965,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:40:07'),
 (1966,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 15:40:40'),
 (1967,'10.19.8.141','drpareda','Registro Empleado','2015-01-06 15:43:39'),
 (1968,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 15:45:29'),
 (1969,'10.19.8.141','drpareda','Eliminacion Empleado','2015-01-06 15:45:35'),
 (1970,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 16:08:15'),
 (1971,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-06 16:35:50'),
 (1972,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 16:40:17'),
 (1973,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 16:40:38'),
 (1974,'10.19.8.141','drpareda','Actualizacion Empleado','2015-01-06 16:40:48'),
 (1975,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 19:33:18'),
 (1976,'192.168.1.127','drpareda','Actualizacion Empleado','2015-01-06 19:34:11'),
 (1977,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 19:40:51'),
 (1978,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 19:43:14'),
 (1979,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 19:51:08'),
 (1980,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:03:18'),
 (1981,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:03:41'),
 (1982,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:05:02'),
 (1983,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:14:27'),
 (1984,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:15:21'),
 (1985,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:16:26'),
 (1986,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:17:09'),
 (1987,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:17:27'),
 (1988,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:23:35'),
 (1989,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:25:11'),
 (1990,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:26:37'),
 (1991,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:28:06'),
 (1992,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:28:53'),
 (1993,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:30:24'),
 (1994,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:34:56'),
 (1995,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:38:00'),
 (1996,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 20:40:54'),
 (1997,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 21:01:00'),
 (1998,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 21:04:45'),
 (1999,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 21:07:06'),
 (2000,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 21:19:19'),
 (2001,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 21:23:24'),
 (2002,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 21:29:03'),
 (2003,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 21:29:39'),
 (2004,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:01:58'),
 (2005,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:03:49'),
 (2006,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:04:57'),
 (2007,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:06:01'),
 (2008,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:06:33'),
 (2009,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:07:34'),
 (2010,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:08:56'),
 (2011,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:09:52'),
 (2012,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:11:17'),
 (2013,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:12:20'),
 (2014,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:14:26'),
 (2015,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:15:44'),
 (2016,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:17:06'),
 (2017,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:17:53'),
 (2018,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:18:26'),
 (2019,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:19:02'),
 (2020,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:19:27'),
 (2021,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:21:31'),
 (2022,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:22:46'),
 (2023,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:23:14'),
 (2024,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:24:01'),
 (2025,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:25:38'),
 (2026,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:26:06'),
 (2027,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:34:16'),
 (2028,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:36:28'),
 (2029,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:38:42'),
 (2030,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:40:26'),
 (2031,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:41:09'),
 (2032,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:41:44'),
 (2033,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:44:55'),
 (2034,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:48:27'),
 (2035,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:50:03'),
 (2036,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:50:37'),
 (2037,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:52:23'),
 (2038,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:55:20'),
 (2039,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:56:57'),
 (2040,'192.168.1.127','drpareda','Registro Pedido','2015-01-06 22:58:12'),
 (2041,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 22:59:38'),
 (2042,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 23:05:01'),
 (2043,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 23:08:21'),
 (2044,'192.168.1.127','drpareda','Registro Pedido','2015-01-06 23:09:15'),
 (2045,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 23:16:11'),
 (2046,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 23:19:36'),
 (2047,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-06 23:57:07'),
 (2048,'192.168.1.127','drpareda','Actualizacion Empleado','2015-01-06 23:59:12'),
 (2049,'192.168.1.127','drpareda','Registro Empleado','2015-01-07 00:01:29'),
 (2050,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 00:17:17'),
 (2051,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 00:17:44'),
 (2052,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 00:19:11'),
 (2053,'192.168.1.127','drpareda','Registro Empleado','2015-01-07 00:19:54'),
 (2054,'192.168.1.127','drpareda','Eliminacion Empleado','2015-01-07 00:20:18'),
 (2055,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 00:29:38'),
 (2056,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 00:31:51'),
 (2057,'192.168.1.127','drpareda','Registro Empleado','2015-01-07 00:32:29'),
 (2058,'127.0.0.1','drpareda','Acceso al Sistema','2015-01-07 15:43:09'),
 (2059,'127.0.0.1','drpareda','Registro Pedido','2015-01-07 15:43:42'),
 (2060,'127.0.0.1','drpareda','Acceso al Sistema','2015-01-07 15:46:59'),
 (2061,'127.0.0.1','drpareda','Registro Pedido','2015-01-07 15:52:07'),
 (2062,'127.0.0.1','drpareda','Edicion inventario','2015-01-07 16:01:40'),
 (2063,'127.0.0.1','drpareda','Registro Usuario','2015-01-07 16:03:11'),
 (2064,'127.0.0.1','qq','Acceso al Sistema','2015-01-07 16:03:33'),
 (2065,'127.0.0.1','drpareda','Acceso al Sistema','2015-01-07 16:04:15'),
 (2066,'127.0.0.1','drpareda','Acceso al Sistema','2015-01-07 16:08:55'),
 (2067,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 19:04:04'),
 (2068,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 19:06:07'),
 (2069,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 19:07:16'),
 (2070,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 19:11:16'),
 (2071,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 19:47:37'),
 (2072,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 19:54:04'),
 (2073,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 19:56:51'),
 (2074,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:01:15'),
 (2075,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 20:02:59'),
 (2076,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 20:06:35'),
 (2077,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:06:57'),
 (2078,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 20:16:58'),
 (2079,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:17:19'),
 (2080,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:33:50'),
 (2081,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 20:34:40'),
 (2082,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:35:03'),
 (2083,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:43:12'),
 (2084,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:43:35'),
 (2085,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 20:47:31'),
 (2086,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 20:54:02'),
 (2087,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:54:34'),
 (2088,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 20:55:03'),
 (2089,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 21:06:32'),
 (2090,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:06:56'),
 (2091,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:07:02'),
 (2092,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:07:07'),
 (2093,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:07:10'),
 (2094,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:07:12'),
 (2095,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:07:15'),
 (2096,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 21:09:35'),
 (2097,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:09:51'),
 (2098,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 21:22:26'),
 (2099,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:22:47'),
 (2100,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 21:23:43'),
 (2101,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:24:00'),
 (2102,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 21:32:09'),
 (2103,'192.168.1.127','drpareda','Registro Pedido','2015-01-07 21:32:26'),
 (2104,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 22:03:29'),
 (2105,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 22:12:49'),
 (2106,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 22:18:00'),
 (2107,'192.168.1.127','drpareda','Registro Empleado','2015-01-07 22:18:15'),
 (2108,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 22:23:21'),
 (2109,'192.168.1.127','drpareda','Registro Empleado','2015-01-07 22:23:42'),
 (2110,'192.168.1.127','drpareda','Registro Usuario','2015-01-07 22:24:08'),
 (2111,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 22:30:00'),
 (2112,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 22:31:27'),
 (2113,'192.168.1.127','drpareda','Registro Cliente','2015-01-07 22:31:58'),
 (2114,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:11:25'),
 (2115,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:17:00'),
 (2116,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:18:24'),
 (2117,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:20:32'),
 (2118,'192.168.1.127','drpareda','Actualizacion Empleado','2015-01-07 23:21:45'),
 (2119,'192.168.1.127','drpareda','Eliminacion Empleado','2015-01-07 23:22:55'),
 (2120,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:32:21'),
 (2121,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:34:02'),
 (2122,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:38:45'),
 (2123,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:44:14'),
 (2124,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:46:22'),
 (2125,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-07 23:46:53'),
 (2126,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-07 23:46:58'),
 (2127,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-07 23:50:46'),
 (2128,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 00:11:55'),
 (2129,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-08 00:12:02'),
 (2130,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-08 00:12:08'),
 (2131,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-08 00:12:23'),
 (2132,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 00:14:54'),
 (2133,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 21:47:41'),
 (2134,'192.168.1.127','drpareda','Registro Usuario','2015-01-08 21:48:00'),
 (2135,'192.168.1.127','drpareda','Registro Usuario','2015-01-08 21:49:02'),
 (2136,'192.168.1.127','drpareda','Registro Usuario','2015-01-08 21:49:16'),
 (2137,'192.168.1.127','drpareda','Registro Usuario','2015-01-08 21:50:20'),
 (2138,'192.168.1.127','drpareda','Registro Cliente','2015-01-08 21:50:56'),
 (2139,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 22:05:19'),
 (2140,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 22:30:12'),
 (2141,'192.168.1.127','drpareda','Registro Usuario','2015-01-08 22:31:51'),
 (2142,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-08 22:36:10'),
 (2143,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 22:45:15'),
 (2144,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 22:59:44'),
 (2145,'192.168.1.127','drpareda','Registro Usuario','2015-01-08 23:00:10'),
 (2146,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-08 23:00:18'),
 (2147,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-08 23:00:30'),
 (2148,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:21:16'),
 (2149,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:22:37'),
 (2150,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:29:50'),
 (2151,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:32:11'),
 (2152,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:32:53'),
 (2153,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:35:22'),
 (2154,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:37:29'),
 (2155,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:42:53'),
 (2156,'192.168.1.127','drpareda','Eliminacion Cliente','2015-01-08 23:43:46'),
 (2157,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:53:42'),
 (2158,'192.168.1.127','drpareda','Registro Empleado','2015-01-08 23:54:19'),
 (2159,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-08 23:57:50'),
 (2160,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-09 00:01:18'),
 (2161,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-09 00:04:02'),
 (2162,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-09 00:05:50'),
 (2163,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-09 00:07:15'),
 (2164,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-09 00:08:07'),
 (2165,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-09 00:09:01'),
 (2166,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 14:04:23'),
 (2167,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 14:18:05'),
 (2168,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 14:24:12'),
 (2169,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 14:34:37'),
 (2170,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 14:35:42'),
 (2171,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 14:36:02'),
 (2172,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 14:47:17'),
 (2173,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 14:52:08'),
 (2174,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 15:58:30'),
 (2175,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 15:59:47'),
 (2176,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:00:59'),
 (2177,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:04:16'),
 (2178,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:05:37'),
 (2179,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:08:36'),
 (2180,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:09:59'),
 (2181,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:11:14'),
 (2182,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:39:08'),
 (2183,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 16:39:28'),
 (2184,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:49:17'),
 (2185,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:52:23'),
 (2186,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 16:57:46'),
 (2187,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:08:04'),
 (2188,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:13:58'),
 (2189,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:15:39'),
 (2190,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:22:55'),
 (2191,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:29:07'),
 (2192,'192.168.1.127','drpareda','Registro Empleado','2015-01-10 17:31:48'),
 (2193,'192.168.1.127','drpareda','Actualizacion Empleado','2015-01-10 17:31:59'),
 (2194,'192.168.1.127','drpareda','Actualizacion Empleado','2015-01-10 17:32:07'),
 (2195,'192.168.1.127','drpareda','Eliminacion Empleado','2015-01-10 17:32:12'),
 (2196,'192.168.1.127','drpareda','Registro Empleado','2015-01-10 17:32:29'),
 (2197,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:37:12'),
 (2198,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:43:31'),
 (2199,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:46:19'),
 (2200,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-10 17:46:28'),
 (2201,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-10 17:46:49'),
 (2202,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-10 17:47:14'),
 (2203,'192.168.1.127','drpareda','Eliminacion Usuario','2015-01-10 17:48:50'),
 (2204,'192.168.1.127','drpareda','Registro Usuario','2015-01-10 17:49:04'),
 (2205,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-10 17:49:12'),
 (2206,'192.168.1.127','drpareda','Eliminacion Usuario','2015-01-10 17:49:14'),
 (2207,'192.168.1.127','drpareda','Eliminacion Cliente','2015-01-10 17:54:26'),
 (2208,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 17:54:37'),
 (2209,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 17:57:27'),
 (2210,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:00:10'),
 (2211,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:01:45'),
 (2212,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:06:58'),
 (2213,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:07:12'),
 (2214,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:07:23'),
 (2215,'192.168.1.127','drpareda','Eliminacion Cliente','2015-01-10 18:07:34'),
 (2216,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:09:11'),
 (2217,'192.168.1.127','drpareda','Registro Cliente','2015-01-10 18:09:37'),
 (2218,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:09:43'),
 (2219,'192.168.1.127','drpareda','Eliminacion Cliente','2015-01-10 18:09:51'),
 (2220,'192.168.1.127','drpareda','Registro Empleado','2015-01-10 18:10:41'),
 (2221,'192.168.1.127','drpareda','Registro Usuario','2015-01-10 18:11:04'),
 (2222,'192.168.1.127','drpareda','Actualizacion Usuario','2015-01-10 18:11:12'),
 (2223,'192.168.1.127','drpareda','Eliminacion Usuario','2015-01-10 18:11:19'),
 (2224,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:11:33'),
 (2225,'192.168.1.127','drpareda','Eliminacion Cliente','2015-01-10 18:11:39'),
 (2226,'192.168.1.127','drpareda','Registro Cliente','2015-01-10 18:11:59'),
 (2227,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:12:07'),
 (2228,'192.168.1.127','drpareda','Eliminacion Cliente','2015-01-10 18:12:09'),
 (2229,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:24:16'),
 (2230,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:26:00'),
 (2231,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:26:54'),
 (2232,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:31:29'),
 (2233,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:32:30'),
 (2234,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:34:01'),
 (2235,'192.168.1.127','drpareda','Registro Cliente','2015-01-10 18:34:21'),
 (2236,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:34:31'),
 (2237,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:34:35'),
 (2238,'192.168.1.127','drpareda','Actualizacion Cliente','2015-01-10 18:34:58'),
 (2239,'192.168.1.127','drpareda','Eliminacion Cliente','2015-01-10 18:35:02'),
 (2240,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:42:16'),
 (2241,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:45:26'),
 (2242,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:58:44'),
 (2243,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 18:59:28'),
 (2244,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 19:01:18'),
 (2245,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 19:06:19'),
 (2246,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 19:16:22'),
 (2247,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:06:51'),
 (2248,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:12:49'),
 (2249,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:13:45'),
 (2250,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:14:26'),
 (2251,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:14:55'),
 (2252,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:24:57'),
 (2253,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:25:55'),
 (2254,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:26:51'),
 (2255,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-10 20:27:34'),
 (2256,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 19:41:30'),
 (2257,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 19:43:19'),
 (2258,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 19:50:25'),
 (2259,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 21:47:59'),
 (2260,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 21:55:56'),
 (2261,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 21:57:09'),
 (2262,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:01:19'),
 (2263,'192.168.1.127','drpareda','Registro Pedido','2015-01-11 22:03:15'),
 (2264,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:12:52'),
 (2265,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:14:54'),
 (2266,'192.168.1.127','drpareda','Registro Pedido','2015-01-11 22:17:48'),
 (2267,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:22:34'),
 (2268,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:23:57'),
 (2269,'192.168.1.127','drpareda','Registro Pedido','2015-01-11 22:24:14'),
 (2270,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:24:59'),
 (2271,'192.168.1.127','drpareda','Registro Pedido','2015-01-11 22:25:18'),
 (2272,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:30:40'),
 (2273,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:33:49'),
 (2274,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:37:01'),
 (2275,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:39:56'),
 (2276,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:41:57'),
 (2277,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 22:42:41'),
 (2278,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:01:18'),
 (2279,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:04:11'),
 (2280,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:04:50'),
 (2281,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:05:46'),
 (2282,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:13:16'),
 (2283,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:13:27'),
 (2284,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:15:08'),
 (2285,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:15:19'),
 (2286,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:17:58'),
 (2287,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:18:08'),
 (2288,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:18:57'),
 (2289,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:19:06'),
 (2290,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:21:08'),
 (2291,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:21:16'),
 (2292,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:21:53'),
 (2293,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:22:03'),
 (2294,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:22:43'),
 (2295,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:22:53'),
 (2296,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:26:47'),
 (2297,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:26:56'),
 (2298,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:27:31'),
 (2299,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:27:39'),
 (2300,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:28:53'),
 (2301,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:29:09'),
 (2302,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:29:14'),
 (2303,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:30:52'),
 (2304,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:31:02'),
 (2305,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:35:13'),
 (2306,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:35:23'),
 (2307,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:38:46'),
 (2308,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:38:57'),
 (2309,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:40:19'),
 (2310,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:40:31'),
 (2311,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:41:06'),
 (2312,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:44:33'),
 (2313,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:45:33'),
 (2314,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:45:55'),
 (2315,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:46:13'),
 (2316,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:46:49'),
 (2317,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:47:50'),
 (2318,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:48:40'),
 (2319,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-11 23:54:10'),
 (2320,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:54:27'),
 (2321,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:54:46'),
 (2322,'192.168.1.127','drpareda','Edicion inventario','2015-01-11 23:55:25'),
 (2323,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:02:35'),
 (2324,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:02:54'),
 (2325,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:03:49'),
 (2326,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:04:11'),
 (2327,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:04:36'),
 (2328,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:10:19'),
 (2329,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:10:56'),
 (2330,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:11:54'),
 (2331,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:20:25'),
 (2332,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:20:57'),
 (2333,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:23:32'),
 (2334,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:24:09'),
 (2335,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:26:30'),
 (2336,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:27:02'),
 (2337,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:29:10'),
 (2338,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:29:28'),
 (2339,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:30:09'),
 (2340,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:30:28'),
 (2341,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:33:38'),
 (2342,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:34:03'),
 (2343,'192.168.1.127','drpareda','Edicion inventario','2015-01-12 00:34:16'),
 (2344,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:36:26'),
 (2345,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:38:00'),
 (2346,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 00:39:59'),
 (2347,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 19:50:21'),
 (2348,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 19:51:29'),
 (2349,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 19:58:47'),
 (2350,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 19:59:08'),
 (2351,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 19:59:49'),
 (2352,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 21:53:22'),
 (2353,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 21:53:56'),
 (2354,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:01:11'),
 (2355,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 22:01:42'),
 (2356,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:09:04'),
 (2357,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:10:19'),
 (2358,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:12:13'),
 (2359,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 22:12:48'),
 (2360,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:14:54'),
 (2361,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 22:15:39'),
 (2362,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:16:45'),
 (2363,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 22:17:07'),
 (2364,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:22:29'),
 (2365,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 22:23:02'),
 (2366,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:27:14'),
 (2367,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:28:22'),
 (2368,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:32:47'),
 (2369,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:34:47'),
 (2370,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:37:13'),
 (2371,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:38:55'),
 (2372,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:41:46'),
 (2373,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:43:03'),
 (2374,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:46:47'),
 (2375,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 22:47:20'),
 (2376,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 22:56:51'),
 (2377,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 23:03:20'),
 (2378,'192.168.1.127','drpareda','Registro Pedido','2015-01-12 23:03:41'),
 (2379,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-12 23:11:40'),
 (2380,'127.0.0.1','drpareda','Acceso al Sistema','2015-01-13 09:25:07'),
 (2381,'127.0.0.1','drpareda','Registro Pedido','2015-01-13 09:34:24'),
 (2382,'127.0.0.1','drpareda','Edicion inventario','2015-01-13 09:56:38'),
 (2383,'127.0.0.1','drpareda','Edicion inventario','2015-01-13 09:57:24'),
 (2384,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:17:55'),
 (2385,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:33:30'),
 (2386,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:34:32'),
 (2387,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:34:32'),
 (2388,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:35:24'),
 (2389,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:37:01'),
 (2390,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:38:33'),
 (2391,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:40:53'),
 (2392,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:41:37'),
 (2393,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:44:17'),
 (2394,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:45:06'),
 (2395,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:49:30'),
 (2396,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:51:14'),
 (2397,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:52:06'),
 (2398,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:53:28'),
 (2399,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:54:17'),
 (2400,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:54:51'),
 (2401,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:55:56'),
 (2402,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:56:34'),
 (2403,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:58:01'),
 (2404,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 19:59:20'),
 (2405,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:00:00'),
 (2406,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:00:40'),
 (2407,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:01:32'),
 (2408,'192.168.1.127','drpareda','Registro Empleado','2015-01-13 20:03:15'),
 (2409,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:07:17'),
 (2410,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:08:13'),
 (2411,'192.168.1.127','drpareda','Registro Empleado','2015-01-13 20:08:25'),
 (2412,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:10:05'),
 (2413,'192.168.1.127','drpareda','Registro Empleado','2015-01-13 20:10:19'),
 (2414,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:11:47'),
 (2415,'192.168.1.127','drpareda','Registro Empleado','2015-01-13 20:11:58'),
 (2416,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:13:17'),
 (2417,'192.168.1.127','drpareda','Registro Empleado','2015-01-13 20:13:28'),
 (2418,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:14:10'),
 (2419,'192.168.1.127','drpareda','Registro Empleado','2015-01-13 20:14:25'),
 (2420,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:14:55'),
 (2421,'192.168.1.127','drpareda','Registro Empleado','2015-01-13 20:15:05'),
 (2422,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:20:57'),
 (2423,'192.168.1.127','drpareda','Registro Usuario','2015-01-13 20:21:23'),
 (2424,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:23:28'),
 (2425,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:24:24'),
 (2426,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:28:14'),
 (2427,'192.168.1.127','drpareda','Registro Cliente','2015-01-13 20:28:54'),
 (2428,'192.168.1.127','drpareda','Registro Usuario','2015-01-13 20:29:25'),
 (2429,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:31:31'),
 (2430,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:32:30'),
 (2431,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:33:32'),
 (2432,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:36:05'),
 (2433,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:37:33'),
 (2434,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:39:21'),
 (2435,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:41:24'),
 (2436,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:43:12'),
 (2437,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:44:19'),
 (2438,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:46:28'),
 (2439,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:51:54'),
 (2440,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:53:23'),
 (2441,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:54:16'),
 (2442,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 20:56:28'),
 (2443,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:00:04'),
 (2444,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:02:36'),
 (2445,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:04:27'),
 (2446,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:05:11'),
 (2447,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:06:19'),
 (2448,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:12:37'),
 (2449,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:15:49'),
 (2450,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:15:56'),
 (2451,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:37:56'),
 (2452,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:44:21'),
 (2453,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 21:58:56'),
 (2454,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 22:05:55'),
 (2455,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 22:07:46'),
 (2456,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 22:08:42'),
 (2457,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 22:09:34'),
 (2458,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 22:10:23'),
 (2459,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 22:12:10'),
 (2460,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 22:56:36'),
 (2461,'192.168.1.127','drpareda','Registro Pedido','2015-01-13 22:56:53'),
 (2462,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 23:01:28'),
 (2463,'192.168.1.127','drpareda','Registro Pedido','2015-01-13 23:01:47'),
 (2464,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 23:49:03'),
 (2465,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 23:50:14'),
 (2466,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-13 23:58:37'),
 (2467,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:01:32'),
 (2468,'192.168.1.127','drpareda','Edicion inventario','2015-01-14 00:01:54'),
 (2469,'192.168.1.127','drpareda','Edicion inventario','2015-01-14 00:02:03'),
 (2470,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:06:21'),
 (2471,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:07:13'),
 (2472,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:10:44'),
 (2473,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:14:17'),
 (2474,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:17:17'),
 (2475,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:18:42'),
 (2476,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:21:16'),
 (2477,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:23:58'),
 (2478,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:25:24'),
 (2479,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:27:41'),
 (2480,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:28:32'),
 (2481,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:30:00'),
 (2482,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:30:54'),
 (2483,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:32:04'),
 (2484,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-14 00:34:15'),
 (2485,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 11:29:31'),
 (2486,'10.19.8.141','ccalderg','Acceso al Sistema','2015-01-26 11:30:06'),
 (2487,'10.19.8.141','ccalderg','Acceso al Sistema','2015-01-26 11:30:24'),
 (2488,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 11:32:08'),
 (2489,'10.19.8.141','ccalderg','Acceso al Sistema','2015-01-26 11:32:31'),
 (2490,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 11:32:58'),
 (2491,'10.19.8.141','ccalderg','Acceso al Sistema','2015-01-26 11:37:24');
INSERT INTO `inv_log_transacciones` (`codigo`,`ip`,`usuario`,`accion`,`fecha`) VALUES 
 (2492,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 11:39:50'),
 (2493,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 16:40:01'),
 (2494,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 16:40:01'),
 (2495,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 16:44:46'),
 (2496,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:03:27'),
 (2497,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:09:25'),
 (2498,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:12:55'),
 (2499,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:16:03'),
 (2500,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:18:33'),
 (2501,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:25:59'),
 (2502,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:28:01'),
 (2503,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:31:18'),
 (2504,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:32:18'),
 (2505,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-26 17:33:05'),
 (2506,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:10:29'),
 (2507,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:16:59'),
 (2508,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:18:02'),
 (2509,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:20:15'),
 (2510,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:21:13'),
 (2511,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:22:27'),
 (2512,'192.168.1.127','ccalderg','Acceso al Sistema','2015-01-26 19:23:13'),
 (2513,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:24:21'),
 (2514,'192.168.1.127','ccalderg','Acceso al Sistema','2015-01-26 19:24:33'),
 (2515,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:26:00'),
 (2516,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:27:08'),
 (2517,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:27:34'),
 (2518,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:28:04'),
 (2519,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:28:39'),
 (2520,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:34:48'),
 (2521,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:37:09'),
 (2522,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 19:48:03'),
 (2523,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:05:30'),
 (2524,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:06:51'),
 (2525,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:07:25'),
 (2526,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:08:16'),
 (2527,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:09:34'),
 (2528,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:10:34'),
 (2529,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:45:55'),
 (2530,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:47:53'),
 (2531,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:51:14'),
 (2532,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:52:44'),
 (2533,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 20:56:11'),
 (2534,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:06:01'),
 (2535,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:07:10'),
 (2536,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:09:15'),
 (2537,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:10:01'),
 (2538,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:13:05'),
 (2539,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:14:04'),
 (2540,'192.168.1.127','ccalderg','Acceso al Sistema','2015-01-26 21:24:45'),
 (2541,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:26:09'),
 (2542,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:27:58'),
 (2543,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:33:16'),
 (2544,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:34:27'),
 (2545,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:40:23'),
 (2546,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:41:37'),
 (2547,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:46:03'),
 (2548,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:47:18'),
 (2549,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:49:00'),
 (2550,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:49:26'),
 (2551,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:50:21'),
 (2552,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:53:33'),
 (2553,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 21:54:03'),
 (2554,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:06:08'),
 (2555,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:07:27'),
 (2556,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:07:59'),
 (2557,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:08:20'),
 (2558,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:10:59'),
 (2559,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:12:02'),
 (2560,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:13:09'),
 (2561,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:17:01'),
 (2562,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:18:03'),
 (2563,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:20:18'),
 (2564,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:21:57'),
 (2565,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:24:06'),
 (2566,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:26:33'),
 (2567,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:27:59'),
 (2568,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:30:00'),
 (2569,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:32:47'),
 (2570,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:34:16'),
 (2571,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:39:40'),
 (2572,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:44:31'),
 (2573,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:45:10'),
 (2574,'192.168.1.127','ccalderg','Acceso al Sistema','2015-01-26 22:45:17'),
 (2575,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:48:24'),
 (2576,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:50:45'),
 (2577,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:51:48'),
 (2578,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:51:48'),
 (2579,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:57:25'),
 (2580,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 22:57:54'),
 (2581,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 23:00:03'),
 (2582,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 23:00:30'),
 (2583,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 23:01:40'),
 (2584,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-26 23:02:37'),
 (2585,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 15:50:39'),
 (2586,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 15:50:39'),
 (2587,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 15:50:39'),
 (2588,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 15:50:50'),
 (2589,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 15:55:51'),
 (2590,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:03:18'),
 (2591,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:07:02'),
 (2592,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:10:05'),
 (2593,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:12:12'),
 (2594,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:14:42'),
 (2595,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:22:46'),
 (2596,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:22:52'),
 (2597,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:28:45'),
 (2598,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:28:46'),
 (2599,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 16:32:59'),
 (2600,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-27 17:03:21'),
 (2601,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-28 16:47:12'),
 (2602,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-28 16:48:29'),
 (2603,'10.19.8.141','drpareda','Acceso al Sistema','2015-01-28 16:55:29'),
 (2604,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:10:37'),
 (2605,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:11:12'),
 (2606,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:12:13'),
 (2607,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:13:14'),
 (2608,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:15:35'),
 (2609,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:20:32'),
 (2610,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:20:56'),
 (2611,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:21:46'),
 (2612,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:23:05'),
 (2613,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:25:12'),
 (2614,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:25:56'),
 (2615,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:34:43'),
 (2616,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:35:44'),
 (2617,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:37:58'),
 (2618,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:41:07'),
 (2619,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:41:51'),
 (2620,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:46:04'),
 (2621,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:47:15'),
 (2622,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:49:19'),
 (2623,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:50:10'),
 (2624,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:58:10'),
 (2625,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 22:59:01'),
 (2626,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:00:54'),
 (2627,'192.168.1.127','drpareda','Registro Usuario','2015-01-28 23:01:12'),
 (2628,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:40:17'),
 (2629,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:42:51'),
 (2630,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:45:17'),
 (2631,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:48:05'),
 (2632,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:48:36'),
 (2633,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:49:08'),
 (2634,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:49:40'),
 (2635,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:50:42'),
 (2636,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:51:38'),
 (2637,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:52:14'),
 (2638,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:53:34'),
 (2639,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:57:24'),
 (2640,'192.168.1.127','prueba','Acceso al Sistema','2015-01-28 23:57:40'),
 (2641,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-28 23:58:24'),
 (2642,'192.168.1.127','prueba','Acceso al Sistema','2015-01-28 23:59:26'),
 (2643,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-29 00:00:52'),
 (2644,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:01:02'),
 (2645,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-29 00:02:35'),
 (2646,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:02:53'),
 (2647,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:03:16'),
 (2648,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:04:28'),
 (2649,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-29 00:05:30'),
 (2650,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:05:41'),
 (2651,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:05:54'),
 (2652,'192.168.1.127','drpareda','Acceso al Sistema','2015-01-29 00:07:44'),
 (2653,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:07:53'),
 (2654,'192.168.1.127','prueba','Acceso al Sistema','2015-01-29 00:08:17'),
 (2655,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:13:04'),
 (2656,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:17:13'),
 (2657,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:25:28'),
 (2658,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:32:00'),
 (2659,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:33:58'),
 (2660,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:34:54'),
 (2661,'192.168.1.127','drpareda','Actualizacion Empleado','2015-02-02 20:36:48'),
 (2662,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:39:00'),
 (2663,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:42:06'),
 (2664,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:46:19'),
 (2665,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 20:50:17'),
 (2666,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 21:12:53'),
 (2667,'192.168.1.127','drpareda','Eliminacion Empleado','2015-02-02 21:13:21'),
 (2668,'192.168.1.127','prueba','Acceso al Sistema','2015-02-02 21:13:41'),
 (2669,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 21:13:45'),
 (2670,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 21:38:10'),
 (2671,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 21:44:44'),
 (2672,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 21:49:14'),
 (2673,'192.168.1.127','drpareda','Actualizacion Cliente','2015-02-02 21:49:53'),
 (2674,'192.168.1.127','drpareda','Eliminacion Cliente','2015-02-02 21:50:38'),
 (2675,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 22:14:47'),
 (2676,'192.168.1.127','drpareda','Actualizacion Cliente','2015-02-02 22:15:06'),
 (2677,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 22:18:01'),
 (2678,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 22:18:48'),
 (2679,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 22:42:15'),
 (2680,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 22:47:10'),
 (2681,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 22:58:02'),
 (2682,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:11:20'),
 (2683,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:11:53'),
 (2684,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:15:42'),
 (2685,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:16:32'),
 (2686,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:21:05'),
 (2687,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:22:35'),
 (2688,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:24:59'),
 (2689,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:27:45'),
 (2690,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:46:20'),
 (2691,'192.168.1.127','drpareda','Registro Usuario','2015-02-02 23:46:45'),
 (2692,'192.168.1.127','drpareda','Registro Empleado','2015-02-02 23:47:13'),
 (2693,'192.168.1.127','ccalderg','Acceso al Sistema','2015-02-02 23:48:08'),
 (2694,'192.168.1.127','ccalderg','Eliminacion Usuario','2015-02-02 23:48:34'),
 (2695,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-02 23:51:07'),
 (2696,'192.168.1.127','drpareda','Registro Pedido','2015-02-02 23:52:54'),
 (2697,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:01:33'),
 (2698,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:03:57'),
 (2699,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:05:54'),
 (2700,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:08:01'),
 (2701,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:10:16'),
 (2702,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:11:33'),
 (2703,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:12:24'),
 (2704,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 00:19:35'),
 (2705,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 20:28:05'),
 (2706,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 20:30:00'),
 (2707,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 20:40:01'),
 (2708,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 20:44:44'),
 (2709,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 20:49:27'),
 (2710,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 20:57:43'),
 (2711,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:02:47'),
 (2712,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:15:07'),
 (2713,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:37:41'),
 (2714,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:40:15'),
 (2715,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:41:06'),
 (2716,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:41:36'),
 (2717,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:41:56'),
 (2718,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:42:19'),
 (2719,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:45:00'),
 (2720,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:48:03'),
 (2721,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:48:18'),
 (2722,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:50:10'),
 (2723,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:50:26'),
 (2724,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:51:28'),
 (2725,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:51:47'),
 (2726,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:51:51'),
 (2727,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:57:11'),
 (2728,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:57:25'),
 (2729,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:57:33'),
 (2730,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 21:59:09'),
 (2731,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:59:42'),
 (2732,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 21:59:53'),
 (2733,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:01:35'),
 (2734,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 22:01:47'),
 (2735,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 22:01:55'),
 (2736,'192.168.1.127','drpareda','Edicion inventario','2015-02-03 22:02:37'),
 (2737,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:15:49'),
 (2738,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:17:16'),
 (2739,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:20:57'),
 (2740,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:27:33'),
 (2741,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:30:38'),
 (2742,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:42:12'),
 (2743,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:48:11'),
 (2744,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 22:48:42'),
 (2745,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 23:19:19'),
 (2746,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 23:54:40'),
 (2747,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-03 23:59:42'),
 (2748,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:11:22'),
 (2749,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:23:44'),
 (2750,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:24:33'),
 (2751,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:26:20'),
 (2752,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:28:21'),
 (2753,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:30:46'),
 (2754,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:35:55'),
 (2755,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:38:02'),
 (2756,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:38:42'),
 (2757,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:39:27'),
 (2758,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:40:42'),
 (2759,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:42:09'),
 (2760,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:43:39'),
 (2761,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:44:23'),
 (2762,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:45:12'),
 (2763,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:50:47'),
 (2764,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:51:56'),
 (2765,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:52:27'),
 (2766,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-04 00:53:14'),
 (2767,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:12:47'),
 (2768,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:13:17'),
 (2769,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:31:01'),
 (2770,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:31:28'),
 (2771,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:34:01'),
 (2772,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:34:19'),
 (2773,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:39:57'),
 (2774,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:40:15'),
 (2775,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:43:00'),
 (2776,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:43:16'),
 (2777,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:47:15'),
 (2778,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:47:34'),
 (2779,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:54:31'),
 (2780,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:54:52'),
 (2781,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 21:57:17'),
 (2782,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 21:57:35'),
 (2783,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:03:52'),
 (2784,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 22:04:14'),
 (2785,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 22:05:58'),
 (2786,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:08:31'),
 (2787,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 22:09:00'),
 (2788,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:10:31'),
 (2789,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 22:10:51'),
 (2790,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 22:12:17'),
 (2791,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:14:43'),
 (2792,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:19:23'),
 (2793,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:23:24'),
 (2794,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:39:52'),
 (2795,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:41:44'),
 (2796,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:43:21'),
 (2797,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:49:38'),
 (2798,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:56:20'),
 (2799,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 22:58:49'),
 (2800,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:02:35'),
 (2801,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:03:55'),
 (2802,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:06:34'),
 (2803,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:11:24'),
 (2804,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:14:38'),
 (2805,'192.168.1.127','drpareda','Registro Pedido','2015-02-05 23:15:04'),
 (2806,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:20:42'),
 (2807,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:22:36'),
 (2808,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:23:55'),
 (2809,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-05 23:26:30'),
 (2810,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 19:18:01'),
 (2811,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:00:54'),
 (2812,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:03:46'),
 (2813,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:04:57'),
 (2814,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:11:11'),
 (2815,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:14:01'),
 (2816,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:18:46'),
 (2817,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:29:18'),
 (2818,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:33:40'),
 (2819,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:35:21'),
 (2820,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 20:37:16'),
 (2821,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:07:58'),
 (2822,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:08:43'),
 (2823,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:09:18'),
 (2824,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:11:15'),
 (2825,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:14:22'),
 (2826,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:26:50'),
 (2827,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:43:53'),
 (2828,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:49:15'),
 (2829,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 21:50:40'),
 (2830,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:10:15'),
 (2831,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:11:30'),
 (2832,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:13:28'),
 (2833,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:17:38'),
 (2834,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:24:02'),
 (2835,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:24:51'),
 (2836,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:28:07'),
 (2837,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:30:30'),
 (2838,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:31:59'),
 (2839,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:35:11'),
 (2840,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-09 22:37:42'),
 (2841,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 00:38:40'),
 (2842,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 00:40:20'),
 (2843,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:09:20'),
 (2844,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:12:11'),
 (2845,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:15:15'),
 (2846,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:18:00'),
 (2847,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:41:47'),
 (2848,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:42:30'),
 (2849,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:43:47'),
 (2850,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:45:58'),
 (2851,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:49:22'),
 (2852,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:54:59'),
 (2853,'192.168.1.127','drpareda','Registro Pedido','2015-02-10 19:55:26'),
 (2854,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 19:58:29'),
 (2855,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 20:03:12'),
 (2856,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 20:05:09'),
 (2857,'192.168.1.127','drpareda','Registro Pedido','2015-02-10 20:05:31'),
 (2858,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 20:15:47'),
 (2859,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 20:17:30'),
 (2860,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 20:21:17'),
 (2861,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 20:22:54'),
 (2862,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 20:39:12'),
 (2863,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 21:08:30'),
 (2864,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 21:09:26'),
 (2865,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 21:12:46'),
 (2866,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 21:13:42'),
 (2867,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 21:43:20'),
 (2868,'192.168.1.127','drpareda','Acceso al Sistema','2015-02-10 21:47:10');
/*!40000 ALTER TABLE `inv_log_transacciones` ENABLE KEYS */;


--
-- Definition of table `inv_pedido`
--

DROP TABLE IF EXISTS `inv_pedido`;
CREATE TABLE `inv_pedido` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo_cliente` int(10) unsigned NOT NULL,
  `nombre_paciente` varchar(500) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `nombre_medico` varchar(500) NOT NULL,
  `paquete` int(10) unsigned NOT NULL,
  `fecha_emision` datetime NOT NULL,
  `numero_items` int(10) unsigned DEFAULT NULL,
  `usuario_registra` int(10) unsigned DEFAULT NULL,
  `porcentaje_cliente` decimal(10,2) DEFAULT NULL,
  `subtotal` decimal(10,2) DEFAULT NULL,
  `impuestos` decimal(10,2) DEFAULT NULL,
  `total` decimal(10,2) DEFAULT NULL,
  `estado` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB AUTO_INCREMENT=37 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_pedido`
--

/*!40000 ALTER TABLE `inv_pedido` DISABLE KEYS */;
INSERT INTO `inv_pedido` (`codigo`,`codigo_cliente`,`nombre_paciente`,`nombre_medico`,`paquete`,`fecha_emision`,`numero_items`,`usuario_registra`,`porcentaje_cliente`,`subtotal`,`impuestos`,`total`,`estado`) VALUES 
 (1,2,0x6161,'aa',407,'2015-01-07 21:32:26',2,1,'0.50','179.76','21.57','201.33','REC'),
 (2,2,0x7072756562612073747269696E67,'prueba string',407,'2015-01-11 22:03:15',2,1,'0.50','901.08','108.13','1009.21','REC'),
 (3,2,0x70727565626161,'pruebaa',407,'2015-01-11 22:17:48',3,1,NULL,NULL,NULL,NULL,'ING'),
 (4,2,0x61736466736164,'sadfsadfa',407,'2015-01-11 22:24:14',1,1,NULL,NULL,NULL,NULL,'ING'),
 (5,2,0x71717171,'qqq',407,'2015-01-11 22:25:18',1,1,'0.40','83.89','10.07','93.96','REC'),
 (6,2,0x646761647367,'asdgdga',407,'2015-01-12 19:51:29',1,1,NULL,NULL,NULL,NULL,'ING'),
 (7,2,0x6173646661,'asdfadsfa',407,'2015-01-12 19:59:08',1,1,NULL,NULL,NULL,NULL,'ING'),
 (8,2,0x617364666164,'adsfadf',407,'2015-01-12 19:59:49',5,1,NULL,NULL,NULL,NULL,'ING'),
 (9,2,0x717765717765,'qweqw',407,'2015-01-12 21:53:56',4,1,NULL,NULL,NULL,NULL,'ING'),
 (10,2,0x666666,'ff',407,'2015-01-12 22:01:42',1,1,NULL,NULL,NULL,NULL,'ING'),
 (11,2,0x6767,'gg',407,'2015-01-12 22:12:48',1,1,NULL,NULL,NULL,NULL,'ING'),
 (12,2,0x67746774,'gtgt',407,'2015-01-12 22:15:38',1,1,NULL,NULL,NULL,NULL,'ING'),
 (13,2,0x687468,'hth',407,'2015-01-12 22:17:07',1,1,NULL,NULL,NULL,NULL,'ING'),
 (14,2,0x736466,'sdfsd',407,'2015-01-12 22:23:01',1,1,NULL,NULL,NULL,NULL,'ING'),
 (15,2,0x646667,'dfgdf',407,'2015-01-12 22:47:20',1,1,NULL,NULL,NULL,NULL,'ING'),
 (16,2,0x7466,'ff',407,'2015-01-12 23:03:41',1,1,NULL,NULL,NULL,NULL,'ING'),
 (17,2,0x66677366,'sdfgfd',401,'2015-01-13 09:34:23',2,1,'0.00','59.92','7.19','67.11','REC'),
 (18,2,0x6767,'gg',407,'2015-01-13 22:56:53',1,1,NULL,NULL,NULL,NULL,'ING'),
 (19,2,0x73646667736466,'sdfgsdf',407,'2015-01-13 23:01:47',3,1,NULL,NULL,NULL,NULL,'ING'),
 (20,2,0x44616E69656C2050617265646573,'Paredes',401,'2015-02-02 23:52:54',2,1,NULL,NULL,NULL,NULL,'ING'),
 (21,2,0x44616E69656C2050617265646573,'Christian Calderon',407,'2015-02-05 21:13:17',2,1,NULL,NULL,NULL,NULL,'ING'),
 (22,2,0x50617265646573,'CCCC',407,'2015-02-05 21:31:28',3,1,NULL,NULL,NULL,NULL,'ING'),
 (23,2,0x616161,'aaaa',407,'2015-02-05 21:34:19',2,1,NULL,NULL,NULL,NULL,'ING'),
 (24,2,0x616161,'aaa',407,'2015-02-05 21:40:15',2,1,NULL,NULL,NULL,NULL,'ING'),
 (25,2,0x6767,'gg',407,'2015-02-05 21:43:16',1,1,NULL,NULL,NULL,NULL,'ING'),
 (26,2,0x71717171,'qqq',407,'2015-02-05 21:47:34',1,1,NULL,NULL,NULL,NULL,'ING'),
 (27,2,0x747474,'ttt',407,'2015-02-05 21:54:51',1,1,NULL,NULL,NULL,NULL,'ING'),
 (28,2,0x6767,'ggg',407,'2015-02-05 21:57:35',1,1,NULL,NULL,NULL,NULL,'ING'),
 (29,2,0x6767,'gg',407,'2015-02-05 22:04:14',1,1,NULL,NULL,NULL,NULL,'ING'),
 (30,2,0x44616E69656C2050617265646573,'Arcentales briga',407,'2015-02-05 22:05:58',16,1,NULL,NULL,NULL,NULL,'ING'),
 (31,2,0x646667646667,'sadfasdf',407,'2015-02-05 22:09:00',3,1,NULL,NULL,NULL,NULL,'ING'),
 (32,2,0x6466676667,'sdgsdfgsfd',407,'2015-02-05 22:10:51',1,1,NULL,NULL,NULL,NULL,'ING'),
 (33,2,0x646161,'dada',407,'2015-02-05 22:12:16',1,1,NULL,NULL,NULL,NULL,'ING'),
 (34,2,0x7364677364,'sgsdfg',407,'2015-02-05 23:15:03',1,1,NULL,NULL,NULL,NULL,'ING'),
 (35,2,0x64616E69656C2070617265646573,'christian calderon',407,'2015-02-10 19:55:26',2,1,NULL,NULL,NULL,NULL,'ING'),
 (36,2,0x707275656261,'prueba',407,'2015-02-10 20:05:31',2,1,NULL,NULL,NULL,NULL,'ING');
/*!40000 ALTER TABLE `inv_pedido` ENABLE KEYS */;


--
-- Definition of table `inv_perfil`
--

DROP TABLE IF EXISTS `inv_perfil`;
CREATE TABLE `inv_perfil` (
  `codigo` int(10) unsigned NOT NULL,
  `nombre_acceso` varchar(50) NOT NULL,
  `estado` varchar(50) NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_perfil`
--

/*!40000 ALTER TABLE `inv_perfil` DISABLE KEYS */;
INSERT INTO `inv_perfil` (`codigo`,`nombre_acceso`,`estado`) VALUES 
 (1,'ADMINISTRADOR','ACT'),
 (2,'VENTAS','ACT'),
 (3,'BODEGA','ACT');
/*!40000 ALTER TABLE `inv_perfil` ENABLE KEYS */;


--
-- Definition of table `inv_perfil_usuario`
--

DROP TABLE IF EXISTS `inv_perfil_usuario`;
CREATE TABLE `inv_perfil_usuario` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo_perfil` int(10) unsigned NOT NULL,
  `codigo_usuario` int(10) unsigned NOT NULL,
  `fecha_modificacion` datetime DEFAULT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_perfil_usuario` (`codigo_perfil`),
  CONSTRAINT `FK_inv_perfil_usuario` FOREIGN KEY (`codigo_perfil`) REFERENCES `inv_perfil` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_perfil_usuario`
--

/*!40000 ALTER TABLE `inv_perfil_usuario` DISABLE KEYS */;
INSERT INTO `inv_perfil_usuario` (`codigo`,`codigo_perfil`,`codigo_usuario`,`fecha_modificacion`) VALUES 
 (1,1,1,'2015-01-10 17:47:14');
/*!40000 ALTER TABLE `inv_perfil_usuario` ENABLE KEYS */;


--
-- Definition of table `inv_porcentaje_cliente`
--

DROP TABLE IF EXISTS `inv_porcentaje_cliente`;
CREATE TABLE `inv_porcentaje_cliente` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `porcentaje` decimal(10,2) NOT NULL,
  `codigo_lista` int(10) unsigned NOT NULL,
  `decimal_porcentaje` decimal(10,2) NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_porcentaje_cliente`
--

/*!40000 ALTER TABLE `inv_porcentaje_cliente` DISABLE KEYS */;
INSERT INTO `inv_porcentaje_cliente` (`codigo`,`porcentaje`,`codigo_lista`,`decimal_porcentaje`) VALUES 
 (1,'12.00',701,'0.12'),
 (2,'8.00',702,'0.12'),
 (3,'8.50',703,'0.12'),
 (4,'7.50',704,'0.12');
/*!40000 ALTER TABLE `inv_porcentaje_cliente` ENABLE KEYS */;


--
-- Definition of table `inv_recepcion_pedido`
--

DROP TABLE IF EXISTS `inv_recepcion_pedido`;
CREATE TABLE `inv_recepcion_pedido` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `codigo_pedido` int(10) unsigned NOT NULL,
  `codigo_producto` varchar(50) NOT NULL,
  `cantidad_utilizada` int(10) unsigned NOT NULL,
  `valor_grupal` decimal(10,2) NOT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_recepcion_pedido_1` (`codigo_pedido`),
  CONSTRAINT `FK_inv_recepcion_pedido_1` FOREIGN KEY (`codigo_pedido`) REFERENCES `inv_pedido` (`codigo`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_recepcion_pedido`
--

/*!40000 ALTER TABLE `inv_recepcion_pedido` DISABLE KEYS */;
INSERT INTO `inv_recepcion_pedido` (`codigo`,`codigo_pedido`,`codigo_producto`,`cantidad_utilizada`,`valor_grupal`) VALUES 
 (1,1,'501004002',2,'179.76'),
 (2,5,'501004000',1,'83.89'),
 (3,17,'501004001',1,'59.92'),
 (4,17,'501004004',0,'0.00'),
 (5,2,'108056',2,'901.08');
/*!40000 ALTER TABLE `inv_recepcion_pedido` ENABLE KEYS */;


--
-- Definition of table `inv_tipo_catalogo_producto`
--

DROP TABLE IF EXISTS `inv_tipo_catalogo_producto`;
CREATE TABLE `inv_tipo_catalogo_producto` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nombre_catalogo` varchar(100) NOT NULL,
  `fecha_alta` datetime NOT NULL,
  PRIMARY KEY (`codigo`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_tipo_catalogo_producto`
--

/*!40000 ALTER TABLE `inv_tipo_catalogo_producto` DISABLE KEYS */;
INSERT INTO `inv_tipo_catalogo_producto` (`codigo`,`nombre_catalogo`,`fecha_alta`) VALUES 
 (1,'PLACAS ESTANDAR(2.0)','2014-09-23 22:16:32'),
 (2,'MINI PLACAS(1.7)','2014-09-23 22:16:36'),
 (3,'MICRO PLACAS(1.2)','2014-09-23 22:16:40'),
 (4,'MICROSEGMENTOS','2014-09-23 22:16:44'),
 (5,'TORNILLOS(2.0 MM)','2014-09-23 22:16:50'),
 (6,'SEGMENTOS TRIDIMENSIONALES','2014-09-23 22:16:54'),
 (7,'BROCAS PARA(2.0)','2014-09-23 22:16:59'),
 (8,'TORNILLOS(1.7 MM)','2014-09-23 22:17:03'),
 (9,'MINISEGMENTOS 3-D(1.7)','2014-09-23 22:17:08'),
 (10,'BROCAS PARA(1.7 m)','2014-09-23 22:17:13'),
 (11,'MICRO TORNILLOS(1.2 MM)','2014-09-23 22:17:17'),
 (12,'BROCAS PARA(1.2 MM)','2014-09-23 22:17:22'),
 (13,'PLACAS RECONSTRUCCION MANDIBULAR(2.7)','2014-09-23 22:17:29'),
 (14,'PLACAS P/FRACTURA MANDIBULAR(2.4)','2014-09-23 22:17:35'),
 (15,'TORNILLOS DE TITANIO(2.3 MM)','2014-09-23 22:17:39'),
 (16,'TORNILLOS RECONST. MANDIB','2014-09-23 22:17:42'),
 (17,'MALLAS','2014-09-23 22:17:46'),
 (18,'VARIOS','2014-09-23 22:17:50'),
 (19,'PLACAS ORBITARIAS','2014-09-23 22:17:53');
/*!40000 ALTER TABLE `inv_tipo_catalogo_producto` ENABLE KEYS */;


--
-- Definition of table `inv_usuario`
--

DROP TABLE IF EXISTS `inv_usuario`;
CREATE TABLE `inv_usuario` (
  `codigo` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `usuario` varchar(50) NOT NULL,
  `clave` varchar(50) NOT NULL,
  `estado` varchar(50) NOT NULL,
  `fecha_alta` datetime NOT NULL,
  `fecha_modificacion` datetime DEFAULT NULL,
  `codigo_empleado` int(10) unsigned DEFAULT NULL,
  `inicio_listo` varchar(2) NOT NULL,
  PRIMARY KEY (`codigo`),
  KEY `FK_inv_usuario_1` (`codigo_empleado`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inv_usuario`
--

/*!40000 ALTER TABLE `inv_usuario` DISABLE KEYS */;
INSERT INTO `inv_usuario` (`codigo`,`usuario`,`clave`,`estado`,`fecha_alta`,`fecha_modificacion`,`codigo_empleado`,`inicio_listo`) VALUES 
 (1,'drpareda','1afbbdc87cce0857df74ba762623c14d','ACT','2014-09-16 19:39:22','2015-02-02 20:13:15',1,'SI');
/*!40000 ALTER TABLE `inv_usuario` ENABLE KEYS */;


--
-- Definition of procedure `PRO_ACTUALIZAR_CLIENTE`
--

DROP PROCEDURE IF EXISTS `PRO_ACTUALIZAR_CLIENTE`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_ACTUALIZAR_CLIENTE`(VcodigoCliente int,VtipoCliente int,VtipoHospital int,
VCliente varchar(200),VRucCliente varchar(30),VDireccionCliente varchar(300),VTelefonoCliente varchar(20))
BEGIN


IF EXISTS(select 1 from inv_cliente where codigo=VcodigoCliente)then

UPDATE inv_cliente
SET
tipo_cliente=VtipoCliente,
tipo_hospital=VtipoHospital,
fecha_modificacion=now(),
nombre_cliente=VCliente,
ruc_cliente=VRucCliente,
direccion_cliente=VDireccionCliente,
telefono_cliente=VTelefonoCliente
where codigo=VcodigoCliente;

SELECT 1;

else
select 0;
END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_ACTUALIZAR_EMPLEADO`
--

DROP PROCEDURE IF EXISTS `PRO_ACTUALIZAR_EMPLEADO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_ACTUALIZAR_EMPLEADO`(VCodigoEmpleado int,VNombreEmpleado varchar(100),VApellidoEmpleado varchar(100),VCedulaEmpleado varchar(10),VDireccionEmpleado varchar(600),VTelefonoEmpleado varchar(20))
BEGIN

IF EXISTS(select 1 from inv_empleado where codigo=VcodigoEmpleado)then

UPDATE inv_empleado
SET
NOMBRE_EMPLEADO=VNombreEmpleado,
APELLIDO_EMPLEADO=VApellidoEmpleado,
CEDULA_EMPLEADO=VCedulaEmpleado,
DIRECCION_EMPLEADO=VDireccionEmpleado,
TELEFONO_EMPLEADO=VTelefonoEmpleado,
fecha_modificacion=now()
where codigo=VcodigoEmpleado;


SELECT 1;

else
SELECT 0;
END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_ACTUALIZAR_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_ACTUALIZAR_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_ACTUALIZAR_USUARIO`(Vcodigo int,Vclave varchar(50),Vperfil int,VCodigoEmpleado int,Vestado varchar(50))
BEGIN



IF EXISTS(select 1 from inv_usuario where codigo=Vcodigo)then

UPDATE inv_usuario
SET
clave=Vclave,
estado=Vestado,
fecha_modificacion=now(),
codigo_empleado=VCodigoEmpleado
where codigo=Vcodigo;


UPDATE inv_perfil_usuario
set codigo_perfil=Vperfil,
fecha_modificacion=now()
where codigo_usuario=Vcodigo;

SELECT 1;

else
select 0;
END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_ASIGNA_PAQUETES_INVENTARIO`
--

DROP PROCEDURE IF EXISTS `PRO_ASIGNA_PAQUETES_INVENTARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_ASIGNA_PAQUETES_INVENTARIO`(VcodigoProducto varchar(50),VpaqueteProducto int)
BEGIN

DECLARE RESULTADO INT;

IF EXISTS(SELECT 1 FROM inv_catalogo_producto WHERE CODIGO=VcodigoProducto)THEN

SET RESULTADO=1;

  IF NOT EXISTS(SELECT 1 FROM inv_catalogo_paquetes WHERE CODIGO_PRODUCTO=VcodigoProducto AND CODIGO_PAQUETE=VpaqueteProducto)THEN

    INSERT INTO inv_catalogo_paquetes(CODIGO_PRODUCTO,CODIGO_PAQUETE)VALUES(
    VcodigoProducto,VpaqueteProducto);

    SET RESULTADO=0;

  ELSE

  SET RESULTADO=2;

  END IF;

  SELECT RESULTADO;

ELSE

  SELECT 1;

END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_BUSCAR_CLIENTE`
--

DROP PROCEDURE IF EXISTS `PRO_BUSCAR_CLIENTE`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_BUSCAR_CLIENTE`(Voperacion int, VcodigoCliente int,VRucCLiente varchar(30))
BEGIN


IF (Voperacion=0)THEN

SELECT
C.CODIGO,
C.TIPO_CLIENTE,
C.TIPO_HOSPITAL,
C.NOMBRE_CLIENTE,
C.RUC_CLIENTE,
C.DIRECCION_CLIENTE,
C.TELEFONO_CLIENTE
FROM INV_CLIENTE C
WHERE C.CODIGO=VcodigoCliente;



ELSEIF(Voperacion=1)THEN

SELECT
C.CODIGO,
C.TIPO_CLIENTE,
C.TIPO_HOSPITAL,
C.NOMBRE_CLIENTE,
C.RUC_CLIENTE,
C.DIRECCION_CLIENTE,
C.TELEFONO_CLIENTE
FROM INV_CLIENTE C
WHERE C.RUC_CLIENTE=VRucCLiente;


END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_BUSCAR_EMPLEADO`
--

DROP PROCEDURE IF EXISTS `PRO_BUSCAR_EMPLEADO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_BUSCAR_EMPLEADO`(Voperacion int,VCodigoEmpleado int,VCedulaEmpleado varchar(10))
BEGIN


IF (Voperacion=0)THEN

SELECT
CODIGO,
NOMBRE_EMPLEADO,
APELLIDO_EMPLEADO,
CEDULA_EMPLEADO,
DIRECCION_EMPLEADO,
TELEFONO_EMPLEADO
FROM inv_empleado
WHERE CODIGO=VCodigoEmpleado;

ELSEIF(Voperacion=1)THEN

SELECT
CODIGO,
NOMBRE_EMPLEADO,
APELLIDO_EMPLEADO,
CEDULA_EMPLEADO,
DIRECCION_EMPLEADO,
TELEFONO_EMPLEADO
FROM inv_empleado
WHERE CEDULA_EMPLEADO=VCedulaEmpleado;


END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_BUSCAR_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_BUSCAR_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_BUSCAR_USUARIO`(Voperacion int,Vusuario varchar(50),VcodigoUsuario int)
BEGIN

IF (Voperacion=0)THEN

SELECT
U.CODIGO,
U.USUARIO,
U.CLAVE,
PU.CODIGO_PERFIL,
U.CODIGO_EMPLEADO,
U.ESTADO
FROM INV_USUARIO U
JOIN INV_PERFIL_USUARIO  PU ON PU.CODIGO_USUARIO=U.CODIGO
WHERE U.CODIGO=VcodigoUsuario;

ELSEIF(Voperacion=1)THEN

SELECT
U.CODIGO,
U.USUARIO,
U.CLAVE,
PU.CODIGO_PERFIL,
U.CODIGO_EMPLEADO,
U.ESTADO
FROM INV_USUARIO U
JOIN INV_PERFIL_USUARIO  PU ON PU.CODIGO_USUARIO=U.CODIGO
WHERE U.USUARIO=Vusuario;

END IF;



END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CARGA_PAQUETE_PRODUCTOS`
--

DROP PROCEDURE IF EXISTS `PRO_CARGA_PAQUETE_PRODUCTOS`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CARGA_PAQUETE_PRODUCTOS`(VcodigoCaja int)
BEGIN




  SELECT
  CP.CODIGO,
  CP.DESCRIPCION,
  DP.NOMBRE_DETALLE TIPO_PRODUCTO,
  IP.CANTIDAD
  FROM inv_catalogo_producto CP
  JOIN inv_inventario_producto IP on CP.CODIGO=IP.CODIGO_PRODUCTO
  JOIN inv_detalle_catalogo_parametrizacion DP ON DP.CODIGO=CP.TIPO
  JOIN inv_catalogo_paquetes CAP ON CAP.CODIGO_PRODUCTO=CP.CODIGO
  WHERE CAP.CODIGO_PAQUETE=VcodigoCaja;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_CATALOGO_PARAMETRIZACION`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_CATALOGO_PARAMETRIZACION`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_CATALOGO_PARAMETRIZACION`(Vcodigo_catalogo int)
BEGIN


SELECT NOMBRE_DETALLE FROM inv_detalle_catalogo_parametrizacion
WHERE CODIGO_CATALOGO=Vcodigo_catalogo;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_CLIENTE`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_CLIENTE`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_CLIENTE`(Voperacion int)
BEGIN

IF(Voperacion=0)THEN

select nombre_cliente from inv_cliente;

ELSEIF(Voperacion=1)THEN

select codigo from inv_cliente;

ELSEIF(Voperacion=2)THEN

SELECT NOMBRE_DETALLE FROM inv_detalle_catalogo_parametrizacion WHERE CODIGO_CATALOGO=70;

ELSEIF(Voperacion=3)THEN

SELECT CODIGO FROM inv_detalle_catalogo_parametrizacion WHERE CODIGO_CATALOGO=70;

END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_EMPLEADOS_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_EMPLEADOS_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_EMPLEADOS_USUARIO`(Voperacion int)
BEGIN

IF(Voperacion=0)THEN

SELECT

CONCAT(NOMBRE_EMPLEADO,' ',APELLIDO_EMPLEADO) AS EMPLEADO
FROM
INV_EMPLEADO;

ELSEIF(Voperacion=1)THEN 
SELECT
CODIGO
FROM
INV_EMPLEADO;

END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_INVENTARIO`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_INVENTARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_INVENTARIO`(Voperacion int,VtipoProducto int,VparametrosBusqueda varchar(500))
BEGIN



IF(Voperacion=0)THEN


  SELECT
  CP.CODIGO,
  CP.DESCRIPCION
  FROM inv_catalogo_producto CP
  ORDER BY CP.TIPO;

ELSEIF(Voperacion=1)THEN


  IF(VtipoProducto=0)THEN

  SELECT
  CP.CODIGO,
  CP.DESCRIPCION
  FROM inv_catalogo_producto CP
  ORDER BY CP.TIPO;

  ELSE

  SELECT
  CP.CODIGO,
  CP.DESCRIPCION
  FROM inv_catalogo_producto CP
  WHERE CP.TIPO=VtipoProducto
  ORDER BY CP.TIPO;
  END IF;

ELSEIF(Voperacion=2)THEN

SET VparametrosBusqueda=CONCAT('%',VparametrosBusqueda,'%');

  SELECT
  CP.CODIGO,
  CP.DESCRIPCION
  FROM inv_catalogo_producto CP
  WHERE CP.CODIGO LIKE VparametrosBusqueda OR CP.DESCRIPCION LIKE VparametrosBusqueda
  ORDER BY CP.TIPO;


END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_INVENTARIO_EDIT`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_INVENTARIO_EDIT`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_INVENTARIO_EDIT`(Voperacion int,VTipoProducto int,VparametroBusqueda varchar(500))
BEGIN


SET VparametroBusqueda=CONCAT('%',VparametroBusqueda,'%');

IF(Voperacion=0)THEN


  IF(VTipoProducto=0)THEN


  SELECT
  CP.CODIGO,
  CP.DESCRIPCION,
  CP.TIPO,
  DP.NOMBRE_DETALLE TIPO_PRODUCTO,
  CP.TIPO_INVENTARIO,
  ID.NOMBRE_DETALLE,
  CP.VALOR_UNITARIO
  FROM inv_catalogo_producto CP
  JOIN inv_detalle_catalogo_parametrizacion DP ON DP.CODIGO=CP.TIPO
  JOIN inv_detalle_catalogo_parametrizacion ID ON ID.CODIGO=CP.TIPO_INVENTARIO
  ORDER BY CP.TIPO;

  ELSE

  SELECT
  CP.CODIGO,
  CP.DESCRIPCION,
  CP.TIPO,
  DP.NOMBRE_DETALLE TIPO_PRODUCTO,
  CP.TIPO_INVENTARIO,
  ID.NOMBRE_DETALLE,
  CP.VALOR_UNITARIO
  FROM inv_catalogo_producto CP
  JOIN inv_detalle_catalogo_parametrizacion DP ON DP.CODIGO=CP.TIPO
  JOIN inv_detalle_catalogo_parametrizacion ID ON ID.CODIGO=CP.TIPO_INVENTARIO
  WHERE CP.TIPO=VTipoProducto
  ORDER BY CP.TIPO;

  END IF;

ELSEIF(Voperacion=1)THEN

  SELECT
  CP.CODIGO,
  CP.DESCRIPCION,
  CP.TIPO,
  DP.NOMBRE_DETALLE TIPO_PRODUCTO,
  CP.TIPO_INVENTARIO,
  ID.NOMBRE_DETALLE,
  CP.VALOR_UNITARIO
  FROM inv_catalogo_producto CP
  JOIN inv_detalle_catalogo_parametrizacion DP ON DP.CODIGO=CP.TIPO
  JOIN inv_detalle_catalogo_parametrizacion ID ON ID.CODIGO=CP.TIPO_INVENTARIO
  WHERE CP.CODIGO LIKE VparametroBusqueda or CP.DESCRIPCION like VparametroBusqueda
  ORDER BY CP.TIPO;


END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_PAQUETES_INVENTARIO`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_PAQUETES_INVENTARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_PAQUETES_INVENTARIO`(Vcodigo_catalogo int)
BEGIN


SELECT CODIGO,NOMBRE_DETALLE FROM inv_detalle_catalogo_parametrizacion
WHERE CODIGO_CATALOGO=Vcodigo_catalogo;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_PEDIDOS`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_PEDIDOS`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_PEDIDOS`(VOperacion int,VcodigoPedido int,VcodigoCliente int,VfechaEmison varchar(20))
BEGIN

declare fechaFormato varchar(11);

IF(VOperacion=0) THEN

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.NOMBRE_MEDICO MEDICO
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
WHERE P.ESTADO='ING';


ELSEIF(VOperacion=1)THEN

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.NOMBRE_MEDICO MEDICO
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
WHERE P.CODIGO=VcodigoPedido AND P.ESTADO='ING';


ELSEIF(VOperacion=2)THEN

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.NOMBRE_MEDICO MEDICO
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
WHERE P.CODIGO_CLIENTE=VcodigoCliente AND P.ESTADO='ING';

ELSEIF(VOperacion=3)THEN




SET fechaFormato=CONCAT(VfechaEmison,'%');


SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.NOMBRE_MEDICO MEDICO
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
WHERE P.FECHA_EMISION  like fechaFormato AND P.ESTADO='ING';


ELSEIF(VOperacion=4)THEN


SELECT
DP.CODIGO_PRODUCTO CODIGOPRODUCTO,
DCP.NOMBRE_DETALLE,
CP.DESCRIPCION DESCRIPCION,
DP.CANTIDAD CANTIDAD,
CP.TIPO_INVENTARIO
FROM INV_PEDIDO P
JOIN inv_detalle_pedido DP ON DP.CODIGO_PEDIDO=P.CODIGO
JOIN inv_catalogo_producto CP ON CP.CODIGO=DP.CODIGO_PRODUCTO
JOIN inv_detalle_catalogo_parametrizacion DCP ON DCP.codigo=DP.CODIGO_TIPO_PRODUCTO
WHERE P.CODIGO=VcodigoPedido AND P.ESTADO='ING'
order by DCP.NOMBRE_DETALLE desc;




END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_PERFIL`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_PERFIL`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_PERFIL`()
BEGIN
select
nombre_acceso
from inv_perfil
where estado='ACT';
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_PRODUCTOS`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_PRODUCTOS`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_PRODUCTOS`(Voperacion int,VTipoProducto int,VCodigoProducto varchar(500))
BEGIN



SET VCodigoProducto=CONCAT('%',VCodigoProducto,'%');


IF(Voperacion=0)THEN


  IF(VTipoProducto=0)THEN


  SELECT
  CP.CODIGO,
  CP.DESCRIPCION,
  DP.NOMBRE_DETALLE TIPO_PRODUCTO,
  IP.CANTIDAD,
  PD.NOMBRE_DETALLE,
  ID.NOMBRE_DETALLE
  FROM inv_catalogo_producto CP
  JOIN inv_inventario_producto IP on CP.CODIGO=IP.CODIGO_PRODUCTO
  JOIN inv_detalle_catalogo_parametrizacion DP ON DP.CODIGO=CP.TIPO
  JOIN inv_detalle_catalogo_parametrizacion ID ON ID.CODIGO=CP.TIPO_INVENTARIO
  JOIN inv_detalle_catalogo_parametrizacion PD ON PD.CODIGO=IP.ESTADO;

  ELSE

  SELECT
  CP.CODIGO,
  CP.DESCRIPCION,
  DP.NOMBRE_DETALLE TIPO_PRODUCTO,
  IP.CANTIDAD,
  PD.NOMBRE_DETALLE,
  ID.NOMBRE_DETALLE
  FROM inv_catalogo_producto CP
  JOIN inv_inventario_producto IP on CP.CODIGO=IP.CODIGO_PRODUCTO
  JOIN inv_detalle_catalogo_parametrizacion DP ON DP.CODIGO=CP.TIPO
  JOIN inv_detalle_catalogo_parametrizacion ID ON ID.CODIGO=CP.TIPO_INVENTARIO
  JOIN inv_detalle_catalogo_parametrizacion PD ON PD.CODIGO=IP.ESTADO
  WHERE CP.TIPO=VTipoProducto;

  END IF;


ELSEIF(Voperacion=1)THEN


  SELECT
  CP.CODIGO,
  CP.DESCRIPCION,
  DP.NOMBRE_DETALLE TIPO_PRODUCTO,
  IP.CANTIDAD,
  PD.NOMBRE_DETALLE,
  ID.NOMBRE_DETALLE
  FROM inv_catalogo_producto CP
  JOIN inv_inventario_producto IP on CP.CODIGO=IP.CODIGO_PRODUCTO
  JOIN inv_detalle_catalogo_parametrizacion DP ON DP.CODIGO=CP.TIPO
  JOIN inv_detalle_catalogo_parametrizacion ID ON ID.CODIGO=CP.TIPO_INVENTARIO
  JOIN inv_detalle_catalogo_parametrizacion PD ON PD.CODIGO=IP.ESTADO
  WHERE CP.CODIGO LIKE VCodigoProducto or CP.DESCRIPCION like VCodigoProducto;


END IF;



END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_CONSULTA_TIPO_CLIENTE`
--

DROP PROCEDURE IF EXISTS `PRO_CONSULTA_TIPO_CLIENTE`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_CONSULTA_TIPO_CLIENTE`(Vcodigo_catalogo int)
BEGIN


SELECT NOMBRE_DETALLE FROM inv_detalle_catalogo_parametrizacion
WHERE CODIGO_CATALOGO=Vcodigo_catalogo;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_EDITA_INVENTARIO`
--

DROP PROCEDURE IF EXISTS `PRO_EDITA_INVENTARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_EDITA_INVENTARIO`(
VcodigoProductoA VARCHAR(50),
VcodigoProductoN VARCHAR(50),
Vdescripcion varchar(1000) ,
VclaseProducto int,
VtipoProducto int,
VvalorUnitario float
)
BEGIN

DECLARE VvalorIvaN float;

  IF EXISTS(SELECT 1 FROM inv_catalogo_producto WHERE CODIGO=VcodigoProductoA)THEN

    SET VvalorIvaN=((VvalorUnitario*0.12)+VvalorUnitario);

    UPDATE inv_catalogo_producto
    SET CODIGO=VcodigoProductoN,TIPO=VclaseProducto,DESCRIPCION=Vdescripcion,
        TIPO_INVENTARIO=VtipoProducto,VALOR_UNITARIO=VvalorUnitario,VALOR_CON_IVA=VvalorIvaN
    WHERE CODIGO=VcodigoProductoA;


    UPDATE inv_inventario_producto
    SET CODIGO_PRODUCTO=VcodigoProductoN
    WHERE CODIGO_PRODUCTO=VcodigoProductoA;

    UPDATE inv_inventario_proceso
    SET CODIGO_PRODUCTO=VcodigoProductoN,TIPO_INVENTARIO=VtipoProducto
    WHERE CODIGO_PRODUCTO=VcodigoProductoA;


    UPDATE inv_catalogo_paquetes
    SET CODIGO_PRODUCTO=VcodigoProductoN
    WHERE CODIGO_PRODUCTO=VcodigoProductoA;

    UPDATE inv_detalle_pedido
    SET CODIGO_PRODUCTO=VcodigoProductoN,CODIGO_TIPO_PRODUCTO=VclaseProducto
    WHERE CODIGO_PRODUCTO=VcodigoProductoA;

    UPDATE inv_recepcion_pedido
    SET CODIGO_PRODUCTO=VcodigoProductoN
    WHERE CODIGO_PRODUCTO=VcodigoProductoA;

    SELECT 0;

  ELSE

    SELECT 1;

  END IF;



END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_ELIMINAR_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_ELIMINAR_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_ELIMINAR_USUARIO`(Vcodigo int,Voperacion int)
BEGIN


DECLARE VcodigoUsuario int;


IF(Voperacion=1)then

  IF EXISTS(select 1 from inv_usuario where codigo=Vcodigo)then


  DELETE FROM inv_usuario
  WHERE CODIGO=Vcodigo;


  DELETE FROM inv_perfil_usuario
  WHERE CODIGO_USUARIO=Vcodigo;


  SELECT 1;

  else

  SELECT 0;

  END IF;

ELSEIF(Voperacion=2)then

  IF EXISTS(select 1 from inv_cliente where codigo=Vcodigo)then


  DELETE FROM inv_cliente
  WHERE CODIGO=Vcodigo;

  SELECT 1;

  else
  SELECT 0;
  END IF;


ELSEIF(Voperacion=3)then

  IF EXISTS(select 1 from inv_empleado where codigo=Vcodigo)then



    IF EXISTS(select 1 from inv_usuario where codigo_empleado=Vcodigo)then

      set VcodigoUsuario=(select codigo from inv_usuario where codigo_empleado=Vcodigo);

      UPDATE inv_usuario
      SET CODIGO_EMPLEADO=NULL, ESTADO='DES'
      WHERE CODIGO=VcodigoUsuario;

    END IF;

  DELETE FROM inv_empleado
  WHERE CODIGO=Vcodigo;

  SELECT 1;

  else
  SELECT 0;
  END IF;

END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_GENERA_NOTA_ENTREGA`
--

DROP PROCEDURE IF EXISTS `PRO_GENERA_NOTA_ENTREGA`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_GENERA_NOTA_ENTREGA`(VcodigoPedido int)
BEGIN


DECLARE VfechaPedido DATETIME;
DECLARE Vusuario varchar(100);
DECLARE Vfecha VARCHAR(100);
DECLARE Vdetalle VARCHAR(500);

SET lc_time_names = 'es_UY';

SET Vusuario=(SELECT U.USUARIO FROM inv_pedido P
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA WHERE P.CODIGO=VcodigoPedido);

SET VfechaPedido=(SELECT FECHA_EMISION FROM INV_PEDIDO WHERE CODIGO=VcodigoPedido);

SET Vfecha=(SELECT CONCAT(
DATE_FORMAT(VfechaPedido, '%d de '),
CONCAT(UCASE(SUBSTRING(MONTHNAME(VfechaPedido), 1, 1)),LCASE(SUBSTRING(MONTHNAME(VfechaPedido), 2))),
DATE_FORMAT(VfechaPedido, ' del %Y')
));

SET Vdetalle=(SELECT DETALLE FROM inv_catalogo_detalle_paquete
WHERE CODIGO=(SELECT PAQUETE FROM inv_pedido WHERE CODIGO=VcodigoPedido));


SELECT
P.CODIGO NUMPEDIDO,
YEAR(NOW()) ANIO,
'Quito' CUIDAD,
Vfecha FECHA,
Vdetalle DETALLE,
Vusuario USUARIO,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.NOMBRE_MEDICO MEDICO
FROM INV_PEDIDO P
JOIN inv_cliente C ON C.CODIGO=P.CODIGO_CLIENTE
WHERE P.CODIGO=VcodigoPedido;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_GENERA_REPORTES`
--

DROP PROCEDURE IF EXISTS `PRO_GENERA_REPORTES`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_GENERA_REPORTES`(
Voperacion int,
Vcliente int,
VfechaInicio varchar(20),
VfechaFin varchar(20),
VestadoPedido varchar(10))
BEGIN


declare fechaFormato varchar(11);

IF(VOperacion=0) THEN/*todos los pedidos*/


SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.ESTADO,
U.USUARIO,
IFNULL(P.TOTAL,'') TOTAL
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA;

ELSEIF(VOperacion=1)THEN/*todos los pedidos por cliente*/


SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.ESTADO,
U.USUARIO,
IFNULL(P.TOTAL,'') TOTAL
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA
WHERE P.CODIGO_CLIENTE=Vcliente;

ELSEIF(VOperacion=2)THEN /*todos los pedidos de una fecha en especifco*/

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.ESTADO,
U.USUARIO,
IFNULL(P.TOTAL,'') TOTAL
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA
WHERE DATE_FORMAT(FECHA_EMISION,'%Y-%m-%d')=VfechaInicio;


ELSEIF(VOperacion=3)THEN

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.ESTADO,
U.USUARIO,
IFNULL(P.TOTAL,'') TOTAL
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA
WHERE DATE_FORMAT(FECHA_EMISION,'%Y-%m-%d') BETWEEN VfechaInicio AND VfechaFin;

ELSEIF(VOperacion=4)THEN

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.ESTADO,
U.USUARIO,
IFNULL(P.TOTAL,'') TOTAL
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA
WHERE DATE_FORMAT(FECHA_EMISION,'%Y-%m-%d') BETWEEN VfechaInicio AND VfechaFin
AND P.CODIGO_CLIENTE=Vcliente;



ELSEIF(VOperacion=5)THEN

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.ESTADO,
U.USUARIO,
IFNULL(P.TOTAL,'') TOTAL
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA
WHERE P.ESTADO=VestadoPedido;

ELSEIF(VOperacion=6)THEN

SELECT
P.CODIGO,
P.FECHA_EMISION,
C.NOMBRE_CLIENTE HOSPITAL,
P.NOMBRE_PACIENTE PACIENTE,
P.ESTADO,
U.USUARIO,
IFNULL(P.TOTAL,'') TOTAL
FROM INV_PEDIDO P
JOIN INV_CLIENTE C ON C.CODIGO=P.CODIGO_CLIENTE
JOIN INV_USUARIO U ON U.CODIGO=P.USUARIO_REGISTRA
WHERE P.ESTADO=VestadoPedido
AND P.CODIGO_CLIENTE=Vcliente;

END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_GENERA_REPORTE_AUDITORIA`
--

DROP PROCEDURE IF EXISTS `PRO_GENERA_REPORTE_AUDITORIA`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_GENERA_REPORTE_AUDITORIA`(Voperacion int,VfechaInicio varchar(20),VfechaFin varchar(20))
BEGIN

declare fechaFormato varchar(11);

IF(VOperacion=0) THEN/*TRANSACCIONES*/

SELECT
LT.IP,
IFNULL(LT.USUARIO,'') USUARIO,
CONCAT(IFNULL(E.NOMBRE_EMPLEADO,''),' ',IFNULL(E.APELLIDO_EMPLEADO,'')) EMPLEADO,
LT.ACCION TRANSACCION,
LT.FECHA
FROM inv_log_transacciones LT
JOIN INV_USUARIO U ON U.USUARIO=LT.USUARIO
JOIN INV_EMPLEADO E ON E.CODIGO=U.CODIGO_EMPLEADO
WHERE DATE_FORMAT(LT.FECHA,'%Y-%m-%d') BETWEEN VfechaInicio AND VfechaFin;


ELSEIF(VOperacion=1)THEN/*ERRORES*/

SELECT
LE.IP,
IFNULL(LE.USUARIO,'') USUARIO,
CONCAT(IFNULL(E.NOMBRE_EMPLEADO,''),' ',IFNULL(E.APELLIDO_EMPLEADO,'')) EMPLEADO,
LE.ERROR TRANSACCION,
LE.FECHA
FROM inv_log_errores LE
JOIN INV_USUARIO U ON U.USUARIO=LE.USUARIO
JOIN INV_EMPLEADO E ON E.CODIGO=U.CODIGO_EMPLEADO
WHERE DATE_FORMAT(LE.FECHA,'%Y-%m-%d') BETWEEN VfechaInicio AND VfechaFin;

END IF;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_GENERA_REPORTE_INVENTARIO`
--

DROP PROCEDURE IF EXISTS `PRO_GENERA_REPORTE_INVENTARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_GENERA_REPORTE_INVENTARIO`(Voperacion int,VestadoInventario int,VfechaInicio varchar(20),VfechaFin varchar(20))
BEGIN

declare fechaFormato varchar(11);

IF(VOperacion=0) THEN/*todo el iventario*/

SELECT
I.CODIGO_PRODUCTO,
I.CANTIDAD,
DCP.NOMBRE_DETALLE ESTADO,
I.FECHA_ULTIMO_INGRESO FECHA_INGRESO
FROM inv_inventario_producto I
JOIN inv_detalle_catalogo_parametrizacion DCP ON DCP.CODIGO=I.ESTADO;


ELSEIF(VOperacion=1)THEN/*por estado*/


SELECT
I.CODIGO_PRODUCTO,
I.CANTIDAD,
DCP.NOMBRE_DETALLE ESTADO,
I.FECHA_ULTIMO_INGRESO FECHA_INGRESO
FROM inv_inventario_producto I
JOIN inv_detalle_catalogo_parametrizacion DCP ON DCP.CODIGO=I.ESTADO
WHERE I.ESTADO=VestadoInventario;


ELSEIF(VOperacion=2)THEN/*por fecha inicio*/

SELECT
I.CODIGO_PRODUCTO,
I.CANTIDAD,
DCP.NOMBRE_DETALLE ESTADO,
I.FECHA_ULTIMO_INGRESO FECHA_INGRESO
FROM inv_inventario_producto I
JOIN inv_detalle_catalogo_parametrizacion DCP ON DCP.CODIGO=I.ESTADO
WHERE DATE_FORMAT(I.FECHA_ULTIMO_INGRESO,'%Y-%m-%d')=VfechaInicio;


ELSEIF(VOperacion=3)THEN/*etre fecha y fecha*/

SELECT
I.CODIGO_PRODUCTO,
I.CANTIDAD,
DCP.NOMBRE_DETALLE ESTADO,
I.FECHA_ULTIMO_INGRESO FECHA_INGRESO
FROM inv_inventario_producto I
JOIN inv_detalle_catalogo_parametrizacion DCP ON DCP.CODIGO=I.ESTADO
WHERE DATE_FORMAT(I.FECHA_ULTIMO_INGRESO,'%Y-%m-%d') BETWEEN VfechaInicio AND VfechaFin;

ELSEIF(VOperacion=4)THEN/*entre fecha y fecha y estado*/

SELECT
I.CODIGO_PRODUCTO,
I.CANTIDAD,
DCP.NOMBRE_DETALLE ESTADO,
I.FECHA_ULTIMO_INGRESO FECHA_INGRESO
FROM inv_inventario_producto I
JOIN inv_detalle_catalogo_parametrizacion DCP ON DCP.CODIGO=I.ESTADO
WHERE DATE_FORMAT(I.FECHA_ULTIMO_INGRESO,'%Y-%m-%d') BETWEEN VfechaInicio AND VfechaFin
AND I.ESTADO=VestadoInventario;

END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_INSERTA_LOG_ERROR`
--

DROP PROCEDURE IF EXISTS `PRO_INSERTA_LOG_ERROR`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_INSERTA_LOG_ERROR`(Vip varchar(50),Vusuario varchar(50),Verror varchar(1000))
BEGIN


INSERT INTO inv_log_errores(ip,usuario,error,fecha)
VALUES(Vip,Vusuario,Verror,now());


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_INSERTA_LOG_TRANSACCIONES`
--

DROP PROCEDURE IF EXISTS `PRO_INSERTA_LOG_TRANSACCIONES`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_INSERTA_LOG_TRANSACCIONES`(Vip varchar(50),Vusuario varchar(50),Vaccion varchar(50))
BEGIN

INSERT INTO inv_log_transacciones(ip,usuario,accion,fecha)
VALUES(Vip,Vusuario,Vaccion,now());

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_REGISTRA_CLIENTE`
--

DROP PROCEDURE IF EXISTS `PRO_REGISTRA_CLIENTE`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_REGISTRA_CLIENTE`(VTipoCliente int,VtipoHospital int,
VCliente varchar(200),VRucCliente varchar(30),VDireccionCliente varchar(300),VTelefonoCliente varchar(20))
BEGIN


DECLARE Vcodigo_cliente int;

IF NOT EXISTS(select 1 from inv_cliente where nombre_cliente=VCliente or ruc_cliente=VRucCliente)then


insert into inv_cliente(tipo_cliente,tipo_hospital,nombre_cliente,fecha_alta,ruc_cliente,direccion_cliente,telefono_cliente)
values(VTipoCliente,VtipoHospital,VCliente,now(),VRucCliente,VDireccionCliente,VTelefonoCliente);

set Vcodigo_cliente=(select codigo from inv_cliente where nombre_cliente=VCliente or ruc_cliente=VRucCliente);


select Vcodigo_cliente;

else
select 0;
END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_REGISTRA_EMPLEADO`
--

DROP PROCEDURE IF EXISTS `PRO_REGISTRA_EMPLEADO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_REGISTRA_EMPLEADO`(VnombreEmpleado varchar(100),VapellidoEmpleado varchar(100),VcedulaEmpleado varchar(10),VdireccionEmpleado varchar(600),VtelefonoEmpleado varchar(20))
BEGIN

DECLARE VcodigoEmpleado int;

IF NOT EXISTS(select 1 from inv_empleado where cedula_empleado=VcedulaEmpleado)then

INSERT INTO inv_empleado(NOMBRE_EMPLEADO,APELLIDO_EMPLEADO,CEDULA_EMPLEADO,DIRECCION_EMPLEADO,TELEFONO_EMPLEADO,FECHA_REGISTRO)
VALUES (VnombreEmpleado,VapellidoEmpleado,VcedulaEmpleado,VdireccionEmpleado,VtelefonoEmpleado,now());


SET VcodigoEmpleado=(select codigo from inv_empleado where cedula_empleado=VcedulaEmpleado);

SELECT VcodigoEmpleado;

else
select 0;
END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_REGISTRA_INVENTARIO`
--

DROP PROCEDURE IF EXISTS `PRO_REGISTRA_INVENTARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_REGISTRA_INVENTARIO`(
Voperacion int,
VcodigoProducto VARCHAR(50),
Vdescripcion varchar(1000) ,
Vmarca varchar(100) ,
Vvalor decimal(10,2) ,
VtipoProducto int,
Vcantidad int
)
BEGIN

DECLARE RESULTADO INT;
DECLARE Vvalor_con_iva DECIMAL(10,2);
DECLARE VTipo_inventario INT;

IF(Voperacion=0)THEN 


SET RESULTADO=1;

  IF NOT EXISTS(SELECT 1 FROM inv_catalogo_producto WHERE CODIGO=VcodigoProducto)THEN

    IF(VtipoProducto=320)THEN
      SET VTipo_inventario=(602);
    ELSE
      SET VTipo_inventario=(601);
    END IF;

    SET Vvalor_con_iva=(Vvalor+(Vvalor*0.12));

    INSERT INTO inv_catalogo_producto VALUES(
    VcodigoProducto,VtipoProducto,Vdescripcion,Vvalor,Vvalor_con_iva,Vmarca,0,VTipo_inventario);

    SET RESULTADO=0;

  ELSE

    SET RESULTADO=2;

  END IF;

SELECT RESULTADO;

ELSEIF(Voperacion=1)THEN


SET RESULTADO=1;

  IF EXISTS(SELECT 1 FROM inv_catalogo_producto WHERE CODIGO=VcodigoProducto)THEN

    IF EXISTS(SELECT 1 FROM inv_inventario_producto WHERE CODIGO_PRODUCTO=VcodigoProducto)THEN

      UPDATE inv_inventario_producto
      SET CANTIDAD=CANTIDAD+Vcantidad
      WHERE CODIGO_PRODUCTO=VcodigoProducto;

    ELSE

      INSERT INTO inv_inventario_producto(CODIGO_PRODUCTO,CANTIDAD,ESTADO,FECHA_ULTIMO_INGRESO)
      VALUES(VcodigoProducto,Vcantidad,501,NOW());

    END IF;

    SET RESULTADO=0;

  ELSE

    SET RESULTADO=1;

  END IF;


SELECT RESULTADO;

END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_REGISTRA_PEDIDO`
--

DROP PROCEDURE IF EXISTS `PRO_REGISTRA_PEDIDO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_REGISTRA_PEDIDO`(
VflagActualizacion int,
Voperacion int,
VcodigoCliente int,
Vpaciente varchar(500),
Vmedico varchar(500),
VcodigoPaquete int,

VcodigoPedido int,
VcodigoProducto VARCHAR(50),
Vcantidad int,
VnumeroItems int,
VusuarioRegistra varchar(50)
)
BEGIN

DECLARE VcantidadDisponible int;
DECLARE VestadoNoDisponible int;
DECLARE VcodigoTipoProducto int;
DECLARE VcodigoTipoInventario int;
DECLARE VcodigoUsuarioRegistra int;


SET VestadoNoDisponible=502;

IF(Voperacion=1)THEN

SET VcodigoUsuarioRegistra=(SELECT CODIGO FROM INV_USUARIO WHERE USUARIO=VusuarioRegistra);

INSERT INTO inv_pedido(codigo_cliente,nombre_paciente,nombre_medico,paquete,fecha_emision,usuario_registra,ESTADO)
VALUES(VcodigoCliente,Vpaciente,Vmedico,VcodigoPaquete,now(),VcodigoUsuarioRegistra,'ING');

set VcodigoPedido=(select codigo from inv_pedido
where codigo_cliente=VcodigoCliente
and nombre_paciente=Vpaciente
and nombre_medico=Vmedico
and paquete=VCodigoPaquete
ORDER BY fecha_emision desc LIMIT 1);

select VcodigoPedido;

ELSEIF(Voperacion=2)THEN

SET VcodigoTipoProducto=(SELECT TIPO FROM inv_catalogo_producto WHERE CODIGO=VcodigoProducto);
SET VcodigoTipoInventario=(SELECT TIPO_INVENTARIO FROM inv_catalogo_producto WHERE CODIGO=VcodigoProducto);



INSERT INTO inv_detalle_pedido(CODIGO_PEDIDO,CODIGO_TIPO_PRODUCTO,CODIGO_PRODUCTO,CODIGO_PAQUETE,CANTIDAD,TIPO_INVENTARIO)
VALUES(VcodigoPedido,VcodigoTipoProducto,VcodigoProducto,VcodigoPaquete,Vcantidad,VcodigoTipoInventario);

INSERT INTO inv_inventario_proceso(CODIGO_PEDIDO,CODIGO_PRODUCTO,CANTIDAD,ESTADO,FECHA_EMISION,TIPO_INVENTARIO)
VALUES(VcodigoPedido,VcodigoProducto,Vcantidad,503,NOW(),VcodigoTipoInventario);

UPDATE inv_inventario_producto
SET CANTIDAD=CANTIDAD-Vcantidad
WHERE CODIGO_PRODUCTO=VcodigoProducto;


SET VcantidadDisponible=(SELECT CANTIDAD FROM inv_inventario_producto WHERE CODIGO_PRODUCTO=VcodigoProducto);

  IF(VcantidadDisponible=0)THEN

  UPDATE inv_inventario_producto
  SET ESTADO=VestadoNoDisponible
  WHERE CODIGO_PRODUCTO=VcodigoProducto;

  END IF;


  IF(VflagActualizacion=2)THEN
  UPDATE inv_pedido
  SET numero_items=VnumeroItems
  WHERE codigo=VcodigoPedido;
  END IF;

SELECT 0;

END IF;



END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_REGISTRA_RECEPCION_PEDIDO`
--

DROP PROCEDURE IF EXISTS `PRO_REGISTRA_RECEPCION_PEDIDO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_REGISTRA_RECEPCION_PEDIDO`(
Voperacion int,
VcodigoPedido int,
VcodigoProducto VARCHAR(50),
VcantidadRecepcion int,
VcodigoPorcentaje decimal(10,2)
)
BEGIN




DECLARE VcantidadEnviada int;
DECLARE VcantidadUtilizada int;
DECLARE VcantidadNula int;
DECLARE VvalorUnitario decimal(10,2);
DECLARE VvalorGrupal decimal(10,2);
DECLARE Vsubtotal decimal(10,2);
DECLARE Vimpuestos decimal(10,2);
DECLARE Vtotal decimal(10,2);
DECLARE Vcantidad0 int;



IF(Voperacion=1)THEN
SET AUTOCOMMIT=0;
START TRANSACTION;

SET VcantidadEnviada=(SELECT CANTIDAD FROM INV_INVENTARIO_PROCESO WHERE CODIGO_PRODUCTO=VcodigoProducto AND CODIGO_PEDIDO=VcodigoPedido);
SET VcantidadUtilizada=VcantidadEnviada-VcantidadRecepcion;

UPDATE inv_inventario_proceso
SET CANTIDAD=CANTIDAD-VcantidadUtilizada-VcantidadRecepcion
WHERE CODIGO_PRODUCTO=VcodigoProducto AND CODIGO_PEDIDO=VcodigoPedido;


SET VcantidadNula=(SELECT CANTIDAD FROM INV_INVENTARIO_PROCESO WHERE CODIGO_PRODUCTO=VcodigoProducto AND CODIGO_PEDIDO=VcodigoPedido);

if(VcantidadNula=0)THEN

DELETE FROM INV_INVENTARIO_PROCESO
WHERE CODIGO_PRODUCTO=VcodigoProducto AND CODIGO_PEDIDO=VcodigoPedido AND CANTIDAD=0;

UPDATE inv_inventario_producto
SET CANTIDAD=CANTIDAD+VcantidadRecepcion
WHERE CODIGO_PRODUCTO=VcodigoProducto;

SET VvalorUnitario=(SELECT VALOR_UNITARIO FROM INV_CATALOGO_PRODUCTO WHERE CODIGO=VcodigoProducto);

SET VvalorUnitario=((VvalorUnitario*VcodigoPorcentaje)+VvalorUnitario);

SET VvalorGrupal=(VcantidadUtilizada*VvalorUnitario);

INSERT INTO INV_RECEPCION_PEDIDO(CODIGO_PEDIDO,CODIGO_PRODUCTO,CANTIDAD_UTILIZADA,VALOR_GRUPAL)
VALUES(VcodigoPedido,VcodigoProducto,VcantidadUtilizada,VvalorGrupal);


UPDATE inv_detalle_pedido
SET VALOR_GRUPAL=VvalorGrupal
WHERE CODIGO_PEDIDO=VcodigoPedido;

UPDATE inv_inventario_producto
SET ESTADO=501
WHERE CANTIDAD>0 and codigo_producto=VcodigoProducto;

  commit;

  select 0;
else

  rollback;

  select 1;
end if;

ELSEIF(Voperacion=2)THEN
SET AUTOCOMMIT=0;
START TRANSACTION;
SET Vcantidad0=(select count(codigo_pedido) cantidad_detalles from inv_inventario_proceso where codigo_pedido=VcodigoPedido);

  IF(Vcantidad0=0)THEN

  SET Vsubtotal=(SELECT ROUND(SUM(VALOR_GRUPAL), 2) AS SUBTOTAL FROM INV_RECEPCION_PEDIDO WHERE CODIGO_PEDIDO=VcodigoPedido);

  SET vImpuestos=(Vsubtotal*0.12);

  SET Vtotal=(Vsubtotal+Vimpuestos);

  UPDATE INV_PEDIDO
  SET SUBTOTAL=Vsubtotal,TOTAL=Vtotal,IMPUESTOS=Vimpuestos,PORCENTAJE_CLIENTE=VcodigoPorcentaje,
  ESTADO='REC'
  WHERE CODIGO=VcodigoPedido;



  COMMIT;
 SELECT 3;
  ELSE

  ROLLBACK;
SELECT 4;
  END IF;

END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_REGISTRA_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_REGISTRA_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_REGISTRA_USUARIO`(Vusuario varchar(50),Vclave varchar(50),Vcodigo_perfil int, VCodigo_empleado int)
BEGIN


DECLARE Vcodigo_usuario int;

IF NOT EXISTS(select 1 from inv_usuario where usuario=Vusuario)then


insert into inv_usuario(usuario,clave,estado,codigo_empleado,fecha_alta,inicio_listo)
values(Vusuario,Vclave,'ACT',VCodigo_empleado,now(),'SI');

set Vcodigo_usuario=(select codigo from inv_usuario where usuario=Vusuario);


insert into inv_perfil_usuario(codigo_perfil,codigo_usuario)
values(Vcodigo_perfil,Vcodigo_usuario);

select Vcodigo_usuario;

else
select 0;
END IF;




END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_RESETEA_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_RESETEA_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_RESETEA_USUARIO`(Voperacion int,Vusuario varchar(50),Vclave varchar(50))
BEGIN


IF(Voperacion=0)THEN


  UPDATE inv_usuario
  SET INICIO_LISTO='NO',CLAVE=Vclave,FECHA_MODIFICACION=NOW()
  WHERE USUARIO=Vusuario;

  SELECT 0;

ELSEIF(Voperacion=1)THEN

  UPDATE inv_usuario
  SET INICIO_LISTO='SI',CLAVE=Vclave,FECHA_MODIFICACION=NOW()
  WHERE USUARIO=Vusuario;

  SELECT 0;

END IF;

END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_VALIDA_EMPLEADO_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_VALIDA_EMPLEADO_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_VALIDA_EMPLEADO_USUARIO`(Voperacion int,VcodigoEmpleado INT,VcodigoUsuario int)
BEGIN


IF(Voperacion=0)THEN

  IF NOT EXISTS(select 1 FROM INV_USUARIO WHERE CODIGO_EMPLEADO=VcodigoEmpleado)then

    SELECT 1;

  ELSE
    SELECT 0;
  END IF;

ELSE IF(Voperacion=1)THEN

  IF EXISTS(select 1 FROM INV_USUARIO WHERE CODIGO_EMPLEADO=VcodigoEmpleado AND CODIGO=VcodigoUsuario)THEN

    SELECT 1;

  ELSE

    IF EXISTS(select 1 FROM INV_USUARIO WHERE CODIGO_EMPLEADO=VcodigoEmpleado AND CODIGO NOT IN (VcodigoUsuario))then

      SELECT 0;

    ELSE
      SELECT 1;
    END IF;

END IF;


  END IF;

END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_VALIDA_PERFIL_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_VALIDA_PERFIL_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_VALIDA_PERFIL_USUARIO`(Vusuario varchar(50))
BEGIN
SELECT
P.NOMBRE_ACCESO
FROM
INV_PERFIL P
JOIN INV_PERFIL_USUARIO  PU ON PU.CODIGO_PERFIL=P.CODIGO
JOIN INV_USUARIO U ON U.CODIGO=PU.CODIGO_USUARIO
WHERE U.USUARIO=Vusuario;
END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;

--
-- Definition of procedure `PRO_VALIDA_USUARIO`
--

DROP PROCEDURE IF EXISTS `PRO_VALIDA_USUARIO`;

DELIMITER $$

/*!50003 SET @TEMP_SQL_MODE=@@SQL_MODE, SQL_MODE='STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `PRO_VALIDA_USUARIO`(Vusuario varchar(50),Vclave varchar(50))
BEGIN



IF EXISTS(select 1 from inv_usuario where usuario=Vusuario)then

SELECT ESTADO,INICIO_LISTO
FROM INV_USUARIO
WHERE USUARIO=Vusuario
AND CLAVE=Vclave;


else

SELECT 0;

END IF;


END $$
/*!50003 SET SESSION SQL_MODE=@TEMP_SQL_MODE */  $$

DELIMITER ;



/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
